<CsoundSynthesizer>
<CsOptions>
</CsOptions>

<CsInstruments>
sr = 44100
kr = 882
ksmps = 50
nchnls = 2

#define SURMULOTDIR #d:/devel/surmulot#

;|menu SoundFont
;|MaestroVelocity
#define SOUNDFONT #$SURMULOTDIR/soundfonts/Maestro_Velocity.sf2# 
#define PRESET #0#
;|NylonGuitar
; #define SOUNDFONT #$SURMULOTDIR/soundfonts/NylonGuitar1.SF2#
; #define PRESET #0#
;|Cister
; #define SOUNDFONT #$SURMULOTDIR/soundfonts/cister.sf2# 
; #define PRESET #127#
;|Psaltry
; #define SOUNDFONT #$SURMULOTDIR/soundfonts/Psaltry.sf2# 
; #define PRESET #0#
;|ProTrax
; #define SOUNDFONT #$SURMULOTDIR/soundfonts/ProTrax_Classical_Guitar.sf2# 
; #define PRESET #0#
;|endmenu

#ifndef VOLUME
#define VOLUME #70000#
#end

#ifndef BANK
#define BANK #0#
#end

#ifndef PRESET
#define PRESET #0#
#end

#ifndef SOUNDFONT
#define SOUNDFONT #$SURMULOTDIR/soundfonts/Maestro_Velocity.sf2# 
#end

giengine  fluidEngine
isfnum    fluidLoad "$SOUNDFONT", giengine
          fluidProgramSelect giengine, 1, isfnum, $BANK, $PRESET


instr 1
/*| 
((pitchField: 4)
 (pitchFormat: cps)
 (ampField: 5)
 (ampMin:max: (0 127))
 (iTemplate: "i 1 0 0.5 440 80 0 1"))
|*/
            ;; p4   base pitch (cps)
            ;; p5   velocity
            ;; p6   pitch bend envelope over p3 (in semitones)
            ;; p7   envelope multiplier

  imfloat   =  (17.31234049066757 * log(p4)) - 36.376316562296
  ikey      =  round(imfloat)
  ipbend    =  (imfloat - ikey) / 2

  ivel      init      p5

  kpbend    =  0
if p6=0 goto noEnvelope
  kndx      line      0, p3, 1
  ksemitones   table  kndx, p6, 1 
  kpbend    =  p7 * ksemitones / 200
noEnvelope:

  kfullbend =  round(8192 * (1 + ipbend + kpbend))
  kdata1    =  kfullbend & 127
  kdata2    =  kfullbend >> 7
	    fluidControl  giengine, 224, 1, kdata1, kdata2  
            fluidNote   giengine, 1, ikey, ivel
endin

instr 99/*|effect i 99 0 1|*/
  imvol     init      $VOLUME
  asigl, asigr fluidOut   giengine
            outs      asigl * imvol, asigr * imvol
endin
</CsInstruments>
<CsScore>

</CsScore>
</CsoundSynthesizer>
