;Written by Iain McCurdy, 2009

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	4410	;CONTROL RATE
ksmps 		= 	10	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;			LABEL  | WIDTH | HEIGHT | X | Y
		FLpanel	"clip",   500,    260,    0,  0

;SWITCHES  	                                  		ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | DUR
gkOnOff,ihOnOff			FLbutton	"On/Off",	1,   -1,    2,     150,     30,    0,  0,     0,     2,      0,       -1

;VALUE DISPLAY BOXES	LABEL | WIDTH | HEIGHT | X | Y
idlimit      	FLvalue	" ",	 70,      20,    0,  75
idarg		FLvalue	" ",	 70,      20,    0, 125
idpostgain	FLvalue	" ",	 70,      20,    0, 240

;            				LABEL                 			MIN   | MAX | EXP | TYPE |  DISP      | WIDTH | HEIGHT | X  | Y
gklimit, ihlimit	FLslider	"Limit",                 		0.0001,  1,   -1,   5,     idlimit,      500,    25,     0,  50
gkarg,iharg		FLslider	"Clipping Point (B.d.J Method only)",	0,       1,    0,   5,     idarg,        500,    25,     0, 100
gkpostgain,ihpostgain	FLslider	"Post Gain",        	 		1,    1000,   -1,   5,     idpostgain,   500,    25,     0, 215

;GENERAL_TEXT_SETTINGS			SIZE | FONT |  ALIGN | RED | GREEN | BLUE
			FLlabel		13,      4,      1,    190,   190,   190		;LABELS MADE INVISIBLE (I.E. SAME COLOR AS PANEL)

;BUTTON BANKS			 TYPE | NUMX | NUMY | WIDTH | HEIGHT | X | Y | OPCODE
gkmeth, ihmeth	FLbutBank	 13,     1,     3,      18,     60,   55, 150,   -1

;GENERAL_TEXT_SETTINGS			SIZE | FONT |  ALIGN | RED | GREEN | BLUE
			FLlabel		13,      4,      1,     0,     0,     0			;LABELS MADE VISIBLE AGAIN

;TEXT BOXES						TYPE | FONT | SIZE | WIDTH | HEIGHT | X |  Y
ih		 	FLbox  	"Method:",		1,       6,    12,    45,      25,     7, 147
ih		 	FLbox  	"Bram de Jong", 	1,       5,    12,    85,      25,    75, 147
ih		 	FLbox  	"Sine        ", 	1,       5,    12,    85,      25,    75, 167
ih		 	FLbox  	"Tanh        ", 	1,       5,    12,    85,      25,    75, 187

;SET INITIAL VALUES FOR SLIDERS |VALUE | HANDLE
		FLsetVal_i	1,       ihlimit
		FLsetVal_i	0.5,     iharg
		FLsetVal_i	0,       ihmeth
		FLsetVal_i	1,       ihpostgain

		FLpanel_end	;END OF PANEL CONTENTS

;INSTRUCTIONS AND INFO PANEL                 WIDTH | HEIGHT | X | Y
				FLpanel	" ", 500,     260,   512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                            clip                             ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"The 'clip' opcode provides audio signal soft clipping using  ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"one of three different methods.                              ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"'Limiting Value' defines the maximum amplitude that will be  ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"passed unclipped. In this example maximum amplitude has been ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"defined as '1' therefore, in this instance, this value ranges", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"up to 1.                                                     ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"'Clipping Point' defines the point at which clipping starts  ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"and is only ised in the Bram de Jong method.                 ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"A 'Post Gain' control is included so that the user can       ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"compensate for the loss of gain that occurs when the signal  ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"is clipped.                                                  ", 	1,      5,     14,    490,    15,     5, 240

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

0dbfs	=	1

instr	1	;(ALWAYS ON - SEE SCORE) PLAYS FILE AND SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS	
	gasig		diskin2		"808loopMono.wav", 1, 0, 1
	kSwitch		changed		gklimit, gkmeth, gkarg	;GENERATE A MOMENTARY '1' PULSE IN OUTPUT 'kSwitch' IF ANY OF THE SCANNED INPUT VARIABLES CHANGE. (OUTPUT 'kSwitch' IS NORMALLY ZERO)
	;				ITRIGGER | IMINTIM | IMAXNUM | IINSNUM | IWHEN | IDUR (-1 MEANS A NOTE OF INFINITE DURATION)
			schedkwhen	kSwitch,      0,        0,        2,        0,    -1	;RESTART INSTRUMENT 2 WITH A SUSTAINED (HELD) NOTE WHENEVER kSwitch=1
endin

		instr 2
if	gkOnOff!=-1	goto	CONTINUE	;SENSE FLTK ON/OFF SWITCH
			turnoff			;TURN THIS INSTRUMENT OFF IMMEDIATELY
CONTINUE:
ares		clip 		gasig, i(gkmeth), i(gklimit), i(gkarg)
outs		ares * gkpostgain, ares * gkpostgain
		endin
		
</CsInstruments>

<CsScore>
i 1 0 3600
</CsScore>

</CsoundSynthesizer>