;Written by Iain McCurdy, 2009

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	4410	;CONTROL RATE
ksmps 		= 	10	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;			LABEL        | WIDTH | HEIGHT | X | Y
		FLpanel	"powershape",   500,    150,    0,  0

;SWITCHES  	                                  		ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | DUR
gkOnOff,ihOnOff			FLbutton	"On/Off",	1,    0,    2,     150,     30,    0,  0,     0,     1,      0,       -1

;VALUE DISPLAY BOXES	LABEL | WIDTH | HEIGHT | X | Y
idShapeAmount  	FLvalue	" ",	 70,      20,    0,  75
idOutputGain  	FLvalue	" ",	 70,      20,    0, 125

;SLIDERS       					LABEL                 	MIN   | MAX | EXP | TYPE |  DISP        | WIDTH | HEIGHT | X  | Y
gkShapeAmount, ihShapeAmount	FLslider	"Waveshaping Amount",   0,        2,   0,    5,   idShapeAmount,   500,    25,     0,  50
gkOutputGain, ihOutputGain	FLslider	"Output Gain",   	0.0001,  50,  -1,    5,   idOutputGain,    500,    25,     0, 100

;SET INITIAL VALUES FOR SLIDERS |VALUE | HANDLE
		FLsetVal_i	1,       ihShapeAmount
		FLsetVal_i	1,       ihOutputGain

		FLpanel_end	;END OF PANEL CONTENTS

;INSTRUCTIONS AND INFO PANEL                 WIDTH | HEIGHT | X | Y
				FLpanel	" ", 500,     200,   512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                        powershape                           ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"'powershape' waveshapes an audio signal by raising it to a   ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"variable exponent ('Waveshaping Amount').                    ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"The opcode is given a value for the maximum expected         ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"amplitude of the input signal. Using this it normalises the  ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"input signal before processing and then expands the output to", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"the original amplitude range.                                ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"An output gain control is added to allow for compensating for", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"gain increase or decrease depending on waveshaping amount.   ", 	1,      5,     14,    490,    15,     5, 180

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

0dbfs	=	1

instr	1
	if	gkOnOff!=0	goto	CONTINUE	;SENSE FLTK ON/OFF SWITCH
				turnoff			;TURN THIS INSTRUMENT OFF IMMEDIATELY
	CONTINUE:
	ain		diskin2		"808loopMono.wav", 1, 0, 1
	ifullscale	=	1
	aout 		powershape 	ain, gkShapeAmount , ifullscale
	outs		aout*gkOutputGain, aout*gkOutputGain
endin
		
</CsInstruments>

<CsScore>
i 1 0 3600
</CsScore>

</CsoundSynthesizer>