;Written by Iain McCurdy, 2007

<CsoundSynthesizer>

<CsOptions>
-idevaudio -odevaudio -b400
</CsOptions>

<CsInstruments>

sr	= 	44100
kr	= 	4410
ksmps	= 	10
nchnls	= 	2

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		LABEL     | WIDTH | HEIGHT | X | Y
	FLpanel	"pvscale",   500,    420,    0,  0

;BORDERS				TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	" ", 	6,      9,     15,    490,    130,    5, 280	;BORDER AROUND FFT ATTRIBUTES

;SWITCHES  	                         	ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | DUR
gkOnOff,ihOnOff	FLbutton	"On/Off",	1,  -1,     2,    150,     30,    0,  0,    0,       1,      0,      -1

;VALUE DISPLAY BOXES		LABEL | WIDTH | HEIGHT | X | Y
idscal			FLvalue	" ",	 80,      20,    0, 130
idgain			FLvalue	" ",	 80,      20,    0, 180

;SLIDERS				            		MIN   | MAX | EXP | TYPE |  DISP   | WIDTH | HEIGHT | X  | Y
gkscal, ihscal		FLslider 	"Frequency Rescale",	.125,    8,   -1,    3,    idscal,    500,     30,    0,  100
gkgain, ihgain		FLslider 	"Gain Rescale",		0,      20,    0,    3,    idgain,    500,     30,    0,  150

;COUNTERS						MIN | MAX | STEP1 | STEP2 | TYPE | WIDTH | HEIGHT | X | Y | OPCODE 
gkkeepform, ihkeepform	FLcount  "Formant Mode \
 0=Do_Not_Keep_Formants\
 1=Impose_Original_Amplitudes\
 2=Keep_Original_Spectral_Envelope",			0,     2,     1,      1,     2,     150,    30,    300, 0,   -1

;GENERAL_TEXT_SETTINGS			SIZE | FONT |  ALIGN | RED | GREEN | BLUE
			FLlabel		13,      1,       1,   190,   190,   190		;NUMBERS MADE INVISIBLE

;BUTTON BANKS			   			TYPE | NUMX | NUMY | WIDTH | HEIGHT | X | Y | OPCODE
gkinput,   ihinput			FLbutBank	12,     1,     3,     30,      75,    0, 202,   -1
gkFFTattributes, ihFFTattributes	FLbutBank	14,     1,     4,     18,      78,   120,320,   -1

;GENERAL_TEXT_SETTINGS			SIZE | FONT |  ALIGN | RED | GREEN | BLUE
			FLlabel		13,      5,      4,     0,     0,     0			;LABELS MADE VISIBLE AGAIN

;TEXT BOXES						TYPE | FONT | SIZE | WIDTH | HEIGHT | X |  Y
ih		 	FLbox  	"Live Input", 		1,       5,    11,    70,      25,   32,  202
ih		 	FLbox  	"Voice     ", 		1,       5,    11,    70,      25,   32,  227
ih		 	FLbox  	"Drum Loop ", 		1,       5,    11,    70,      25,   32,  252
ih		 	FLbox  	"FFT Attributes",       1,       4,    14,   100,      25,   15,  285
;TEXT BOXES										TYPE | FONT | SIZE | WIDTH | HEIGHT | X |  Y
ih		 	FLbox  	"FFT Size - Overlap - Window Size - Window Type",	1,       5,    11,    340,      20,  140,  300
ih		 	FLbox  	"  512        256        1024            1     ",	1,       5,    11,    340,      20,  140,  318
ih		 	FLbox  	" 1024        256        1024            1     ",	1,       5,    11,    340,      20,  140,  338
ih		 	FLbox  	" 2048        128        2048            1     ",	1,       5,    11,    340,      20,  140,  358
ih		 	FLbox  	" 4096        128        4096            1     ",	1,       5,    11,    340,      20,  140,  378

;SET INITIAL VALUES FOR SLIDERS 	|VALUE | HANDLE
			FLsetVal_i	1, 	ihscal
			FLsetVal_i	1, 	ihgain
			FLsetVal_i	0, 	ihkeepform
			FLsetVal_i	1, 	ihinput
			FLsetVal_i	1, 	ihFFTattributes

			FLpanel_end

;INSTRUCTIONS AND INFO PANEL                 WIDTH | HEIGHT | X | Y
				FLpanel	" ", 500,     400,   512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                           pvscale                           ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"The opcode pvscale performs rescaling of the frequency values", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"of an f-signal. If the 'Frequency Rescale' slider is given a ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"value of 2, frequency values will be transposed up by one    ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"octave, if it is given a value of .5, frequency values will  ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"be transposed down 1 octave and so on.                       ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"Pvscale also offers three transposition modes of dealing with", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"formants of the original spectrum. This is an optional       ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"argument and it defaults to 0. In mode 0 no attempt is made  ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"to retain formants. In mode 1 formants are retained by       ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"imposing the original amplitude values. In mode 2 formants   ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"are retained through filtering the output according to the   ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"spectral envelope of the original signal.                    ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"A variety of combination of FFT analysis attributes are      ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"selectable using radio button selectors. If can be observed  ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"that smaller FFT size and window sizes results in less time  ", 	1,      5,     14,    490,    15,     5, 320
ih		 	FLbox  	"smearing but greater harmonic distortion whereas larger FFT  ", 	1,      5,     14,    490,    15,     5, 340
ih		 	FLbox  	"sizes and window sizes results in greater time smearing but  ", 	1,      5,     14,    490,    15,     5, 360
ih		 	FLbox  	"less harmonic distortion.                                    ", 	1,      5,     14,    490,    15,     5, 380

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

gasig		init		0

giFFTattributes0	ftgen	1, 0, 4, -2,  512, 256, 1024, 1
giFFTattributes1	ftgen	2, 0, 4, -2, 1024, 256, 1024, 1
giFFTattributes2	ftgen	3, 0, 4, -2, 2048, 128, 2048, 1
giFFTattributes3	ftgen	4, 0, 4, -2, 4096, 128, 4096, 1


instr	1	;(ALWAYS ON - SEE SCORE) PLAYS FILE AND SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS
	event_i	"i", 2, 0, -1				;ACTIVATE INSTR 2 WITH A HELD NOTE
	if		gkinput=0	then			;IF 'INPUT' SWITCH IS SET TO 'Live Input' THEN IMPLEMENT THE NEXT LINE OF CODE
		gasig		inch		1				;READ AUDIO FROM THE COMPUTER'S LIVE INPUT CHANNEL 1 (LEFT)
	elseif		gkinput=1 	then			;IF 'INPUT' SWITCH IS SET TO 'Voice' THEN IMPLEMENT THE NEXT LINE OF CODE
		;OUTPUT		OPCODE		FILE_PATH       | SPEED | INSKIP | WRAPAROUND (1=ON)
		gasig		diskin2		"AndItsAll.wav",    1,      0,        1			;READ A STORED AUDIO FILE FROM THE HARD DRIVE
	else						;IF 'INPUT' SWITCH IS NOT SET TO 'STORED FILE' THEN IMPLEMENT THE NEXT LINE OF CODE
		;OUTPUT		OPCODE		FILE_PATH       | SPEED | INSKIP | WRAPAROUND (1=ON)
		gasig		diskin2		"808loopMono.wav",    1,      0,        1			;READ A STORED AUDIO FILE FROM THE HARD DRIVE
	endif						;END OF 'IF'...'THEN' BRANCHING
	kSwitch		changed		gkgain, gkkeepform, gkFFTattributes	;GENERATE A MOMENTARY '1' PULSE IN OUTPUT 'kSwitch' IF ANY OF THE SCANNED INPUT VARIABLES CHANGE. (OUTPUT 'kSwitch' IS NORMALLY ZERO)
	;					ITRIGGER | IMINTIM | IMAXNUM | IINSNUM | IWHEN | IDUR (-1 MEANS A NOTE OF INFINITE DURATION)
	schedkwhen	kSwitch,    0,        0,        2,        0,      -1	;RESTART INSTRUMENT 2 WITH A SUSTAINED (HELD) NOTE WHENEVER kSwitch=1
endin

instr 		2	;THIS INSTRUMENT GENERATES AND PERFORMS PROCESSING UPON AN FSIG CREATED FROM THE AUDIO STREAM CREATED IN INSTRUMENT 1
	if		gkOnOff!=-1	kgoto	CONTINUE	;SENSE FLTK ON/OFF SWITCH            
		turnoff                                                 ;TURN THIS INSTRUMENT OFF IMMEDIATELY
	CONTINUE:                                               ;LABEL
	iFFTsize	table	0, i(gkFFTattributes)+1
	ioverlap	table	1, i(gkFFTattributes)+1
	iwinsize	table	2, i(gkFFTattributes)+1
	iwintype	table	3, i(gkFFTattributes)+1	
	fsig1  		pvsanal		gasig, iFFTsize, ioverlap, iwinsize, iwintype		;ANALYSE THE AUDIO SIGNAL THAT WAS CREATED IN INSTRUMENT 1. OUTPUT AN F-SIGNAL.
	;OUTPUT		OPCODE		INPUT | RESCALE_VALUE | FORMANT_MODE |   GAIN
	fsig2 		pvscale 	fsig1,      gkscal,     i(gkkeepform), i(gkgain)	;RESCALE THE FREQUENCY VALUES ACCORDING TO THE INPUT ARGUMENT gkscal.
	;OUTPUT		OPCODE		INPUT
	aresyn 		pvsynth  	fsig2                      		;RESYNTHESIZE THE f-SIGNAL AS AN AUDIO SIGNAL
			outs		aresyn, aresyn				;SEND THE RESCALED, RESYNTHESIZED SIGNAL TO THE AUDIO OUTPUTS
endin

</CsInstruments>

<CsScore>
f 0 3600	;DUMMY SCORE EVENT KEEPS PERFORMANCE GOING FOR 1 HOUR
</CsScore>

</CsoundSynthesizer>