;Written by Iain McCurdy 2009

<CsoundSynthesizer>

<CsOptions>
-idevaudio -odevaudio -b400
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	441	;CONTROL RATE
ksmps 		= 	100	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		LABEL     | WIDTH | HEIGHT | X | Y
	FLpanel	"pvshift",   500,    520,    0,  0

;BORDERS				TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	" ", 	6,      9,     15,    490,    130,    5, 380	;BORDER AROUND FFT ATTRIBUTES

;SWITCHES  	                         	ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | DUR
gkOnOff,ihOnOff	FLbutton	"On/Off",	1,  -1,     2,    150,     30,    0,  0,    0,       1,      0,       -1
                                                
;VALUE DISPLAY BOXES		LABEL | WIDTH | HEIGHT | X | Y
idshift			FLvalue	" ",	 80,      20,    0, 130
idgain			FLvalue	" ",	 80,      20,    0, 180
idlowest		FLvalue	" ",	 80,      20,    0, 230
idOutGain		FLvalue	" ",	 80,      20,    0, 280

;SLIDERS				            		MIN   |  MAX | EXP | TYPE |   DISP   | WIDTH | HEIGHT | X  | Y
gkshift, ihshift	FLslider 	"Frequency Shift",	-5000,  5000,   0,    3,     idshift,   500,     30,    0,  100
gkgain, ihgain		FLslider 	"Gain Rescale",		0,         4,   0,    3,      idgain,   500,     30,    0,  150
gklowest, ihlowest	FLslider 	"Lowest Frequency",	1,     20000,  -1,    3,    idlowest,   500,     30,    0,  200
gkOutGain, ihOutGain	FLslider 	"Output Gain",		0,         1,   0,    3,   idOutGain,   500,     30,    0,  250

;COUNTERS						MIN | MAX | STEP1 | STEP2 | TYPE | WIDTH | HEIGHT | X | Y | OPCODE 
gkkeepform, ihkeepform	FLcount  "Formant Mode \
 0=Do_Not_Keep_Formants\
 1=Impose_Original_Amplitudes\
 2=Keep_Original_Spectral_Envelope",			0,     2,     1,      1,     2,     150,    30,    300, 0,   -1

;GENERAL_TEXT_SETTINGS			SIZE | FONT |  ALIGN | RED | GREEN | BLUE
			FLlabel		13,      1,      1,    190,   190,   190	;LABELS MADE INVISIBLE

;BUTTON BANKS				 		TYPE | NUMX | NUMY | WIDTH | HEIGHT | X | Y | OPCODE
gkinput,   ihinput			FLbutBank	12,     1,     3,     30,      75,    0, 302,   -1
gkFFTattributes, ihFFTattributes	FLbutBank	14,     1,     4,     18,      78,   120,420,   -1

;GENERAL_TEXT_SETTINGS			SIZE | FONT |  ALIGN | RED | GREEN | BLUE
			FLlabel		13,      5,      4,     0,     0,     0		;LABELS MADE VISIBLE AGAIN

;TEXT BOXES						TYPE | FONT | SIZE | WIDTH | HEIGHT | X |  Y
ih		 	FLbox  	"Live Input", 		1,       5,    11,    70,      25,   32,  302
ih		 	FLbox  	"Voice     ", 		1,       5,    11,    70,      25,   32,  327
ih		 	FLbox  	"Drum Loop ", 		1,       5,    11,    70,      25,   32,  352
ih		 	FLbox  	"FFT Attributes",       1,       4,    14,   100,      25,   15,  385
;TEXT BOXES										TYPE | FONT | SIZE | WIDTH | HEIGHT | X |  Y
ih		 	FLbox  	"FFT Size - Overlap - Window Size - Window Type",	1,       5,    11,    340,      20,  140,  400
ih		 	FLbox  	"  512        256        1024            1     ",	1,       5,    11,    340,      20,  140,  418
ih		 	FLbox  	" 1024        256        1024            1     ",	1,       5,    11,    340,      20,  140,  438
ih		 	FLbox  	" 2048        128        2048            1     ",	1,       5,    11,    340,      20,  140,  458
ih		 	FLbox  	" 4096        128        4096            1     ",	1,       5,    11,    340,      20,  140,  478

;SET INITIAL VALUES FOR SLIDERS 	|VALUE | HANDLE
			FLsetVal_i	1, 	ihinput
			FLsetVal_i	0, 	ihshift
			FLsetVal_i	1, 	ihgain
			FLsetVal_i	0, 	ihkeepform
			FLsetVal_i	10, 	ihlowest
			FLsetVal_i	0.7, 	ihOutGain
			FLsetVal_i	1, 	ihFFTattributes

			FLpanel_end

;INSTRUCTIONS AND INFO PANEL                 WIDTH | HEIGHT | X | Y
				FLpanel	" ", 500,     540,   512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                          pvshift                            ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"Pvshift shifts all frequency values of an fsig by a constant ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"cycles-per-second value. As frequency values are shifted     ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"upwards the spectrum of the sound is also compressed as,     ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"relatively speaking, higher frequencies will be transposed by", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"less than lower frequencies.                                 ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"The next example appends the pvscale opcode in the fsig      ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"processing chain to allow the user to allow the user to      ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"compensate for this overall raising of frequencies and to    ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"restore the fundemental to its original value by giving      ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"the frequency rescale parameter a value less than 1.         ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"(See example '03pvscale.csd' for info on pvscale opcode.)    ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"Pvshift also includes three modes of dealing with formants of", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"the original signal in the frequency shift. These modes are  ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"the same as those used by the pvscale opcode - see the       ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"'pvscale.csd' example (or the Csound Reference Manual) for   ", 	1,      5,     14,    490,    15,     5, 320
ih		 	FLbox  	"further information about these modes.                       ", 	1,      5,     14,    490,    15,     5, 340
ih		 	FLbox  	"The parameter controlled by the 'Lowest Frequency' slider    ", 	1,      5,     14,    490,    15,     5, 360
ih		 	FLbox  	"defines a frequency beneath which frequencies of the fsig    ", 	1,      5,     14,    490,    15,     5, 380
ih		 	FLbox  	"will be unaffected by pvshift.                               ", 	1,      5,     14,    490,    15,     5, 400
ih		 	FLbox  	"A variety of combinations of FFT analysis attributes are     ", 	1,      5,     14,    490,    15,     5, 420
ih		 	FLbox  	"selectable using radio button selectors. If can be observed  ", 	1,      5,     14,    490,    15,     5, 440
ih		 	FLbox  	"that smaller FFT size and window sizes results in less time  ", 	1,      5,     14,    490,    15,     5, 460
ih		 	FLbox  	"smearing but greater harmonic distortion whereas larger FFT  ", 	1,      5,     14,    490,    15,     5, 480
ih		 	FLbox  	"sizes and window sizes results in greater time smearing but  ", 	1,      5,     14,    490,    15,     5, 500
ih		 	FLbox  	"less harmonic distortion.                                    ", 	1,      5,     14,    490,    15,     5, 520

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

gasig		init		0

giFFTattributes0	ftgen	1, 0, 4, -2,  512, 256, 1024, 1
giFFTattributes1	ftgen	2, 0, 4, -2, 1024, 256, 1024, 1
giFFTattributes2	ftgen	3, 0, 4, -2, 2048, 128, 2048, 1
giFFTattributes3	ftgen	4, 0, 4, -2, 4096, 128, 4096, 1

instr	1	;(ALWAYS ON - SEE SCORE) PLAYS FILE AND SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS
	if		gkOnOff!=-1	kgoto	CONTINUE	;SENSE FLTK ON/OFF SWITCH            
			turnoff                                 ;TURN THIS INSTRUMENT OFF IMMEDIATELY
	CONTINUE:                                               ;LABEL                               
		event_i	"i", 2, 0, -1				;ACTIVATE INSTR 2 WITH A HELD NOTE
	if		gkinput=0	then			;IF 'INPUT' SWITCH IS SET TO 'Live Input' THEN IMPLEMENT THE NEXT LINE OF CODE
		gasig		inch		1				;READ AUDIO FROM THE COMPUTER'S LIVE INPUT CHANNEL 1 (LEFT)
	elseif		gkinput=1 	then			;IF 'INPUT' SWITCH IS SET TO 'Voice' THEN IMPLEMENT THE NEXT LINE OF CODE
		;OUTPUT		OPCODE		FILE_PATH       | SPEED | INSKIP | WRAPAROUND (1=ON)
		gasig		diskin2		"AndItsAll.wav",    1,      0,        1			;READ A STORED AUDIO FILE FROM THE HARD DRIVE
	else						;IF 'INPUT' SWITCH IS NOT SET TO 'STORED FILE' THEN IMPLEMENT THE NEXT LINE OF CODE
		;OUTPUT		OPCODE		FILE_PATH       | SPEED | INSKIP | WRAPAROUND (1=ON)
		gasig		diskin2		"808loopMono.wav",    1,      0,        1			;READ A STORED AUDIO FILE FROM THE HARD DRIVE
	endif						;END OF 'IF'...'THEN' BRANCHING
	kSwitch		changed		gkgain, gkkeepform, gkFFTattributes	;GENERATE A MOMENTARY '1' PULSE IN OUTPUT 'kSwitch' IF ANY OF THE SCANNED INPUT VARIABLES CHANGE. (OUTPUT 'kSwitch' IS NORMALLY ZERO)
;					ITRIGGER | IMINTIM | IMAXNUM | IINSNUM | IWHEN | IDUR (-1 MEANS A NOTE OF INFINITE DURATION)
		schedkwhen	kSwitch,    0,        0,        2,        0,      -1	;RESTART INSTRUMENT 2 WITH A SUSTAINED (HELD) NOTE WHENEVER kSwitch=1
endin

instr 		2	;THIS INSTRUMENT GENERATES AND PERFORMS PROCESSING UPON AN FSIG CREATED FROM THE AUDIO STREAM CREATED IN INSTRUMENT 1
		if		gkOnOff!=-1	kgoto	CONTINUE	;SENSE FLTK ON/OFF SWITCH            
				turnoff                                 ;TURN THIS INSTRUMENT OFF IMMEDIATELY
		CONTINUE:                                               ;LABEL                               
		iFFTsize	table	0, i(gkFFTattributes)+1
		ioverlap	table	1, i(gkFFTattributes)+1
		iwinsize	table	2, i(gkFFTattributes)+1
		iwintype	table	3, i(gkFFTattributes)+1	
		fsig1  		pvsanal		gasig, iFFTsize, ioverlap, iwinsize, iwintype		;ANALYSE THE AUDIO SIGNAL THAT WAS CREATED IN INSTRUMENT 1. OUTPUT AN F-SIGNAL.
		;OUTPUT		OPCODE		INPUT | SHIFT_AMOUNT | LOWEST_EXPECTED_FREQUENCY | FORMANT_MODE  |   GAIN
		fsig2 		pvshift 	fsig1,    gkshift,              gklowest,          i(gkkeepform),  i(gkgain)	;SHIFT FREQUENCIES OF THE INPUT F-SIGNAL
		;OUTPUT		OPCODE		INPUT
		aresyn 		pvsynth  	fsig2                      		;RESYNTHESIZE THE f-SIGNAL AS AN AUDIO SIGNAL
				outs		aresyn * gkOutGain, aresyn * gkOutGain	;SEND THE RESCALED, RESYNTHESIZED SIGNAL TO THE AUDIO OUTPUTS
endin

</CsInstruments>

<CsScore>
f 0 3600	;DUMMY SCORE EVENT KEEPS PERFORMANCE GOING FOR 1 HOUR
</CsScore>

</CsoundSynthesizer>