;Written by Iain McCurdy

<CsoundSynthesizer>

<CsOptions>
-+rtaudio=PortAudio -b400
</CsOptions>

<CsInstruments>

sr	= 	44100
kr	= 	441
ksmps	= 	100
nchnls	= 	2

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		LABEL    | WIDTH | HEIGHT | X | Y
	FLpanel	"pvsarp",   500,    400,    0,  0

;SWITCHES  	                         	ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | DUR
gkOnOff,ihOnOff	FLbutton	"On/Off",	1,  -1,     2,     150,     30,    0,  0,     0,     2,      0,      -1

;VALUE DISPLAY BOXES		LABEL | WIDTH | HEIGHT | X | Y
iddepth			FLvalue	" ",	 80,      20,    0, 180
idgain			FLvalue	" ",	 80,      20,    0, 230
idLFOdepth		FLvalue	" ",	 80,      20,    0, 280
idLFOoffset		FLvalue	" ",	 80,      20,    0, 330
idLFOspeed		FLvalue	" ",	 80,      20,    0, 380

;SLIDERS				            			MIN   | MAX | EXP | TYPE |    DISP   | WIDTH | HEIGHT | X  | Y
gkdepth, ihdepth		FLslider 	"Depth",		0,       1,    0,    3,      iddepth,   500,     30,    0,  150
gkgain, ihgain			FLslider 	"Gain Rescale",		0,      20,    0,    3,       idgain,   500,     30,    0,  200
gkLFOdepth, ihLFOdepth		FLslider 	"LFO Depth",		0,      .5,    0,    3,   idLFOdepth,   500,     30,    0,  250
gkLFOoffset, ihLFOoffset	FLslider 	"LFO Offset",		-.5,    .5,    0,    3,  idLFOoffset,   500,     30,    0,  300
gkLFOspeed, ihLFOspeed		FLslider 	"LFO Speed",		.001, 2000,   -1,    3,   idLFOspeed,   500,     30,    0,  350

;COUNTERS					MIN | MAX | STEP1 | STEP2 | TYPE | WIDTH | HEIGHT | X | Y | OPCODE 
gkLFOfn, ihLFOfn	FLcount  "LFO shape\
 1=sine\
 2=triangle\
 3=ramp_down\
 4=ramp_up\
 5=square\
 6=random",					1,     6,     1,      1,     2,     150,    30,    300, 0,   -1


;SET INITIAL VALUES FOR SLIDERS 	|VALUE | HANDLE
			FLsetVal_i	.95, 	ihdepth
			FLsetVal_i	1, 	ihgain
			FLsetVal_i	.1, 	ihLFOdepth
			FLsetVal_i	0.11, 	ihLFOoffset
			FLsetVal_i	0.17, 	ihLFOspeed
			FLsetVal_i	1, 	ihLFOfn

			FLpanel_end

;INSTRUCTIONS AND INFO PANEL                 WIDTH | HEIGHT | X | Y
				FLpanel	" ", 500,     520,   512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                           pvsarp                            ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 320
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 340
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 360
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 380
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 400
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 420
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 440
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 460
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 480
ih		 	FLbox  	" ", 	1,      5,     14,    490,    15,     5, 500

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		instr		1	;(ALWAYS ON - SEE SCORE) PLAYS FILE AND SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS
gasig		diskin2		"AndItsAll.wav", 1, 0, 1
kSwitch		changed		gkLFOfn	;GENERATE A MOMENTARY '1' PULSE IN OUTPUT 'kSwitch' IF ANY OF THE SCANNED INPUT VARIABLES CHANGE. (OUTPUT 'kSwitch' IS NORMALLY ZERO)
;					ITRIGGER | IMINTIM | IMAXNUM | IINSNUM | IWHEN | IDUR (-1 MEANS A NOTE OF INFINITE DURATION)
		schedkwhen	kSwitch,    0,        0,        2,        0,      -1	;RESTART INSTRUMENT 2 WITH A SUSTAINED (HELD) NOTE WHENEVER kSwitch=1
		endin

		instr 		2
if		gkOnOff!=-1	kgoto	CONTINUE
turnoff
CONTINUE:

fsig1  		pvsanal		gasig, 1024, 256, 1024, 1		;ANALYSE THE AUDIO SIGNAL THAT WAS CREATED IN INSTRUMENT 1

kbin		oscili		gkLFOdepth, gkLFOspeed, i(gkLFOfn)
kbin		=		kbin + gkLFOoffset

kbinrnd		randomh		-gkLFOdepth, gkLFOdepth, gkLFOspeed
kbinrnd		=		kbinrnd + gkLFOoffset

kbin		=		(gkLFOfn == 6 ? kbinrnd : kbin)

kbin		limit		kbin, 0, 1

fsig2		pvsarp 		fsig1, kbin, gkdepth, gkgain

aresyn 	pvsynth  	fsig2                      		;RESYNTHESIZE THE f-SIGNAL AS AN AUDIO SIGNAL
	outs		aresyn, aresyn				;SEND THE RESCALED, RESYNTHESIZED SIGNAL TO THE AUDIO OUTPUTS
	endin

</CsInstruments>

<CsScore>
f 1 0 129 10 1			;SINE WAVE
f 2 0 129 7  0 32 1 64 -1 32 0	;TRIANGLE WAVE
f 3 0 129 7  1  128 -1		;RAMP DOWN
f 4 0 129 7  -1 128  1		;RAMP UP
f 5 0 129 7  1 64 1 0 -1 64 -1	;SQUARE
f 6 0 129 10 1			;DUMMY TABLE (NOT USED)

i 1 0 3600	;INSTRUMENT 1 PLAYS FOR 1 HOUR
</CsScore>

</CsoundSynthesizer>