;Written by Iain McCurdy, 2008

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>


<CsInstruments>

sr	=	44100
kr	=	44100
ksmps	=	1
nchnls	=	2

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;			LABEL                                                        | WIDTH | HEIGHT | X | Y
	FLpanel	"Phase Modulation Synthesis: Simple Carrier->Modulator(with feedback)", 500,    350,    0,  0

;                                                      ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | IDUR
gkOnOff,ihOnOff	FLbutton	"On/Off",		1,   0,     2,    150,     28,    0,  0,    0,      1,      0,       3600
gkExit,ihExit	FLbutton	"Exit",			1,   0,     1,    150,     28,  350,  0,    0,    999,      0,       0.001

;VALUE DISPLAY BOXES					WIDTH | HEIGHT | X |  Y
idbasefreq			FLvalue	" ",     	60,       20,    0,   80
idindex				FLvalue	" ",     	60,       20,    0,  130
idCarAmp			FLvalue	" ",     	60,       20,    0,  280
idFBRatio			FLvalue	" ",     	60,       20,    0,  330

;					            							MIN  |   MAX | EXP | TYPE |   DISP     | WIDTH | HEIGHT | X | Y
gkbasefreq, ihbasefreq		FLslider 	"Base Frequency",		 			20,    20000,  -1,    5,   idbasefreq,    400,    30,     0, 50
gkindex, ihindex		FLslider 	"Modulation Index",					0,       100,   0,    5,   idindex,       400,    30,     0, 100
gkCarAmp, ihCarAmp		FLslider 	"Carrier Amplitude",					0,     30000,   0,    5,   idCarAmp,      500,    30,     0, 250
gkFBRatio, ihFBRatio		FLslider 	"Feedback Ratio",					0,         1,   0,    5,   idFBRatio,     500,    30,     0, 300

;BORDERS				ITYPE, IFONT, ISIZE, IWIDTH, IHEIGHT, IX, IY
ih		 	FLbox  	" ", 	6,        9,    15,    220,    70,   140, 160

;						 			MIN | MAX | STEP | TYPE | WIDTH | HEIGHT | X  | Y
gkCarRatio, ihCarRatio		FLtext		" ", 			.125,   8,  .001,   1,     50,     20,   190, 170
gkModRatio, ihModRatio		FLtext		" ", 			.125,   8,  .001,   1,     50,     20,   260, 170
gkPeakDev, gihPeakDev		FLtext		"Peak Deviation", 	0,  10000,     0,   1,     80,     20,   410,  65 ;DISPLAY ONLY!

;TEXT BOXES										TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	":", 							1,      5,     14,     5,    15,    248,  172
ih		 	FLbox  	"Carrier Frequency", 					1,      5,     12,    90,    15,    170,  200
ih		 	FLbox  	"Modulator Frequency", 					1,      5,     12,    90,    15,    245,  200

			FLsetVal_i	100, 	ihbasefreq
			FLsetVal_i	3, 	ihindex
			FLsetVal_i	1, 	ihCarRatio
			FLsetVal_i	1, 	ihModRatio
			FLsetVal_i	20000, 	ihCarAmp
			FLsetVal_i	0, 	ihFBRatio

			FLpanel_end

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 420, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"Phase Modulation Synthesis: Modulator->Carrier(with feedback)", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"This example implements phase modulation synthesis with a    ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"modulator->carrier pairing and with a feedback loop on the   ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"modulator->carrier pairing.                                  ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"                            +------+                         ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"                            V      |                         ", 	1,      5,     14,    490,    15,     5, 120
ih	  	 	FLbox  	"                         +--+--+   |                         ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"                         |MOD.1|   |                         ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"                         +--+--+   |                         ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"                            |      |                         ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"                            |      |(feedback)               ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"                            |      |                         ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"                         +--+--+   |                         ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"                         |CAR.1|   |                         ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"                         +--+--+   |                         ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"                            |      |                         ", 	1,      5,     14,    490,    15,     5, 320
ih		 	FLbox  	"                            +-->---+                         ", 	1,      5,     14,    490,    15,     5, 340
ih		 	FLbox  	"                            |                                ", 	1,      5,     14,    490,    15,     5, 360
ih		 	FLbox  	"                            V                                ", 	1,      5,     14,    490,    15,     5, 380
ih		 	FLbox  	"                           OUT                               ", 	1,      5,     14,    490,    15,     5, 400

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

gisine	ftgen	0,0,65537,10,1	;A SINE WAVE THAT CAN BE REFERENCED BY THE GLOBAL VARIABLE 'gisine'

instr 1
	if	gkOnOff!=0	kgoto	CONTINUE	;SENSE IF FLTK INSTRUMENT ON/OFF SWITCH IS NOT OFF (IN WHICH CASE SKIP THE NEXT LINE)
	turnoff						;TURN THIS INSTRUMENT OFF IMMEDIATELY
	CONTINUE:					;A LABEL
	
	iporttime	=	.02				;PORTAMENTO FUNCTION (WILL BE USED TO SMOOTH PARAMETER MOVED BY FLTK WIDGETS)
	kporttime	linseg	0,.001,iporttime,1,iporttime	;PORTAMENTO FUNCTION (WILL BE USED TO SMOOTH PARAMETER MOVED BY FLTK WIDGETS)
	
	kindex		portk	gkindex, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kindex'
	kbasefreq	portk	gkbasefreq, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kbasefreq'
	kFBRatio	portk	gkFBRatio, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kFBratio'
	kCarAmp	portk	gkCarAmp, kporttime			;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'gkCarAmp'

	aFB		init	0	;CREATE AN INITIAL VALUE FOR THE FEEDBACK SIGNAL
	aModPhase	phasor	kbasefreq * gkModRatio		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO READ CREATE THE MODULATOR
	aModulator	tablei	aModPhase+aFB,gisine,1,0,1	;MODULATOR OSCILLATOR IS CREATED. NOTE THAT FEEDBACK SIGNAL IS ADDED TO THE POINTER VARIABLE
	aModulator	=	aModulator * (kindex*.17)	;MODULATOR RESCALED
	aCarrPhase	phasor	kbasefreq * gkCarRatio		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO READ CREATE THE CARRIER
	aCarrPhase	=	aCarrPhase + aModulator		;MODULATOR SIGNAL IS ADDED TO CARRIER PHASE VARIABLE
	aCarrier	tablei	aCarrPhase,gisine,1,0,1		;MODULATOR OSCILLATOR IS CREATED. NOTE THAT FEEDBACK SIGNAL IS ADDED TO THE POINTER VARIABLE
	aFB		=	aCarrier * kFBRatio		;FEEDBACK SIGNAL UPDATED FOR THE NEXT PASS
	aCarrier	=	aCarrier*kCarAmp		;CARRIER AMPLITUDE IS RESCALED
	outs	aCarrier, aCarrier	;SEND THE AUDIO OUTPUT OF THE CARRIER WAVEFORM *ONLY* TO THE OUTPUTS 
endin
	
instr	999	;QUIT
	exitnow
endin

</CsInstruments>


<CsScore>
f 0 3600	;DUMMY SCORE EVENT - KEEPS REALTIME PERFORMANCE GOING FOR ONE HOUR
</CsScore>

</CsoundSynthesizer>