;Written by Iain McCurdy, 2009
;2 parallel modulators - 1 carrier

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b4096
</CsOptions>

<CsInstruments>

sr	=	44100
kr	=	44100
ksmps	=	1
nchnls	=	2
0dbfs	=	1	;MAXIMUM AMPLITUDE = 1, REGARDLESS OF BIT DEPTH

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		LABEL                                                          | WIDTH | HEIGHT | X | Y
	FLpanel	"Phase Modulation Synthesis: 2 parallel modulators -> carrier",   500,    330,    0,  0

;                                                      ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | IDUR
gkOnOff,ihOnOff	FLbutton	"On/Off",		1,   0,     2,    150,     28,    0,  0,    0,      1,      0,       3600

;VALUE DISPLAY BOXES					WIDTH | HEIGHT | X |  Y
idbasefreq			FLvalue	" ",     	60,       20,    0,   80
idindex1			FLvalue	" ",     	60,       20,    0,  130
idindex2			FLvalue	" ",     	60,       20,    0,  180
idCarAmp			FLvalue	" ",     	60,       20,    0,  310

;					            							MIN  |   MAX | EXP | TYPE |   DISP     | WIDTH | HEIGHT | X | Y
gkbasefreq, ihbasefreq		FLslider 	"Base Frequency",		 			20,    20000,  -1,    5,   idbasefreq,    500,    30,     0, 50
gkindex1, ihindex1		FLslider 	"Modulation Index 1",					0,         5,   0,    5,   idindex1,      500,    30,     0, 100
gkindex2, ihindex2		FLslider 	"Modulation Index 2",					0,         5,   0,    5,   idindex2,      500,    30,     0, 150
gkCarAmp, ihCarAmp		FLslider 	"Carrier Amplitude",					0,         1,   0,    5,   idCarAmp,      500,    30,     0, 280

;BORDERS				TYPE | FONT | SIZE | WIDTH | HEIGHT |  X | Y
ih		 	FLbox  	" ", 	6,       9,    15,    420,     70,    40, 205

;						 		MIN | MAX | STEP | TYPE | WIDTH | HEIGHT | X  | Y
gkModRatio1, ihModRatio1	FLtext		"", 		.125,   8,  .001,   1,     50,     20,   160, 220
gkModRatio2, ihModRatio2	FLtext		"", 		.125,   8,  .001,   1,     50,     20,   230, 220
gkCarRatio, ihCarRatio		FLtext		"", 		.125,   8,  .001,   1,     50,     20,   300, 220

;TEXT BOXES									TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"Freq. Ratios:", 				1,      5,     14,   110,    15,    50,  222
ih		 	FLbox  	":", 						1,      5,     14,     5,    15,    218,  222
ih		 	FLbox  	":", 						1,      5,     14,     5,    15,    288,  222
ih		 	FLbox  	"Mod. 1", 					1,      5,     12,    60,    15,    155,  245
ih		 	FLbox  	"Mod. 2", 					1,      5,     12,    60,    15,    225,  245
ih		 	FLbox  	"Car.", 					1,      5,     12,    60,    15,    295,  245

			FLsetVal_i	100, 	ihbasefreq
			FLsetVal_i	0, 	ihindex1
			FLsetVal_i	0, 	ihindex2
			FLsetVal_i	1, 	ihCarRatio
			FLsetVal_i	1, 	ihModRatio1
			FLsetVal_i	1, 	ihModRatio2
			FLsetVal_i	0.2, 	ihCarAmp

			FLpanel_end

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 340, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"Phase Modulation Synthesis: 2 parallel modulators -> carrier ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"An implementation of phase modulation synthesis with two     ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"parallel modulators modulating a single carrier.             ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"                                                             ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"            +---------+           +---------+                ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"            | MOD. 1  |           | MOD. 2  |                ", 	1,      5,     14,    490,    15,     5, 120
ih	  	 	FLbox  	"            +----+----+           +----+----+                ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"                 |                     |                     ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"                 +----------+----------+                     ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"                            |                                ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"                       +----+----+                           ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"                       | CARRIER |                           ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"                       +----+----+                           ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"                            |                                ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"                            V                                ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"                           OUT                               ", 	1,      5,     14,    490,    15,     5, 320

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

gisine	ftgen	0,0,65537,10,1	;A SINE WAVE THAT CAN BE REFERENCED BY THE GLOBAL VARIABLE 'gisine'

instr 1
	if	gkOnOff!=0	kgoto	CONTINUE	;SENSE IF FLTK INSTRUMENT ON/OFF SWITCH IS NOT OFF (IN WHICH CASE SKIP THE NEXT LINE)
	turnoff						;TURN THIS INSTRUMENT OFF IMMEDIATELY
	CONTINUE:					;A LABEL

	iporttime	=	.025				;PORTAMENTO FUNCTION (WILL BE USED TO SMOOTH PARAMETER MOVED BY FLTK WIDGETS)
	kporttime	linseg	0,.001,iporttime,1,iporttime	;PORTAMENTO FUNCTION (WILL BE USED TO SMOOTH PARAMETER MOVED BY FLTK WIDGETS)
	
	kindex1		portk	gkindex1, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kindex'
	kindex2		portk	gkindex2, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kindex'
	kbasefreq	portk	gkbasefreq, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kbasefreq'
	kCarAmp	portk	gkCarAmp, kporttime			;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'gkCarAmp'

	aModPhase1	phasor	kbasefreq * gkModRatio1		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO CREATE MODULATOR 1
	aModulator1	tablei	aModPhase1,gisine,1,0,1		;MODULATOR OSCILLATOR IS CREATED.
	aModulator1	=	aModulator1*kindex1		;MODULATOR AMPLITUDE RESCALED

	aModPhase2	phasor	kbasefreq * gkModRatio2		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO CREATE MODULATOR 2
	aModulator2	tablei	aModPhase2,gisine,1,0,1		;MODULATOR OSCILLATOR IS CREATED.
	aModulator2	=	aModulator2 * kindex2		;MODULATOR AMPLITUDE RESCALED

	aCarrPhase	phasor	kbasefreq * gkCarRatio		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO READ CREATE THE CARRIER
	aCarrPhase	=	aCarrPhase + aModulator1 +aModulator2		;MODULATORS 1 & 2 ARE ADDED TO CARRIER PHASE VARIABLE
	aCarrier	tablei	aCarrPhase,gisine,1,0,1		;CARRIER OSCILLATOR IS CREATED.
	aCarrier	=	aCarrier*kCarAmp		;CARRIER AMPLITUDE IS RESCALED

	outs	aCarrier, aCarrier	;SEND THE AUDIO OUTPUT OF THE CARRIER WAVEFORM *ONLY* TO THE OUTPUTS 
endin

</CsInstruments>

<CsScore>
f 0 3600	;DUMMY SCORE EVENT - KEEPS REALTIME PERFORMANCE GOING FOR ONE HOUR
</CsScore>

</CsoundSynthesizer>