;Written by Iain McCurdy, 2009
;3 parallel modulators - 1 carrier

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b4096
</CsOptions>

<CsInstruments>

sr	=	44100
kr	=	4410
ksmps	=	10
nchnls	=	2
0dbfs	=	1

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		LABEL                                                            | WIDTH | HEIGHT | X | Y
	FLpanel	"Phase Modulation Synthesis: 3 parallel modulators -> 1 carrier",   500,    400,    0,  0

;                                                      ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | IDUR
gkOnOff,ihOnOff	FLbutton	"On/Off",		1,   0,     2,    150,     28,    0,  0,    0,      1,      0,       3600

;VALUE DISPLAY BOXES					WIDTH | HEIGHT | X |  Y
idbasefreq			FLvalue	" ",     	60,       20,    0,   80
idindex1			FLvalue	" ",     	60,       20,    0,  130
idindex2			FLvalue	" ",     	60,       20,    0,  180
idindex3			FLvalue	" ",     	60,       20,    0,  230
idCarAmp			FLvalue	" ",     	60,       20,    0,  380

;SLIDERS				            				MIN  |   MAX | EXP | TYPE |   DISP     | WIDTH | HEIGHT | X | Y
gkbasefreq, ihbasefreq		FLslider 	"Base Frequency",		20,    20000,  -1,    5,   idbasefreq,    500,    30,     0, 50
gkindex1, ihindex1		FLslider 	"Modulation Index 1",		0,         5,   0,    5,   idindex1,      500,    30,     0, 100
gkindex2, ihindex2		FLslider 	"Modulation Index 2",		0,         5,   0,    5,   idindex2,      500,    30,     0, 150
gkindex3, ihindex3		FLslider 	"Modulation Index 3",		0,         5,   0,    5,   idindex3,      500,    30,     0, 200
gkCarAmp, ihCarAmp		FLslider 	"Carrier Amplitude",		0,         1,   0,    5,   idCarAmp,      500,    30,     0, 350

;BORDERS				ITYPE, IFONT, ISIZE, IWIDTH, IHEIGHT, IX, IY
ih		 	FLbox  	" ", 	6,        9,    15,    480,    70,    10, 260

;NUMBER INPUT BOXES				 	MIN | MAX | STEP | TYPE | WIDTH | HEIGHT | X  | Y
gkModRatio1, ihModRatio1	FLtext		"", 	.125,   8,  .001,   1,     50,     20,   160, 270
gkModRatio2, ihModRatio2	FLtext		"", 	.125,   8,  .001,   1,     50,     20,   220, 270
gkModRatio3, ihModRatio3	FLtext		"", 	.125,   8,  .001,   1,     50,     20,   280, 270
gkCarRatio, ihCarRatio		FLtext		"", 	.125,   8,  .001,   1,     50,     20,   340, 270

;TEXT BOXES						TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"Freq. Ratios:", 	1,      5,     14,   110,    15,     50,  272
ih		 	FLbox  	"Mod. 1", 		1,      5,     12,    60,    15,    155,  295
ih		 	FLbox  	"Mod. 2", 		1,      5,     12,    60,    15,    215,  295
ih		 	FLbox  	"Mod. 3", 		1,      5,     12,    60,    15,    275,  295
ih		 	FLbox  	"Car.", 		1,      5,     12,    60,    15,    335,  295

;SET INITIAL VALUES OF VALUATORS
			FLsetVal_i	100, 	ihbasefreq
			FLsetVal_i	0, 	ihindex1
			FLsetVal_i	0, 	ihindex2
			FLsetVal_i	0, 	ihindex3
			FLsetVal_i	1, 	ihCarRatio
			FLsetVal_i	1, 	ihModRatio1
			FLsetVal_i	1, 	ihModRatio2
			FLsetVal_i	1, 	ihModRatio3
			FLsetVal_i	0.2, 	ihCarAmp

			FLpanel_end

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 340, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"Phase Modulation Synthesis: 3 parallel modulators-> 1 carrier", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"An implementation of phase modulation synthesis in which 3   ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"parallel modulators modulate a single carrier.               ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"                                                             ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"         +---------+    +---------+    +---------+           ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"         | MOD. 1  |    | MOD. 2  |    | MOD. 3  |           ", 	1,      5,     14,    490,    15,     5, 120
ih	  	 	FLbox  	"         +----+----+    +----+----+    +----+----+           ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"              |              |              |                ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"              +--------------+--------------+                ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"                             |                               ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"                        +----+----+                          ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"                        | CARRIER |                          ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"                        +----+----+                          ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"                             |                               ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"                             v                               ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"                            OUT                              ", 	1,      5,     14,    490,    15,     5, 320

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

gisine	ftgen	0,0,65537,10,1	;A SINE WAVE THAT CAN BE REFERENCED BY THE GLOBAL VARIABLE 'gisine'

instr 1
	if	gkOnOff!=0	kgoto	CONTINUE	;SENSE IF FLTK INSTRUMENT ON/OFF SWITCH IS NOT OFF (IN WHICH CASE SKIP THE NEXT LINE)
	turnoff						;TURN THIS INSTRUMENT OFF IMMEDIATELY
	CONTINUE:					;A LABEL

	iporttime	=	.01				;PORTAMENTO FUNCTION (WILL BE USED TO SMOOTH PARAMETER MOVED BY FLTK WIDGETS)
	kporttime	linseg	0,.001,iporttime,1,iporttime	;PORTAMENTO FUNCTION (WILL BE USED TO SMOOTH PARAMETER MOVED BY FLTK WIDGETS)
	
	kindex1		portk	gkindex1, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kindex'
	kindex2		portk	gkindex2, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kindex'
	kindex3		portk	gkindex3, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kindex'
	kbasefreq	portk	gkbasefreq, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kbasefreq'
	kCarAmp	portk	gkCarAmp, kporttime			;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'gkCarAmp'

	aModPhase1	phasor	kbasefreq * gkModRatio1		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO READ CREATE MODULATOR 1
	aModulator1	tablei	aModPhase1,gisine,1,0,1		;MODULATOR 1 IS CREATED.
	aModulator1	=	aModulator1*kindex1		;MODULATOR 1 AMPLITUDE RESCALED

	aModPhase2	phasor	kbasefreq * gkModRatio2		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO READ CREATE MODULATOR 2
	aModulator2	tablei	aModPhase2,gisine,1,0,1		;MODULATOR 2 IS CREATED
	aModulator2	=	aModulator2 * kindex2		;MODULATOR 2 AMPLITUDE RESCALED

	aModPhase3	phasor	kbasefreq * gkModRatio3		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO READ CREATE MODULATOR 3
	aModulator3	tablei	aModPhase3,gisine,1,0,1		;MODULATOR 3 IS CREATED
	aModulator3	=	aModulator3 * kindex3		;MODULATOR 3 AMPLITUDE RESCALED

	aCarrPhase	phasor	kbasefreq * gkCarRatio		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO CREATE THE CARRIER
	aCarrPhase	=	aCarrPhase + aModulator1 + aModulator2  + aModulator3		;ALL 3 MODULATORS ARE ADDED TO CARRIER PHASE VARIABLE
	aCarrier	tablei	aCarrPhase,gisine,1,0,1		;MODULATOR OSCILLATOR IS CREATED
	aCarrier	=	aCarrier*kCarAmp		;CARRIER AMPLITUDE IS RESCALED

	outs	aCarrier, aCarrier	;SEND THE AUDIO OUTPUT OF THE CARRIER WAVEFORM *ONLY* TO THE OUTPUTS 
endin

</CsInstruments>


<CsScore>
f 0 3600	;DUMMY SCORE EVENT - KEEPS REALTIME PERFORMANCE GOING FOR ONE HOUR
</CsScore>

</CsoundSynthesizer>