;Written by Iain McCurdy, 2009
;modulator -> modulator -> carrier

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b4096
</CsOptions>

<CsInstruments>

sr	=	44100
kr	=	44100
ksmps	=	1
nchnls	=	2
0dbfs	=	1

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		LABEL                                  | WIDTH | HEIGHT | X | Y
	FLpanel	"Phase Modulation Synthesis: M->M->C",    500,    500,    0,  0

;                                                      ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | IDUR
gkOnOff,ihOnOff	FLbutton	"On/Off",		1,   0,     2,    150,     28,    0,  0,    0,      1,      0,       3600

;VALUE DISPLAY BOXES					WIDTH | HEIGHT | X |  Y
idbasefreq			FLvalue	" ",     	60,       20,    0,   80
idindex1			FLvalue	" ",     	60,       20,    0,  130
idindex2			FLvalue	" ",     	60,       20,    0,  180
idCarAmp			FLvalue	" ",     	60,       20,    0,  280
idChoDep			FLvalue	" ",     	60,       20,    0,  380
idChoRte			FLvalue	" ",     	60,       20,    0,  430
idChoMix			FLvalue	" ",     	60,       20,    0,  480

;SLIDERS				            			MIN  |   MAX | EXP | TYPE |   DISP     | WIDTH | HEIGHT | X | Y
gkbasefreq, ihbasefreq		FLslider 	"Base Frequency",	20,    20000,  -1,    5,   idbasefreq,    500,    30,     0, 50
gkindex1, ihindex1		FLslider 	"Modulation Index 1",	0,         1,   0,    5,   idindex1,      500,    30,     0, 100
gkindex2, ihindex2		FLslider 	"Modulation Index 2",	0,         1,   0,    5,   idindex2,      500,    30,     0, 150
gkCarAmp, ihCarAmp		FLslider 	"Carrier Amplitude",	0,         1,   0,    5,   idCarAmp,      500,    30,     0, 300
gkChoDep, ihChoDep		FLslider 	"Chorus Depth",		0,       0.1,   0,    5,   idChoDep,      500,    30,     0, 350
gkChoRte, ihChoRte		FLslider 	"Chorus Rate",		0,        10,   0,    5,   idChoRte,      500,    30,     0, 400
gkChoMix, ihChoMix		FLslider 	"Chorus Dry/Wet Mix",	0,         1,   0,    5,   idChoMix,      500,    30,     0, 450

;BORDERS				TYPE | FONT | SIZE | WIDTH | HEIGHT |  X | Y
ih		 	FLbox  	" ", 	6,       9,    15,    420,     70,    40, 205

;TEXT BOXES					 	MIN | MAX | STEP | TYPE | WIDTH | HEIGHT | X  | Y
gkModRatio1, ihModRatio1	FLtext		"", 	.125,   8,  .001,   1,     50,     20,   160, 220
gkModRatio2, ihModRatio2	FLtext		"", 	.125,   8,  .001,   1,     50,     20,   230, 220
gkCarRatio, ihCarRatio		FLtext		"", 	.125,   8,  .001,   1,     50,     20,   300, 220

;TEXT BOXES						TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"Freq. Ratios:",	1,      5,     14,   110,    15,    50,  222
ih		 	FLbox  	":", 			1,      5,     14,     5,    15,    218,  222
ih		 	FLbox  	":", 			1,      5,     14,     5,    15,    288,  222
ih		 	FLbox  	"Mod. 1", 		1,      5,     12,    60,    15,    155,  245
ih		 	FLbox  	"Mod. 2", 		1,      5,     12,    60,    15,    225,  245
ih		 	FLbox  	"Car.", 		1,      5,     12,    60,    15,    295,  245

			FLsetVal_i	100, 	ihbasefreq
			FLsetVal_i	0, 	ihindex1
			FLsetVal_i	0, 	ihindex2
			FLsetVal_i	1, 	ihCarRatio
			FLsetVal_i	1, 	ihModRatio1
			FLsetVal_i	1, 	ihModRatio2
			FLsetVal_i	0.2, 	ihCarAmp
			FLsetVal_i	0.003, 	ihChoDep
			FLsetVal_i	1, 	ihChoRte
			FLsetVal_i	0.5, 	ihChoMix

			FLpanel_end

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 480, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"Phase Modulation Synthesis: modulator->modulator->carrier    ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"An implementation of phase modulation synthesis in which a   ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"modulator modulates another modulator which in turn modulates", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"a carrier.                                                   ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"                                                             ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"                      +---------+                            ", 	1,      5,     14,    490,    15,     5, 120
ih	  	 	FLbox  	"                      | MOD. 1  |                            ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"                      +----+----+                            ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"                           |                                 ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"                      +----+----+                            ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"                      | MOD. 2  |                            ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"                      +----+----+                            ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"                           |                                 ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"                      +----+----+                            ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"                      | CARRIER |                            ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"                      +----+----+                            ", 	1,      5,     14,    490,    15,     5, 320
ih		 	FLbox  	"                           |                                 ", 	1,      5,     14,    490,    15,     5, 340
ih		 	FLbox  	"                           V                                 ", 	1,      5,     14,    490,    15,     5, 360
ih		 	FLbox  	"                          OUT                                ", 	1,      5,     14,    490,    15,     5, 380
ih		 	FLbox  	"                                                             ", 	1,      5,     14,    490,    15,     5, 400
ih		 	FLbox  	"Additionally the output of the synthesizer is passed through ", 	1,      5,     14,    490,    15,     5, 420
ih		 	FLbox  	"a chorus effect. To bypass this effect set 'Chorus Dry/Wet   ", 	1,      5,     14,    490,    15,     5, 440
ih		 	FLbox  	"Mix' to zero.                                                ", 	1,      5,     14,    490,    15,     5, 460

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

gisine	ftgen	0,0,65537,10,1	;A SINE WAVE THAT CAN BE REFERENCED BY THE GLOBAL VARIABLE 'gisine'
zakinit	2,2

instr 1
	if	gkOnOff!=0	kgoto	CONTINUE	;SENSE IF FLTK INSTRUMENT ON/OFF SWITCH IS NOT OFF (IN WHICH CASE SKIP THE NEXT LINE)
	turnoff						;TURN THIS INSTRUMENT OFF IMMEDIATELY
	CONTINUE:					;A LABEL

	iporttime	=	.01				;PORTAMENTO FUNCTION (WILL BE USED TO SMOOTH PARAMETER MOVED BY FLTK WIDGETS)
	kporttime	linseg	0,.001,iporttime,1,iporttime	;PORTAMENTO FUNCTION (WILL BE USED TO SMOOTH PARAMETER MOVED BY FLTK WIDGETS)
	
	kindex1		portk	gkindex1, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kindex1'
	kindex2		portk	gkindex2, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kindex2'
	kbasefreq	portk	gkbasefreq, kporttime		;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'kbasefreq'
	kCarAmp	portk	gkCarAmp, kporttime			;APPLY SMOOTHING PORTAMENTO TO THE VARIABLE 'gkCarAmp'

	aModPhase1	phasor	kbasefreq * gkModRatio1		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO READ CREATE MODULATOR 1
	aModulator1	tablei	aModPhase1,gisine,1,0,1		;MODULATOR 1 IS CREATED                                                  
	aModulator1	=	aModulator1*kindex1		;MODULATOR 1 AMPLITUDE RESCALED                                          

	aModPhase2	phasor	kbasefreq * gkModRatio2		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO READ CREATE MODULATOR 2
	aModPhase2	=	aModPhase2 + aModulator1	;MODULATOR 1 SIGNAL IS ADDED TO MODULATOR 2 PHASE VARIABLE
	aModulator2	tablei	aModPhase2,gisine,1,0,1		;MODULATOR 2 OSCILLATOR IS CREATED
	aModulator2	=	aModulator2 * kindex2		;MODULATOR 2 AMPLITUDE RESCALED

	aCarrPhase	phasor	kbasefreq * gkCarRatio		;CREATE A MOVING PHASE VALUE THAT WILL BE USED TO READ CREATE THE CARRIER
	aCarrPhase	=	aCarrPhase + aModulator2	;MODULATOR 2 SIGNAL IS ADDED TO CARRIER PHASE VARIABLE
	aCarrier	tablei	aCarrPhase,gisine,1,0,1		;MODULATOR OSCILLATOR IS CREATED
	aCarrier	=	aCarrier*kCarAmp		;CARRIER AMPLITUDE IS RESCALED

	zawm		aCarrier, 1	;MIX PM SYNTHESIZED TONES INTO ZAK AUDIO CHANNEL 1
endin

instr	2	;CHORUS
	iporttime	=	0.05					;DEFINE A RAMPING UP VARIABLE THAT WILL BE USED FOR PORTAMENTO TIME
	kporttime	linseg	0,0.01,iporttime,1,iporttime    	;DEFINE A RAMPING UP VARIABLE THAT WILL BE USED FOR PORTAMENTO TIME
	kChoDep		portk	gkChoDep, kporttime             	;APPLY PORTAMENTO SMOOTHING TO SLIDER VARIABLE gkChoDep
	ain		zar	1					;READ AUDIO FROM ZAK CHANNEL 1
	ichooffset	init	.001					;OFFSET TIME FOR CHORUSING DELAY
	achodepth	interp	kChoDep					;CONVERT kChoDep TO A-RATE
	kchofrq		randomi	-gkChoRte, gkChoRte, 1			;CREATE CHORUS RATE VARIABLE AS RANDOMLY MOVING VARIABLE THE RANGE OF WHICH IS DEFINED BY SLIDER 'Chorus Rate'
	adlt		oscili	kChoDep * 0.5, kchofrq*gkChoRte, gisine	;CREATE DELAY TIME VARIABLE
	adlt		=	adlt + (achodepth * 0.5) + ichooffset	;OFFSET DELAY TIME VARIABLE
	
	imaxdlt		init	1					;DEFINE MAXIMUM DELAY TIME
	abuffer		delayr	1					;SET UP DELAY BUFFER
	atap		deltap3	adlt					;READ A DELAY TAP FROM THE BUFFER
			delayw	ain					;WRITE AUDIO INTO BUFFER
	zawm		atap, 2						;MIX CHORUSED TONES INTO ZAK CHANNEL 2
endin

instr	3	;AUDIO OUTPUT
	adry	zar	1			;READ DRY SIGNAL FROM ZAK CHANNEL 1
	acho	zar	2			;READ CHORUSED AUDIO FROM ZAK CHANNEL 2
	amix	ntrpol	adry, acho, gkChoMix	;MIX DRY AND CHORUSED AND AUDIO
	outs	amix, amix			;SEND AUDIO TO OUTPUTS
	zacl	0,2				;CLEAR ZAK VARIABLES
endin

</CsInstruments>


<CsScore>
i 2 0 3600	;CHORUS VOICES
i 2 0 3600	;CHORUS VOICES
i 2 0 3600	;CHORUS VOICES
i 2 0 3600	;CHORUS VOICES
i 2 0 3600	;CHORUS VOICES
i 2 0 3600	;CHORUS VOICES
i 2 0 3600	;CHORUS VOICES
i 2 0 3600	;CHORUS VOICES
i 2 0 3600	;CHORUS VOICES
i 3 0 3600	;DUMMY SCORE EVENT - KEEPS REALTIME PERFORMANCE GOING FOR ONE HOUR
</CsScore>

</CsoundSynthesizer>