;Written by Iain McCurdy, 2006

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	441	;CONTROL RATE
ksmps 		= 	100	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;					LABEL   | WIDTH | HEIGHT | X | Y
				FLpanel	"pareq",   500,    350,    0,  0

;SWITCHES  	                                  		ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | DUR
gkOnOff,ihOnOff			FLbutton	"On/Off",	1,   -1,     2,    150,     30,    0,   0,    0,     2,      0,       -1

;VALUE DISPLAY BOXES			LABEL  | WIDTH | HEIGHT | X | Y
idc				FLvalue	" ",      100,    20,     0,  80
idv				FLvalue	" ",      100,    20,     0, 130
idq				FLvalue	" ",      100,    20,     0, 180
idamp				FLvalue	" ",      100,    20,     0, 230

;COUNTERS											MIN | MAX | STEP1 | STEP2 | TYPE | WIDTH | HEIGHT | X |  Y  | OPCODE
gkskip, ihskip 			FLcount  "Initialisation 0-On 1-Off", 				0,     1,     1,      1,     2,     150,     30,   350,   0,    -1
gkmode, ihmode			FLcount  "0-Peaking 1-Low_Shelving 2-High_Shelving",	0,     2,     1,      1,     2,     150,     30,   175, 250,    -1

;SLIDERS					            		MIN | MAX | EXP | TYPE | DISP | WIDTH | HEIGHT | X | Y
gkc, ihc			FLslider 	"Cutoff Frequency",	20,  20000, -1,    5,    idc,    500,     30,    0,  50
gkv, ihv			FLslider 	"Parametric Gain",	0,      20,  0,    5,    idv,    500,     30,    0, 100
gkq, ihq			FLslider 	"Q",			.707,   20,  0,    5,    idq,    500,     30,    0, 150
gkamp, ihamp			FLslider 	"Output Amplitude",	0,       4,  0,    5,  idamp,    500,     30,    0, 200

;SET INITIAL VALUES OF FLTK VALUATORS
;						VALUE | HANDLE
				FLsetVal_i	3000, 	ihc
				FLsetVal_i	1, 	ihv
				FLsetVal_i	.707, 	ihq
				FLsetVal_i	.7, 	ihamp
				FLsetVal_i	-1, 	ihOnOff
				FLsetVal_i	0, 	ihskip
			
				FLpanel_end

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 160, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                            pareq                            ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"Pareq is an implementation of Zoelzer's parametric equalizer ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"filters. The interface presented here reflects pareq's input ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"argument and their functions should be familiar from         ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"parametric equalisers found in the studio. A output amplitude", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"control is included to compenstate for gain peaks caused by  ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"high settings of 'Parametric Gain' and 'Q'.                  ", 	1,      5,     14,    490,    15,     5, 140

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		instr	1	;(ALWAYS ON - SEE SCORE) PLAYS FILE AND SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS
;OUTPUTS	OPCODE	FILE           | SPEED | INSKIP | LOOPING (0=OFF 1=ON)
gasigL, gasigR	diskin2	"Seashore.wav",    1,       0,         1	;GENERATE 2 AUDIO SIGNALS FROM A STEREO SOUND FILE (NOTE THE USE OF GLOBAL VARIABLES)
kSwitch		changed	gkmode, gkskip	;GENERATE A MOMENTARY '1' PULSE IN OUTPUT 'kSwitch' IF ANY OF THE SCANNED INPUT VARIABLES CHANGE. (OUTPUT 'kSwitch' IS NORMALLY ZERO)
;				ITRIGGER | IMINTIM | IMAXNUM | IINSNUM | IWHEN | IDUR (-1 MEANS A NOTE OF INFINITE DURATION)
		schedkwhen	kSwitch,      0,        0,        2,        0,    -1	;RESTART INSTRUMENT 2 WITH A SUSTAINED (HELD) NOTE WHENEVER kSwitch=1
		endin
		
		instr	2
if	gkOnOff!=-1	goto	CONTINUE	;SENSE FLTK ON/OFF SWITCH - IF 'ON' JUMP TO LABEL 'CONTINUE'
			turnoff			;TURN THIS INSTRUMENT OFF IMMEDIATELY
CONTINUE:					;LABEL 'CONTINUE'
aresL 		pareq 	gasigL, gkc, gkv, gkq, i(gkmode), i(gkskip)
aresR 		pareq 	gasigR, gkc, gkv, gkq, i(gkmode), i(gkskip)
		outs	aresL*gkamp, aresR*gkamp	;SEND FILTER OUTPUT TO THE AUDIO OUTPUTS
  		endin
  	
</CsInstruments>

<CsScore>
;INSTR | START | DURATION
i  1       0       3600	;INSTRUMENT 1 PLAYS FOR 1 HOUR
</CsScore>

</CsoundSynthesizer>



























