;Writen by Iain McCurdy, 2006

<CsoundSynthesizer>

<CsOptions>
-odevaudio -+rtmidi=virtual --midi-device=0 -b400 
</CsOptions>    

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	441	;CONTROL RATE
ksmps 		= 	100	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;INSTRUCTIONS AND INFO PANEL                 WIDTH | HEIGHT | X | Y
				FLpanel	" ", 515,      660,   0,  0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"   Activating an Instrument Through Realtime MIDI Control    ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"Basic activation of csound instruments through the use of a  ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"connected MIDI transmitting hardware device (typically a MIDI", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"keyboard) is transparent to the user. The only requirement is", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"that a Csound flag for live MIDI input is given so that      ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"Csound knows to expect MIDI information. In the code of this ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"example '--midi-device=0' ('-M0' would be a less verbose     ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"alternative) is included in the <CsOptions> section of the   ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"csd to activate realtime MIDI. The number after the flag     ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"selects which of your computer's MIDI input devices to use.  ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"If your computer has only one MIDI input device then a zero  ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"(as I have used here) will select it. If your computer has   ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"more than one MIDI input device installed (including virtual ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"devices) then you may need to give some other value here. If ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"If you are not sure about what MIDI input devices your       ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"computer has you can overestimate the value given here (for  ", 	1,      5,     14,    490,    15,     5, 320
ih		 	FLbox  	"example '-M99' in which case an error will be produced and   ", 	1,      5,     14,    490,    15,     5, 340
ih		 	FLbox  	"the Csound terminal window will give a list of legal MIDI    ", 	1,      5,     14,    490,    15,     5, 360
ih		 	FLbox  	"input devices and their related numbers.                     ", 	1,      5,     14,    490,    15,     5, 380
ih		 	FLbox  	"This example is very basic and merely produces a beep each   ", 	1,      5,     14,    490,    15,     5, 400
ih		 	FLbox  	"time a note is played on your MIDI keyboard. Note duration   ", 	1,      5,     14,    490,    15,     5, 420
ih		 	FLbox  	"corresponds with how long you hold the note for. Csound      ", 	1,      5,     14,    490,    15,     5, 440
ih		 	FLbox  	"regards MIDI notes as held note so there is no point in      ", 	1,      5,     14,    490,    15,     5, 460
ih		 	FLbox  	"trying to use 'p3' (note duration from a Csound score) in the", 	1,      5,     14,    490,    15,     5, 480
ih		 	FLbox  	"instrument code for a MIDI activated instrument. Polyphony is", 	1,      5,     14,    490,    15,     5, 500
ih		 	FLbox  	"possible although it is rather difficult to hear in this     ", 	1,      5,     14,    490,    15,     5, 520
ih		 	FLbox  	"example as all beeps are the same pitch.                     ", 	1,      5,     14,    490,    15,     5, 540
ih		 	FLbox  	"If an orchestra contains more that one instrument, MIDI notes", 	1,      5,     14,    490,    15,     5, 560
ih		 	FLbox  	"on MIDI channel 1 will be directed to instrument 1, channel 2", 	1,      5,     14,    490,    15,     5, 580
ih		 	FLbox  	"will be directed to instrument 2 and so on. Modification to  ", 	1,      5,     14,    490,    15,     5, 600
ih		 	FLbox  	"this default arrangement is possible using the 'massign'     ", 	1,      5,     14,    490,    15,     5, 620
ih		 	FLbox  	"opcode.                                                      ", 	1,      5,     14,    490,    15,     5, 640
				FLpanel_end
				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	instr	1	; SIMPLE BEEP INSTRUMENT - CAN BE ACTIVATED VIA A CONNECTED MIDI KEYBOARD
;OUTPUT	OPCODE	AMPLITUDE | FREQUENCY | FUNCTION_TABLE
asig	oscili	10000,         440,        1
	outs	asig, asig	;SEND AUDIO OUTPUT OF OSCILLATOR TO THE SPEAKERS
	endin

</CsInstruments>

<CsScore>
f 1 0 129 10 1	; SINE WAVE
f 0 600	; THIS LINE FUNCTIONS AS A DUMMY SCORE EVENT AND ALLOWS REALTIME MIDI PLAYING FOR 10 MINUTES
</CsScore>

</CsoundSynthesizer>