<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	4410	;CONTROL RATE
ksmps 		= 	10	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;				LABEL    | WIDTH | HEIGHT | X | Y
			FLpanel	"pan2",     500,    250,    0,  0

;SWITCHES  	                                  		ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | DUR
gkOnOff, ihOnOff		FLbutton	"On/Off",	1,    0,    2,     150,     30,    10, 10,    0,     2,      0,       -1
gkQuit, ihQuit			FLbutton	"Quit",		1,    0,    1,     150,     30,   340, 10,    0,   999,      0,        0

;VALUE DISPLAY BOXES		LABEL  | WIDTH | HEIGHT | X | Y
idpan			FLvalue	" ",      100,     20,    0,  75
idgain			FLvalue	" ",      100,     20,    0, 125

;SLIDERS				            		MIN | MAX | EXP | TYPE |  DISP     | WIDTH | HEIGHT | X  | Y
gkpan, ihpan			FLslider 	"Pan",		0,     1,    0,    5,    idpan,       500,     25,    0,  50
gkgain, ihgain			FLslider 	"Gain",		0,     1,    0,    5,    idgain,      500,     25,    0, 100

;COUNTERS										MIN | MAX | STEP1 | STEP2 | TYPE | WIDTH | HEIGHT | X | Y | OPCODE
gkmode, ihmode 			FLcount  "Mode: 0=Equal_Power 1=Root_Square 2=Linear", 	0,     2,     1,      1,      2,    150,     30,   175,150,    -1

;SET INITIAL VALUES FOR SLIDERS		|VALUE  | HANDLE
			FLsetVal_i	  0.5, 	  ihpan
			FLsetVal_i	  0.5, 	  ihgain
			FLsetVal_i	  0, 	  ihmode

				FLpanel_end

;INSTRUCTIONS AND INFO PANEL                 WIDTH | HEIGHT | X | Y
				FLpanel	" ", 500,     120,   512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                            pan2                             ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"The pan2 opcode provides a simple way to implement panning   ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"using one of three available methods. The method provided are", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"equal power (harmonic), square root and linear.              ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"Source sound in this example is pink noise.                  ", 	1,      5,     14,    490,    15,     5, 100

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

instr	1	;(ALWAYS ON - SEE SCORE) PLAYS FILE AND SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS
	kSwitch		changed	gkmode	;GENERATE A MOMENTARY '1' PULSE IN OUTPUT 'kSwitch' IF ANY OF THE SCANNED INPUT VARIABLES CHANGE. (OUTPUT 'kSwitch' IS NORMALLY ZERO)
	;				ITRIGGER | IMINTIM | IMAXNUM | IINSNUM | IWHEN | IDUR (-1 MEANS A NOTE OF INFINITE DURATION)
			schedkwhen	kSwitch,      0,        0,        2,        0,    -1	;RESTART INSTRUMENT 2 WITH A SUSTAINED (HELD) NOTE WHENEVER kSwitch=1
	gasig	pinkish	32768*gkgain     	;GENERATE PINK NOISE
endin


instr	2	;PINK NOISE
	if	gkOnOff!=0	goto	CONTINUE	;SENSE FLTK ON/OFF SWITCH FOR 'PINK NOISE' - IF 'ON' JUMP TO LABEL 'CONTINUE'
				turnoff			;TURN THIS INSTRUMENT OFF IMMEDIATELY
	CONTINUE:					;LABEL 'CONTINUE'
	a1, a2	pan2 	gasig, gkpan , i(gkmode)	;APPLY PANNING TO INPUT SIGNAL gasig USING THE MODE SELECTED BY i(gkmode)
	outs	a1, a2					;SEND AUDIO SIGNAL TO OUTPUTS
endin

instr	999	;QUIT
	exitnow
endin

</CsInstruments>

<CsScore>
i 1 0 3600	;INSTRUMENT 1 (SOUND GENERATOR AND SENSES CHANGES IN I-RATE CONTROLLERS) PLAYS FOR 1 HOUR
</CsScore>

</CsoundSynthesizer>
