;Written by Iain McCurdy, 2009

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	44100	;CONTROL RATE
ksmps 		= 	1	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;			LABEL       | WIDTH | HEIGHT | X | Y
		FLpanel	"repluck",     500,    450,    0,  0

;BUTTONS						ON | OFF | TYPE | WIDTH | HEIGHT |  X | Y | OPCODE | INS | STARTTIM | DUR
gkInput,ihInput		FLbutton	"Noise Burst",	1,    1,    1,     150,     30,    10,  10,    0,     2,      0,      -1
gkInput,ihInput		FLbutton	"Sound File",	2,    0,    2,     150,     30,   170,  10,    0,     2,      0,      -1
gkInput,ihInput		FLbutton	"Sine Burst",	3,    3,    1,     150,     30,   330,  10,    0,     2,      0,      -1
gkInput,ihInput		FLbutton	"Sine Tone",	4,    0,    2,     150,     30,   170,  40,    0,     2,      0,      -1


;VALUE DISPLAY BOXES	LABEL  | WIDTH | HEIGHT | X |  Y
idplk		FLvalue	" ",      100,     18,    0,  130
idpick		FLvalue	" ",      100,     18,    0,  180
idrefl		FLvalue	" ",      100,     18,    0,  230
idcps		FLvalue	" ",      100,     18,    0,  280
idamp		FLvalue	" ",      100,     18,    0,  330
idImplsGain	FLvalue	" ",      100,     18,    0,  380
idOutGain	FLvalue	" ",      100,     18,    0,  430

;SLIDERS				            				MIN |   MAX   | EXP | TYPE |   DISP         | WIDTH | HEIGHT | X  | Y
gkNseDur, ihNseDur		FLslider	"Duration",			0.1,      2,     0,    3,       -1,            150,    12,    10,    40
gkSineDur, ihSineDur		FLslider	"Duration",			0.1,      2,     0,    3,       -1,            150,    12,   330,    40
gkSineFrq, ihSineFrq		FLslider	"Frequency",			20,    8000,    -1,    3,       -1,            150,    12,   330,    70
gkSineTFrq, ihSineTFrq		FLslider	"Frequency",			20,    8000,    -1,    3,       -1,            150,    12,   170,    70
gkplk, ihplk			FLslider	"Pluck Position (i-rate)",	0,        1,     0,    5,    idplk,            500,    30,     0,   100
gkpick, ihpick			FLslider	"Pick-up Position (k-rate)",	0,   .99999,     0,    5,    idpick,           500,    30,     0,   150
gkrefl, ihrefl			FLslider	"Reflection",			0.0001,.9999,     0,    5,    idrefl,           500,    30,     0,   200
gkcps, ihcps			FLslider	"Pitch in CPS",			5,     7000,    -1,    5,    idcps,            500,    30,     0,   250
gkamp, ihamp			FLslider	"Amplitude",			.1,   32768,     0,    5,    idamp,            500,    30,     0,   300
gkImplsGain, ihImplsGain	FLslider	"Impulse Gain",			0,        1,     0,    5,    idImplsGain,      500,    30,     0,   350
gkOutGain, ihOutGain		FLslider	"Output Gain",			0,        1,     0,    5,    idOutGain,        500,    30,     0,   400

;SET INITIAL VALUES OF FLTK VALUATORS
;				VALUE | HANDLE
		FLsetVal_i	.98, 	ihplk
		FLsetVal_i	.1, 	ihpick
		FLsetVal_i	0.5, 	ihrefl
		FLsetVal_i	300, 	ihcps
		FLsetVal_i	3000, 	ihamp
		FLsetVal_i	0.15, 	ihImplsGain
		FLsetVal_i	0.7, 	ihOutGain
		FLsetVal_i	0.3, 	ihNseDur
		FLsetVal_i	0.3, 	ihSineDur
		FLsetVal_i	300, 	ihSineFrq
		FLsetVal_i	300, 	ihSineTFrq
		FLsetVal_i	0, 	ihInput

		FLpanel_end

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 320, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                         repluck                             ", 	1,      5,     14,    490,    15,     5,   0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"repluck is an implementation of the Karpluss-Strong plucked  ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"string algorithm.                                            ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"It is rather similar in design to wgpluck in that it also    ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"takes an exitation signal as input but its internal filtering", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"works slightly differently.                                  ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"Filtering or damping is controlled using 'Reflection'. This  ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"can be though of as the reflectiveness (or the amount of     ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"damping action) of the 2 points of fixture at either end of  ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"the string.                                                  ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"The 'Amplitude' control seems to be more effective in        ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"repluck. Again, low values here allow greater predominance   ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"of the exitation signal in the output.                       ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"Some of the other aspects of this example are explained more ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"fully in the example 'wgpluck.csd'.                          ", 	1,      5,     14,    490,    15,     5, 300

		FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

gisine	ftgen	0,0,1024,10,1	;A SINE WAVE

instr	1	;(ALWAYS ON - SEE SCORE) SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS
	kSwitch	changed	gkcps, gkplk	;GENERATE A MOMENTARY '1' PULSE IN OUTPUT 'kSwitch' IF ANY OF THE SCANNED INPUT VARIABLES CHANGE. (OUTPUT 'kSwitch' IS NORMALLY ZERO)
	;				ITRIGGER | IMINTIM | IMAXNUM | IINSNUM | IWHEN | IDUR (-1 MEANS A NOTE OF INFINITE DURATION)
			schedkwhen	kSwitch,      0,        0,        2,   0,     -1	;RESTART INSTRUMENT 2 WITH A SUSTAINED (HELD) NOTE WHENEVER kSwitch=1
endin

instr		2
	if	gkInput==0	then	;IF gkInput=0, I.E. ALL ON/OFF BUTTONS ARE OFF...
		turnoff			;...TURN OFF THIS INSTRUMENT IMMEDIATELY
	endif				;END OF CONDITIONAL BRANCH
	iporttime	=	0.1				;PORTAMENTO TIME
	kporttime	linseg	0,0.01,iporttime,1,iporttime	;PORTAMENTO TIME VARIABLE THAT RAMPS UP FROM ZERO
	kpick		portk	gkpick, kporttime		;APPLY PORTAMENTO TO 'PICK-UP POSITION' VARIABLE (PREVENTS 'ZIP' NOISE)
	kSineTFrq	portk	gkSineTFrq, kporttime		;APPLY PORTAMENTO TO 'SINE TONE FREQUENCY' VARIABLE (MAKES MODULATION SMOOTHER)
	if	gkInput==1	then					;IF gkinput=1, I.E. IF 'NOISE BURST' IS SELECTED...
		kenv	expseg		1,i(gkNseDur),.00001,1,.00001	;CREATE AN AMPLITUDE ENVELOPE FOR THE NOISE BURST
		axcite	pinkish		32768*kenv			;CREATE A PINK NOISE SIGNAL
	elseif	gkInput==2	then					;IF gkinput=2, I.E. IF 'SOUND FILE' IS SELECTED...
		axcite, aR	diskin2		"Songpan.wav",1,0,1	;CREATE AN AUDIO SIGNAL FROM A FILE STORED ON DISK. RIGHT CHANNEL WILL BE IGNORED. SOUND WILL PLAY FROM THE BEGINNING AND WILL LOOP CONTINUOUSLY
	elseif	gkInput==3	then					;IF gkinput=3, I.E. IF 'SINE TONE' IS SELECTED...
		kenv	expseg		1,i(gkSineDur),.00001,1,.00001	;CREATE AN AMPLITUDE ENVELOPE FOR THE SINE BURST
		axcite		oscili	32768*kenv, gkSineFrq, gisine	;CREATE A SINE TONE, FREQUENCY TAKEN FROM FLTK SLIDER
	elseif	gkInput==4	then					;IF gkinput=4, I.E. IF 'SINE BURST' IS SELECTED...
		axcite		oscili	32768, kSineTFrq, gisine	;CREATE A SINE TONE
	endif
	;OUTPUT	OPCODE		INPUT ARGS...
	ares 	repluck 	i(gkplk), gkamp, i(gkcps), kpick, gkrefl, axcite * gkImplsGain	;REPLUCK. NOTE EXCITATION SIGNAL SCALED BY gkImplsGain WHICH IS CREATED BY AN FLTK SLIDER
		outs 		ares * gkOutGain, ares * gkOutGain	;SEND AUDIO TO OUTPUTS, SCALE OUTPUT BY gkOutGain WHICH IS CREATED BY AN FLTK SLIDER
endin

</CsInstruments>

<CsScore>
i 1 0 3600	;INSTRUMENT 1 SCAN FOR CHANGES IN SELECTED I-RATE PARAMETERS AND RESTARTS INSTR 2 WHEN THEY OCCUR. THIS INSTRUMENT STATEMENT ALSO SUSTAINS REALTIME PERFORMANCE FOR 1 HOUR
</CsScore>

</CsoundSynthesizer>