;Written by Iain McCurdy, 2009

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	441	;CONTROL RATE
ksmps 		= 	100	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

		FLcolor		-2	;RANDOMLY COLOURIZE THE INTERFACE
		FLcolor2	-2	;RANDOMLY COLOURIZE THE INTERFACE

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;			LABEL    | WIDTH | HEIGHT | X | Y
		FLpanel	"shaker",   500,    350,    0,  0

;BUTTONS					ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | IDUR
gkOnOff,ihOnOff	FLbutton	"Shake!",	1,    0,     1,    200,     30,   150, 10,    0,     2,      0,       -1


;VALUE DISPLAY BOXES	LABEL  | WIDTH | HEIGHT | X |  Y
idamp		FLvalue	" ",      100,     18,    0,   80
idfreq		FLvalue	" ",      100,     18,    0,  130
idbeans		FLvalue	" ",      100,     18,    0,  180
iddamp		FLvalue	" ",      100,     18,    0,  230
idtimes		FLvalue	" ",      100,     18,    0,  280
iddecay		FLvalue	" ",      100,     18,    0,  330

;SLIDERS				            					MIN | MAX | EXP | TYPE |   DISP     | WIDTH | HEIGHT | X   | Y
gkamp, ihamp			FLslider	"Amplitude",				0,    30000,    0,   5,   idamp,       500,    30,     0,    50
gkfreq, ihfreq			FLslider	"Frequency",				.5,   20000,   -1,   5,   idfreq,      500,    30,     0,   100
gkbeans, ihbeans		FLslider	"Number of Beans",			1,      500,    0,   5,   idbeans,       500,    30,     0,   150
gkdamp, ihdamp			FLslider	"Damping",				-5,     .05,    0,   5,   iddamp,      500,    30,     0,   200
gktimes,ihtimes			FLslider 	"Number of Times Shaken",		0,       50,    0,   5,   idtimes,     500,    30,     0,   250
gkdecay,ihdecay			FLslider 	"Decay Time (i-rate)",			0,        1,    0,   5,   iddecay,     500,    30,     0,   300

;SET INITIAL VALUES OF FLTK VALUATORS
;				VALUE | HANDLE
		FLsetVal_i	5000, 	ihamp
		FLsetVal_i	1, 	ihfreq
		FLsetVal_i	30, 	ihbeans
		FLsetVal_i	-1, 	ihdamp
		FLsetVal_i	5, 	ihtimes
		FLsetVal_i	0, 	ihdecay

		FLpanel_end

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 240, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                           shaker                            ", 	1,      5,     14,    490,    15,     5,   0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"'shaker' is a semi-physical model of the sound of a maraca   ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"being shaken.                                                ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"'Frequency' controls the resonance of the maraca.            ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"'Number of Beans' should be kept low otherwise a kind of     ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"overloading seems to occur, although low numbers of beans    ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"here does not seem to equate with the sound one would expect.", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"'Damping' appears to control the frequency with which the    ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"maraca is shaken.                                            ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"'Number of Times Shaken' works as expected.                  ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"'Decay Time' appears to have no effect.                      ", 	1,      5,     14,    490,    15,     5, 220

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		instr	1	;(ALWAYS ON - SEE SCORE) PLAYS FILE AND SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS

kSwitch		changed		gkdecay	;GENERATE A MOMENTARY '1' PULSE IN OUTPUT 'kSwitch' IF ANY OF THE SCANNED INPUT VARIABLES CHANGE. (OUTPUT 'kSwitch' IS NORMALLY ZERO)
;				ITRIGGER | IMINTIM | IMAXNUM | IINSNUM | IWHEN | IDUR (-1 MEANS A NOTE OF INFINITE DURATION)
		schedkwhen	kSwitch,      0,        0,        2,        0,    -1	;RESTART INSTRUMENT 2 WITH A SUSTAINED (HELD) NOTE WHENEVER kSwitch=1
		endin

	instr		2
ashaker shaker 		gkamp, gkfreq, gkbeans, gkdamp, gktimes , i(gkdecay)
	outs 		ashaker, ashaker
	endin

</CsInstruments>

<CsScore>
i 1 0 3600	;INSTRUMENT 1 SCANS FOR CHANGES IN SELECTED I-RATE PARAMETERS AND RESTARTS INSTR 2 WHEN THEY OCCUR. THIS INSTRUMENT STATEMENT ALSO SUSTAINS REALTIME PERFORMANCE FOR 1 HOUR
</CsScore>

</CsoundSynthesizer>
