;Written by Iain McCurdy, 2009

<CsoundSynthesizer>

<CsOptions>
;COMMENT OR UNCOMMENT CSOUND FLAGS AS REQUIRED
;-odevaudio -M0 -b400			;EXTERNAL MIDI
-odevaudio -M0 -+rtmidi=virtual -b400	;VIRTUAL MIDI DEVICE
;-odevaudio -b400			;NO MIDI DEVICE
</CsOptions>

<CsInstruments>

sr 		= 	22050	;SAMPLE RATE
kr 		= 	2205	;CONTROL RATE
ksmps 		= 	10	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

		FLcolor		-2	;RANDOMLY COLOURIZE THE INTERFACE
		FLcolor2	-2	;RANDOMLY COLOURIZE THE INTERFACE

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;			LABEL   | WIDTH | HEIGHT | X | Y
		FLpanel	"vibes",   500,    400,    0,  0

;BUTTONS					ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | IDUR
gkOnOff,ihOnOff	FLbutton	"Strike!",	1,    0,     1,    200,     30,    5,  5,    0,      3,      0,       -1

;VALUE DISPLAY BOXES	LABEL  | WIDTH | HEIGHT | X |  Y
idamp		FLvalue	" ",      100,     18,    0,   80
idfreq		FLvalue	" ",      100,     18,    0,  130
idhrd		FLvalue	" ",      100,     18,    0,  180
idpos		FLvalue	" ",      100,     18,    0,  230
idvibf		FLvalue	" ",      100,     18,    0,  280
idvamp		FLvalue	" ",      100,     18,    0,  330
iddec		FLvalue	" ",      100,     18,    0,  380

;SLIDERS				            					MIN | MAX | EXP | TYPE |   DISP     | WIDTH | HEIGHT | X   | Y
gkamp, gihamp			FLslider	"Amplitude",				0,    30000,    0,   5,   idamp,       500,    30,     0,    50
gkfreq, gihfreq			FLslider	"Frequency",				20,   10000,   -1,   5,   idfreq,      500,    30,     0,   100
gkhrd, ihhrd			FLslider	"Stick Hardness",			0,        1,    0,   5,   idhrd,       500,    30,     0,   150
gkpos, ihpos			FLslider	"Strike Position",			0,        1,    0,   5,   idpos,       500,    30,     0,   200
gkvibf,ihvibf			FLslider 	"Vibrato Frequency",			0,       15,    0,   5,   idvibf,      500,    30,     0,   250
gkvamp,ihvamp			FLslider 	"Vibrato Amplitude",			0,        1,    0,   5,   idvamp,      500,    30,     0,   300
gkdec,ihdec			FLslider 	"Decay Time",				0,        5,    0,   5,   iddec,       500,    30,     0,   350

;GENERAL_TEXT_SETTINGS			SIZE | FONT |  ALIGN | RED | GREEN | BLUE
			FLlabel		13,      4,      1,    190,   190,   190		;LABELS MADE INVISIBLE (I.E. SAME COLOR AS PANEL)

;BUTTON BANKS					TYPE | NUMX | NUMY | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | DUR
gkimp, ihimp			FLbutBank	3,      1,      2,    18,      40,   330, 0,   -1

;GENERAL_TEXT_SETTINGS			SIZE | FONT |  ALIGN | RED | GREEN | BLUE
			FLlabel		13,      4,      1,     0,     0,     0			;LABELS MADE VISIBLE AGAIN

;TEXT BOXES						TYPE | FONT | SIZE | WIDTH | HEIGHT | X |  Y
ih		 	FLbox  	"IMPULSE:", 		1,       6,    14,     60,      20,  270,   0
ih		 	FLbox  	"marmstk1  ", 		1,       5,    14,     60,      20,  360,   0
ih		 	FLbox  	"soundscape", 		1,       5,    14,     60,      20,  360,  20

;SET INITIAL VALUES OF FLTK VALUATORS
;				VALUE | HANDLE
		FLsetVal_i	8000, 	gihamp
		FLsetVal_i	250, 	gihfreq
		FLsetVal_i	0.5, 	ihhrd
		FLsetVal_i	0.4, 	ihpos
		FLsetVal_i	0.5, 	ihvibf
		FLsetVal_i	0.8, 	ihvamp
		FLsetVal_i	1, 	ihdec

		FLpanel_end

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 240, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                            vibes                            ", 	1,      5,     14,    490,    15,     5,   0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"'vibes' is a physical model of a vibraphone tone.            ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"'Stick Hardness' and 'Strike Position' create some variation ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"in tone but this is quite subtle.                            ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"'Decay Time' controls the time before the end of the note    ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"when damping is introduced.                                  ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"By replacing the sample suggested for the strike impulse     ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"(marmstk1.wav) with a longer sample, a longer duration tone  ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"is possible.                                                 ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"This instrument can be triggered either from the FLTK button ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"or via a connected MIDI keyboard.                            ", 	1,      5,     14,    490,    15,     5, 220

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

gimp1	ftgen	1,0,1024,1,"marmstk1.wav",0,0,0
gimp2	ftgen	2,0,1048576,1,"Songpan.wav",0,0,1
givibfn	ftgen	0,0,4096,10,1			;A SINE WAVE

instr		1	;MIDI ACTIVATED INSTRUMENT
	ifreq	cpsmidi		;FREQUENCY IS READ FROM INCOMING MIDI NOTE
	iamp	ampmidi	8000	;AMPLITUDE IS READ FROM INCOMING MIDI NOTE
	FLsetVal_i	iamp, gihamp	;SEND AMPLITUDE VALUE TO AMPLITUDE SLIDER
	FLsetVal_i	ifreq, gihfreq	;SEND FREQUENCY VALUE TO FREQUENCY SLIDER
	a1,a2	subinstr 3		;CALL INSTRUMENT 2 AS A SUB-INSTRUMENT. OUTPUT ARGUMENTS WILL BE THE AUDIO OUTS OF CALLED INSTRUMENT
	aenv	linsegr	1,3600,1,0.1,0	;CREATE AN AMPLITUDE ENVELOPE. THIS WILL BE USED TO PREVENT CLICKS.
		outs 		a1*aenv, a2*aenv	;SEND AUDIO TO OUTPUTS
endin


instr	2	;(ALWAYS ON - SEE SCORE) PLAYS FILE AND SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS
	
	kSwitch		changed		gkhrd, gkpos, gkdec	;GENERATE A MOMENTARY '1' PULSE IN OUTPUT 'kSwitch' IF ANY OF THE SCANNED INPUT VARIABLES CHANGE. (OUTPUT 'kSwitch' IS NORMALLY ZERO)
	;				ITRIGGER | IMINTIM | IMAXNUM | IINSNUM | IWHEN | IDUR (-1 MEANS A NOTE OF INFINITE DURATION)
			schedkwhen	kSwitch,      0,        0,        3,        0,    -1	;RESTART INSTRUMENT 3 WITH A SUSTAINED (HELD) NOTE WHENEVER kSwitch=1
endin

instr		3	;VIBES INSTRUMENT
	imp	=		i(gkimp)+1
	ares 	vibes 		i(gkamp), i(gkfreq), i(gkhrd), i(gkpos), imp, gkvibf, gkvamp, givibfn, i(gkdec)
		outs 		ares, ares
endin

</CsInstruments>

<CsScore>
i 2 0 3600	;INSTRUMENT 1 SCANS FOR CHANGES IN SELECTED I-RATE PARAMETERS AND RESTARTS INSTR 2 WHEN THEY OCCUR. THIS INSTRUMENT STATEMENT ALSO SUSTAINS REALTIME PERFORMANCE FOR 1 HOUR
</CsScore>

</CsoundSynthesizer>
