;Written by Iain McCurdy, 2009

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	441	;CONTROL RATE
ksmps 		= 	100	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;			LABEL       | WIDTH | HEIGHT | X | Y
		FLpanel	"wgpluck",     500,    500,    0,  0

;BUTTONS						ON | OFF | TYPE | WIDTH | HEIGHT |  X | Y | OPCODE | INS | STARTTIM | DUR
gkInput,ihInput		FLbutton	"Noise Burst",	1,    1,    1,     150,     30,    10,  10,    0,     2,      0,      -1
gkInput,ihInput		FLbutton	"Sound File",	2,    0,    2,     150,     30,   170,  10,    0,     2,      0,      -1
gkInput,ihInput		FLbutton	"Sine Burst",	3,    3,    1,     150,     30,   330,  10,    0,     2,      0,      -1
gkInput,ihInput		FLbutton	"Sine Tone",	4,    0,    2,     150,     30,   170,  40,    0,     2,      0,      -1


;VALUE DISPLAY BOXES	LABEL  | WIDTH | HEIGHT | X |  Y
idplk		FLvalue	" ",      100,     18,    0,  130
idpick		FLvalue	" ",      100,     18,    0,  180
iddamp		FLvalue	" ",      100,     18,    0,  230
idcps		FLvalue	" ",      100,     18,    0,  280
idamp		FLvalue	" ",      100,     18,    0,  330
idfilt		FLvalue	" ",      100,     18,    0,  380
idImplsGain	FLvalue	" ",      100,     18,    0,  430
idOutGain	FLvalue	" ",      100,     18,    0,  480

;SLIDERS				            				MIN |   MAX   | EXP | TYPE |   DISP         | WIDTH | HEIGHT | X  | Y
gkNseDur, gihNseDur		FLslider	"Duration",			0.1,      2,     0,    3,       -1,            150,    12,    10,    40
gkSineDur, gihSineDur		FLslider	"Duration",			0.1,      2,     0,    3,       -1,            150,    12,   330,    40
gkSineFrq, gihSineFrq		FLslider	"Frequency",			20,    8000,    -1,    3,       -1,            150,    12,   330,    70
gkSineTFrq, gihSineTFrq		FLslider	"Frequency",			20,    8000,    -1,    3,       -1,            150,    12,   170,    70
gkplk, gihplk			FLslider	"Pluck Position (i-rate)",	0,        1,     0,    5,    idplk,            500,    30,     0,   100
gkpick, gihpick			FLslider	"Pick-up Position (k-rate)",	0,   .99999,     0,    5,    idpick,           500,    30,     0,   150
gkdamp, gihdamp			FLslider	"Damping",			0,     1000,     0,    5,    iddamp,           500,    30,     0,   200
gkcps, gihcps			FLslider	"Pitch in CPS",			5,     7000,    -1,    5,    idcps,            500,    30,     0,   250
gkamp, gihamp			FLslider	"Amplitude",			0,    32768,     0,    5,    idamp,            500,    30,     0,   300
gkfilt, gihfilt			FLslider	"Filter",			0,     2000,     0,    5,    idfilt,           500,    30,     0,   350
gkImplsGain, gihImplsGain	FLslider	"Impulse Gain",			0,        1,     0,    5,    idImplsGain,      500,    30,     0,   400
gkOutGain, gihOutGain		FLslider	"Output Gain",			0,        1,     0,    5,    idOutGain,        500,    30,     0,   450

;SET INITIAL VALUES OF FLTK VALUATORS
;				VALUE | HANDLE
		FLsetVal_i	.98, 	gihplk
		FLsetVal_i	.1, 	gihpick
		FLsetVal_i	20, 	gihdamp
		FLsetVal_i	300, 	gihcps
		FLsetVal_i	0.5, 	gihamp
		FLsetVal_i	1000, 	gihfilt
		FLsetVal_i	0.15, 	gihImplsGain
		FLsetVal_i	0.15, 	gihOutGain
		FLsetVal_i	0.3, 	gihNseDur
		FLsetVal_i	0.3, 	gihSineDur
		FLsetVal_i	300, 	gihSineFrq
		FLsetVal_i	300, 	gihSineTFrq
		FLsetVal_i	0, 	ihInput

		FLpanel_end

;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 640, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                         wgpluck                             ", 	1,      5,     14,    490,    15,     5,   0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"wgpluck produces a simulation of a plucked string using      ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"interpolating delay lines and is based on the Karpluss-Strong", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"plucked string model.                                        ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"It takes an audio signal as an input with which to excite the", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"string although even if this exitation signal is silence a   ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"plucked string sound is still produced. Nonetheless, the     ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"exitation signal does still influence the sound produced.    ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"'Damping' and 'Filter' both have an impact on the tone       ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"produced. 'Damping' has a more marked influence on the sound ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"produced and also has the effect of shorting the duration of ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"the note.                                                    ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"'Pick-up Position' is the only parameter that can be         ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"modulated at k-rate.                                         ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"I have included gain controls on the exitation signal and on ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"the output signal of the opcode.                             ", 	1,      5,     14,    490,    15,     5, 320
ih		 	FLbox  	"A variety of short burst and sustained signals are offered.  ", 	1,      5,     14,    490,    15,     5, 340
ih		 	FLbox  	"A short burst of pink noise, a short sine tone burst whose   ", 	1,      5,     14,    490,    15,     5, 360
ih		 	FLbox  	"frequency can be modulated, a sound file and a sustained sine", 	1,      5,     14,    490,    15,     5, 380
ih		 	FLbox  	"tone.                                                        ", 	1,      5,     14,    490,    15,     5, 400
ih		 	FLbox  	"'Amplitude' controls the amplitude of the sound of the       ", 	1,      5,     14,    490,    15,     5, 420
ih		 	FLbox  	"plucked string. Low values will not result in silence at the ", 	1,      5,     14,    490,    15,     5, 440
ih		 	FLbox  	"output but instead a greater predominance of the exitation   ", 	1,      5,     14,    490,    15,     5, 460
ih		 	FLbox  	"signal.                                                      ", 	1,      5,     14,    490,    15,     5, 480
ih		 	FLbox  	"'Pick-up Position' allows the user to vary the location of   ", 	1,      5,     14,    490,    15,     5, 500
ih		 	FLbox  	"the pick-up along the length of the string. A value of 0.5   ", 	1,      5,     14,    490,    15,     5, 520
ih		 	FLbox  	"here represents the half-way point along the string, zero and", 	1,      5,     14,    490,    15,     5, 540
ih		 	FLbox  	"1 represent either end of the string. Zero and 1 will        ", 	1,      5,     14,    490,    15,     5, 560
ih		 	FLbox  	"accentuate the higher harmonics (as the output is a harmonic ", 	1,      5,     14,    490,    15,     5, 580
ih		 	FLbox  	"sound) and 0.5 will favour the odd numbered harmonics,       ", 	1,      5,     14,    490,    15,     5, 600
ih		 	FLbox  	"producing a clarinet-like tone.                              ", 	1,      5,     14,    490,    15,     5, 620

		FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

gisine	ftgen	0,0,1024,10,1	;A SINE WAVE

instr	1	;(ALWAYS ON - SEE SCORE) SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS
	kSwitch	changed	gkcps, gkamp, gkplk, gkdamp, gkfilt	;GENERATE A MOMENTARY '1' PULSE IN OUTPUT 'kSwitch' IF ANY OF THE SCANNED INPUT VARIABLES CHANGE. (OUTPUT 'kSwitch' IS NORMALLY ZERO)
	;				ITRIGGER | IMINTIM | IMAXNUM | IINSNUM | IWHEN | IDUR (-1 MEANS A NOTE OF INFINITE DURATION)
			schedkwhen	kSwitch,      0,        0,        2,   0,     -1	;RESTART INSTRUMENT 2 WITH A SUSTAINED (HELD) NOTE WHENEVER kSwitch=1
endin

instr		2
	if	gkInput==0	then	;IF gkInput=0, I.E. ALL ON/OFF BUTTONS ARE OFF...
		turnoff			;...TURN OFF THIS INSTRUMENT IMMEDIATELY
	endif				;END OF CONDITIONAL BRANCH
	iporttime	=	0.1				;PORTAMENTO TIME
	kporttime	linseg	0,0.01,iporttime,1,iporttime	;PORTAMENTO TIME VARIABLE THAT RAMPS UP FROM ZERO
	kpick		portk	gkpick, kporttime		;APPLY PORTAMENTO TO 'PICK-UP POSITION' VARIABLE (PREVENTS 'ZIP' NOISE)
	kSineTFrq	portk	gkSineTFrq, kporttime		;APPLY PORTAMENTO TO 'SINE TONE FREQUENCY' VARIABLE (MAKES MODULATION SMOOTHER)

	if	gkInput==1	then					;IF gkinput=1, I.E. IF 'NOISE BURST' IS SELECTED...
		kenv	expseg		1,i(gkNseDur),.00001,1,.00001	;CREATE AN AMPLITUDE ENVELOPE FOR THE NOISE BURST
		axcite	pinkish		32768*kenv			;CREATE A PINK NOISE SIGNAL
	elseif	gkInput==2	then					;IF gkinput=2, I.E. IF 'SOUND FILE' IS SELECTED...
		axcite, aR	diskin2		"Songpan.wav",1,0,1	;CREATE AN AUDIO SIGNAL FROM A FILE STORED ON DISK. RIGHT CHANNEL WILL BE IGNORED. SOUND WILL PLAY FROM THE BEGINNING AND WILL LOOP CONTINUOUSLY
	elseif	gkInput==3	then					;IF gkinput=3, I.E. IF 'SINE TONE' IS SELECTED...
		kenv	expseg		1,i(gkSineDur),.00001,1,.00001	;CREATE AN AMPLITUDE ENVELOPE FOR THE SINE BURST
		axcite		oscili	32768*kenv, gkSineFrq, gisine	;CREATE A SINE TONE, FREQUENCY TAKEN FROM FLTK SLIDER
	elseif	gkInput==4	then					;IF gkinput=4, I.E. IF 'SINE BURST' IS SELECTED...
		axcite		oscili	32768, kSineTFrq, gisine	;CREATE A SINE TONE
	endif
	;OUTPUT	OPCODE		INPUT ARGS...
	ares	wgpluck 	i(gkcps), i(gkamp), kpick, i(gkplk), i(gkdamp), i(gkfilt), axcite * gkImplsGain	;WGPLUCK. NOTE EXCITATION SIGNAL SCALED BY gkImplsGain WHICH IS CREATED BY AN FLTK SLIDER
		outs 		ares * gkOutGain, ares * gkOutGain	;SEND AUDIO TO OUTPUTS, SCALE OUTPUT BY gkOutGain WHICH IS CREATED BY AN FLTK SLIDER
endin

</CsInstruments>

<CsScore>
i 1 0 3600	;INSTRUMENT 1 SCANS FOR CHANGES IN SELECTED I-RATE PARAMETERS AND RESTARTS INSTR 2 WHEN THEY OCCUR. THIS INSTRUMENT STATEMENT ALSO SUSTAINS REALTIME PERFORMANCE FOR 1 HOUR
</CsScore>

</CsoundSynthesizer>