;Written by Iain McCurdy, 2006

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	441	;CONTROL RATE
ksmps 		= 	100	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)


;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;					LABEL   | WIDTH | HEIGHT | X | Y
				FLpanel	"vcomb", 500,    200,    0,  0
 
;SWITCHES                       				ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | IDUR
gkOnOff,ihOnOff			FLbutton	"On/Off",	1,   -1,    2,     150,     30,    0,   0,    0,     1,      0,       -1

;VALUE DISPLAY BOXES			LABEL  | WIDTH | HEIGHT | X | Y
idlpt				FLvalue	" ",      100,     20,    0,  80
idrvt				FLvalue	" ",      100,     20,    0, 130
idamp				FLvalue	" ",      100,     20,    0, 180

;SLIDERS					            			MIN | MAX | EXP | TYPE |  DISP   | WIDTH | HEIGHT | X   | Y
gklpt,ihlpt			FLslider 	"Loop Time",			.0001, .1,  -1,    5,    idlpt,     500,     30,    0,    50
gkrvt,ihrvt			FLslider 	"Reverb Time",			.0001, 10,  -1,    5,    idrvt,     500,     30,    0,   100
gkamp,ihamp			FLslider 	"Output Amplitude Scaling",	0,      1,   0,    5,    idamp,     500,     30,    0,   150

;SET INITIAL VALUES OF FLTK VALUATORS
;						VALUE | HANDLE
				FLsetVal_i	.0025, 	ihlpt
				FLsetVal_i	.2, 	ihrvt
				FLsetVal_i	.7, 	ihamp
			
				FLpanel_end
;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 600, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                            vcomb                            ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"Vcomb implements a comb filtering effect on an audio input.  ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"This is described in the manual as 'coloured reverb'.        ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"In effect the comb filter is simply a delay with a feedback  ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"loop as illustrated below:                                   ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"                         +-----+                             ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"            INPUT-->--+--+DELAY+---+-->OUTPUT                ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"                      |  +-----+   |                         ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"                      |            |                         ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"                      +-[FEEDBACK]-+                         ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"                                                             ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"Delay time is expressed as 'Loop Time' in the context of this", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"opcode but it is effectively the same thing as delay time.   ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"A ratio for the amount of feedback is not directly accessible", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"but instead the user defines a value for 'Reverb Time' which ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"is the time it will take for an impulse's reverberant tail to", 	1,      5,     14,    490,    15,     5, 320
ih		 	FLbox  	"decay to 1/1000 of its initial strength (a 60 dB drop).      ", 	1,      5,     14,    490,    15,     5, 340
ih		 	FLbox  	"The use of feedback can create dramatic rises in output      ", 	1,      5,     14,    490,    15,     5, 360
ih		 	FLbox  	"amplitude, therefore in this example I have included a slider", 	1,      5,     14,    490,    15,     5, 380
ih		 	FLbox  	"that controls output amplitude.                              ", 	1,      5,     14,    490,    15,     5, 400
ih		 	FLbox  	"Vcomb produces an audible transformation similar to the      ", 	1,      5,     14,    490,    15,     5, 420
ih		 	FLbox  	"'wguide1' and 'streson' opcodes but as it lacks any lowpass  ", 	1,      5,     14,    490,    15,     5, 440
ih		 	FLbox  	"filtering within its algorithm it produces a sharper sound.  ", 	1,      5,     14,    490,    15,     5, 460
ih		 	FLbox  	"Vcomb differs from the 'comb' opcode in that it allows the   ", 	1,      5,     14,    490,    15,     5, 480
ih		 	FLbox  	"user to vary the 'Loop Time' parameter at rates other than   ", 	1,      5,     14,    490,    15,     5, 500
ih		 	FLbox  	"i-rate. Because of this vcomb takes an additional input      ", 	1,      5,     14,    490,    15,     5, 520
ih		 	FLbox  	"argument in which the user must declare the maximum 'Loop    ", 	1,      5,     14,    490,    15,     5, 540
ih		 	FLbox  	"Time that the opcode should expect (for memory allocation    ", 	1,      5,     14,    490,    15,     5, 560
ih		 	FLbox  	"purposes).                                                   ", 	1,      5,     14,    490,    15,     5, 580

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		instr	1
if	gkOnOff!=-1	goto	CONTINUE 	;SENSE FLTK ON/OFF SWITCH, IF STATUS=ON JUMP TO 'CONTINUE' LABEL
			turnoff			;TURNOFF THIS INSTRUMENT IMMEDIATELY
CONTINUE:					;A LABEL CALLED 'CONTINUE' - JUMP TO HERE IF ON/OFF SWITCH IS 'ON'
;OUTPUTS	OPCODE	FILE           | SPEED | INSKIP | LOOPING (0=OFF 1=ON)
gasigL, gasigR	diskin2	"Seashore.wav",    1,       0,         1	;GENERATE 2 AUDIO SIGNALS FROM A STEREO SOUND FILE (NOTE THE USE OF GLOBAL VARIABLES)	
		endin	

		instr	2
;OUTPUT		OPCODE | INPUT | REVERB_TIME | LOOP_TIME_(DELAY_TIME) | MAXIMUM_LOOP_TIME
aresL 		vcomb	gasigL,     gkrvt,         gklpt,                  .1 
aresR 		vcomb	gasigR,     gkrvt,         gklpt,                  .1 
		outs	aresL * gkamp, aresR * gkamp	;SEND vcomb OUTPUT TO THE AUDIO OUTPUTS AND SCALE USING THE FLTK SLIDER VARIABLE gkamp
gasigL		=	0	;GLOBAL AUDIO VARIABLE IS RESET TO ZERO (TO PREVENT, FROZEN NON-ZERO VALUES WHEN INSTRUMENT 1 IS SWITCHED OFF)
gasigR		=	0	;GLOBAL AUDIO VARIABLE IS RESET TO ZERO (TO PREVENT, FROZEN NON-ZERO VALUES WHEN INSTRUMENT 1 IS SWITCHED OFF)
  		endin
  	
</CsInstruments>

<CsScore>
;INSTR | START | DURATION
i  2       0       3600	;INSTRUMENT 1 PLAYS FOR 1 HOUR
</CsScore>

</CsoundSynthesizer>