<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	4410	;CONTROL RATE
ksmps 		= 	10	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;				LABEL                       | WIDTH | HEIGHT | X | Y
			FLpanel	"White Noise / Pink Noise",    500,    255,    0,  0

;BORDERS				TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	" ", 	6,      9,     15,    490,    145,    5,  5
ih		 	FLbox  	" ", 	6,      9,     15,    490,     95,    5,155

;SWITCHES  	                                  		ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | DUR
gkwhite, ihwhite		FLbutton	"White Noise",	1,   -1,    2,     150,     30,    10, 10,    0,     1,      0,       -1
gkpink, ihpink			FLbutton	"Pink Noise",	1,   -1,    2,     150,     30,    10,160,    0,     2,      0,       -1

;VALUE DISPLAY BOXES		LABEL  | WIDTH | HEIGHT | X | Y
idwhiteamp		FLvalue	" ",      100,     20,   10,  75
idbeta			FLvalue	" ",      100,     20,   10, 125
idpinkamp		FLvalue	" ",      100,     20,   10, 225

;SLIDERS				            		MIN | MAX | EXP | TYPE |    DISP   | WIDTH | HEIGHT | X  | Y
gkwhiteamp, ihwhiteamp		FLslider 	"Amplitude",	0,   30000,  0,    5,   idwhiteamp,   480,     30,   10,   45
gkbeta, ihbeta			FLslider 	"Beta",		0,     1,    0,    5,       idbeta,   480,     30,   10,   95
gkpinkamp, ihpinkamp		FLslider 	"Amplitude",	0,   30000,  0,    5,    idpinkamp,   480,     30,   10,  195

;SET INITIAL VALUES FOR SLIDERS 	|VALUE | HANDLE
			FLsetVal_i	0, 	ihbeta
			FLsetVal_i	30000, 	ihwhiteamp
			FLsetVal_i	30000, 	ihpinkamp

				FLpanel_end

;INSTRUCTIONS AND INFO PANEL                 WIDTH | HEIGHT | X | Y
				FLpanel	" ", 500,     120,   512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                white noise / pink noise                     ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"This example demonstrates the opcodes 'noise' and 'pinkish'  ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"which might form useful sources sounds for subtractive       ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"synthesis.                                                   ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"Noise produces white noise and pinkish produces pink noise.  ", 	1,      5,     14,    490,    15,     5, 100

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	instr	1	;WHITE NOISE
if	gkwhite!=-1	goto	CONTINUE	;SENSE FLTK ON/OFF SWITCH FOR 'WHITE NOISE' - IF 'ON' JUMP TO LABEL 'CONTINUE'
			turnoff			;TURN THIS INSTRUMENT OFF IMMEDIATELY
CONTINUE:					;LABEL 'CONTINUE'
asig 	noise 	gkwhiteamp, gkbeta	;GENERATE WHITE NOISE
	outs	asig, asig		;SEND AUDIO SIGNAL TO OUTPUTS
	endin

	instr	2	;PINK NOISE
if	gkpink!=-1	goto	CONTINUE	;SENSE FLTK ON/OFF SWITCH FOR 'PINK NOISE' - IF 'ON' JUMP TO LABEL 'CONTINUE'
			turnoff			;TURN THIS INSTRUMENT OFF IMMEDIATELY
CONTINUE:					;LABEL 'CONTINUE'
asig	pinkish	gkpinkamp     	;GENERATE PINK NOISE
	outs	asig, asig	;SEND AUDIO SIGNAL TO OUTPUTS
	endin

</CsInstruments>

<CsScore>
f 0 3600	;DUMMY SCORE EVENT - ALLOWS REALTIME PERFORMANCE FOR 1 HOUR
</CsScore>

</CsoundSynthesizer>
