;Written by Iain McCurdy, 2006

<CsoundSynthesizer>

<CsOptions>
-idevaudio -odevaudio -b400
</CsOptions>


<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	441	;CONTROL RATE
ksmps 		= 	100	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)

;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		LABEL   | WIDTH | HEIGHT | X | Y
	FLpanel	"bbcut",   500,    250,    0,  0

;SWITCHES  	                                  	ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | DUR
gkOnOff,ihOnOff	FLbutton	"On/Off",		1,   -1,     2,    150,     30,    0,  0,     0,     2,      0,      -1

;COUNTERS						MIN | MAX | STEP1 | STEP2 | TYPE | WIDTH | HEIGHT | X | Y | OPCODE
gksubdiv,ihsubdiv 	FLcount  "Sub-division", 	1,    512,     1,      4,      1,    150,     25,     0,  50,   -1
gkbarlen,ihbarlen 	FLcount  "Bar Length", 		1,     16,   .25,      1,      1,    150,     25,   175,  50,   -1
gkphrase,ihphrase 	FLcount  "Phrase", 		.1,   512,   .25,      1,      1,    150,     25,   350,  50,   -1
gkrepeats,ihrepeats 	FLcount  "Repeats", 		1,     32,     1,      4,      1,    150,     25,     0, 100,   -1
gkstutspd,ihstutspd 	FLcount  "Stutter Speed", 	1,     32,   .25,      1,      1,    150,     25,   175, 100,   -1
gkstutchnc,ihstutchnc 	FLcount  "Stutter Chance", 	0,      1,   .25,      1,      1,    150,     25,   350, 100,   -1
gkBPM,ihBPM 		FLcount  "BPM", 		20,   500,     1,     10,      1,    150,     25,     0, 150,   -1

;GENERAL_TEXT_SETTINGS			SIZE | FONT |  ALIGN | RED | GREEN | BLUE
			FLlabel		13,      1,       1,   190,   190,   190		;NUMBERS MADE INVISIBLE

;			FLBUTBANK 	TYPE | NUMX | NUMY | WIDTH | HEIGHT | X | Y | OPCODE
gkinput,   ihinput	FLbutBank	12,     1,     2,     30,    50,      0, 200,   -1

;GENERAL_TEXT_SETTINGS			SIZE | FONT |  ALIGN | RED | GREEN | BLUE
			FLlabel		13,      5,      4,     0,     0,     0			;LABELS MADE VISIBLE AGAIN

;TEXT BOXES						TYPE | FONT | SIZE | WIDTH | HEIGHT | X |  Y
ih		 	FLbox  	"Live Input", 		1,       2,    12,    70,      25,   30,  200
ih		 	FLbox  	"Stored File", 		1,       2,    12,    70,      25,   30,  225

;SET INITIAL VALUES FOR SLIDERS 	|VALUE | HANDLE
			FLsetVal_i	8, 	ihsubdiv
			FLsetVal_i	2, 	ihbarlen
			FLsetVal_i	8, 	ihphrase
			FLsetVal_i	2, 	ihrepeats
			FLsetVal_i	4, 	ihstutspd
			FLsetVal_i	1, 	ihstutchnc
			FLsetVal_i	110, 	ihBPM
			FLsetVal_i	1, 	ihinput

	FLpanel_end

;INSTRUCTIONS AND INFO PANEL                 WIDTH | HEIGHT | X | Y
				FLpanel	" ", 515,      700,  512, 0
				FLscroll     515,      700,    0, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                      bbcutm/bbcuts                          ", 	1,      5,     14,    490,    15,     5,  0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"bbcutm/bbcuts performs break-beat style cut-ups upon an input", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"audio signal. (bbcutm/bbcuts represents mono and stereo      ", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"versions of the same basic algorithm.)                       ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"In order to create rhythmically precise cut-ups it is        ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"necessary for the input audio loop to begin at the same time ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"that the opcode is triggered and for the tempo argument given", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"to the bbcuts/bbcutm opcode to correspond to that of the     ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"input loop audio. This requires some planning and in this    ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"example this is implemented by playing the audio loop using  ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"the tablei opcode.                                           ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"Of course there is no reason why bbcutm/bbcutm cannot be     ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"applied to unmetered sound material or even a live input     ", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"signal. This example also provides the option of selecting   ", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"the computer's live input as the sound source. If the live   ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"input is used then the results can be more aleatoric than    ", 	1,      5,     14,    490,    15,     5, 320
ih		 	FLbox  	"rhymical.                                                    ", 	1,      5,     14,    490,    15,     5, 340
ih		 	FLbox  	"Bbcuts/bbcutm takes a variety of input arguments that        ", 	1,      5,     14,    490,    15,     5, 360
ih		 	FLbox  	"determine the precise nature of the cut-ups executed.        ", 	1,      5,     14,    490,    15,     5, 380
ih		 	FLbox  	"'Sub-division' determines the note duration used as the base ", 	1,      5,     14,    490,    15,     5, 400
ih		 	FLbox  	"unit in  cut-ups. For example a value of 8 represents quavers", 	1,      5,     14,    490,    15,     5, 420
ih		 	FLbox  	"(eighth notes), 16 represents semiquavers (sixteenth notes)  ", 	1,      5,     14,    490,    15,     5, 440
ih		 	FLbox  	"and so on.                                                   ", 	1,      5,     14,    490,    15,     5, 460
ih		 	FLbox  	"'Bar Length' represents the number of beats per bar. For     ", 	1,      5,     14,    490,    15,     5, 480
ih		 	FLbox  	"example, a value of 4 represents a 4/4 bar and so on.        ", 	1,      5,     14,    490,    15,     5, 500
ih		 	FLbox  	"'Phrase' defines the number of bars that will elapse before  ", 	1,      5,     14,    490,    15,     5, 520
ih		 	FLbox  	"the cutting up pattern restarts from the beginning.          ", 	1,      5,     14,    490,    15,     5, 540
ih		 	FLbox  	"'Stutter' is a separate cut-up process which occasionally    ", 	1,      5,     14,    490,    15,     5, 560
ih		 	FLbox  	"will take a very short fragment of the input audio and repeat", 	1,      5,     14,    490,    15,     5, 580
ih		 	FLbox  	"it many times. 'Stutter Speed' defines the duration of each  ", 	1,      5,     14,    490,    15,     5, 600
ih		 	FLbox  	"stutter in relation to 'Sub-division'. If subdivision is 8   ", 	1,      5,     14,    490,    15,     5, 620
ih		 	FLbox  	"(quavers / eighth notes) and 'Stutter Speed' is 2 then each  ", 	1,      5,     14,    490,    15,     5, 640
ih		 	FLbox  	"stutter will be a semiquaver / sixteenth note.               ", 	1,      5,     14,    490,    15,     5, 660
ih		 	FLbox  	"'Stutter Chance' defines the frequency of stutter moments.   ", 	1,      5,     14,    490,    15,     5, 680
ih		 	FLbox  	"The range for this parameter is 0 to 1. Zero means stuttering", 	1,      5,     14,    490,    15,     5, 700
ih		 	FLbox  	"will be very unlikely, 1 means it will be very likely.       ", 	1,      5,     14,    490,    15,     5, 720
ih		 	FLbox  	"'Repeats' defines the number of repeats that will be employed", 	1,      5,     14,    490,    15,     5, 740
ih		 	FLbox  	"in normal cut-up events.                                     ", 	1,      5,     14,    490,    15,     5, 760
ih		 	FLbox  	"When processing non-rhythmical, unmetered material it may be ", 	1,      5,     14,    490,    15,     5, 780
ih		 	FLbox  	"be more interesting to employ non-whole numbers for          ", 	1,      5,     14,    490,    15,     5, 800
ih		 	FLbox  	"parameters such as 'Sub-division', 'Phrase' and 'Stutter     ", 	1,      5,     14,    490,    15,     5, 820
ih		 	FLbox  	"Speed'.                                                      ", 	1,      5,     14,    490,    15,     5, 840

				FLscrollEnd
				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	instr	1	;(ALWAYS ON - SEE SCORE) PLAYS FILE AND SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS
kSwitch	changed		gkBPM, gkrepeats, gkphrase, gkstutspd, gkstutchnc, gkbarlen, gksubdiv, gkinput	;GENERATE A MOMENTARY '1' PULSE IN OUTPUT 'kSwitch' IF ANY OF THE SCANNED INPUT VARIABLES CHANGE. (OUTPUT 'kSwitch' IS NORMALLY ZERO)
;				ITRIGGER | IMINTIM | IMAXNUM | IINSNUM | IWHEN | IDUR (-1 MEANS A NOTE OF INFINITE DURATION)
	schedkwhen	kSwitch,    0,        0,        2,        0,      -1	;RESTART INSTRUMENT 2 WITH A SUSTAINED (HELD) NOTE WHENEVER kSwitch=1
	endin	

	instr 2
if	gkOnOff!=-1	goto	CONTINUE	;SENSE FLTK ON/OFF SWITCH
			turnoff	;TURN THIS INSTRUMENT OFF IMMEDIATELY
CONTINUE:

isubdiv		=	i(gksubdiv)
ibarlen		=	i(gkbarlen)
iphrase		=	i(gkphrase)
irepeats	=	i(gkrepeats)
istutspd	=	i(gkstutspd)
istutchnc	=	i(gkstutchnc)
iBPM		=	i(gkBPM)

		if		gkinput==1 then			;IF 'INPUT' SWITCH IS SET TO 'STORED FILE' THEN IMPLEMENT THE NEXT LINE OF CODE
kBarPS		=	gkBPM/240
ifn		=	1
inumbar		=	2
aptr		phasor	kBarPS/inumbar
ain		tablei	aptr*nsamp(ifn), ifn
		else						;IF 'INPUT' SWITCH IS NOT SET TO 'STORED FILE' THEN IMPLEMENT THE NEXT LINE OF CODE
ain, aignore	ins						;READ AUDIO FROM THE COMPUTER'S LIVE INPUT (LEFT INPUT ONLY IS READ, RIGHT CHANNEL IS IGNORED IN SUBSEQUENT CODE. A STEREO VERSION COULD EASILY BE BUILT BUT THIS WOULD DOUBLE CPU DEMANDS!)
		endif						;END OF 'IF'...'THEN' BRANCHING


;OUTPUT		OPCODE	INPUT | BPM    | SUBDIVISION | BAR_LENGTH | PHRASE_LENGTH | NUM.OF_REPEATS | STUTTER_SPEED | STUTTER_CHANCE	
abbcut		bbcutm	ain, iBPM/60, i(gksubdiv),  i(gkbarlen),   i(gkphrase),    i(gkrepeats),   i(gkstutspd),   i(gkstutchnc)
;bbcutm IS THE MONO VERSION OF THE BREAK BEAT CUTTER

		outs	abbcut, abbcut
		endin

</CsInstruments>

<CsScore>
;FUNCTION_TABLE_NUMBER | INIT_TIME | TABLE_SIZE | GEN_ROUTINE |  FILE_PATH  | INSKIP | FORMAT | CHANNEL 
f          1                 0         524289         -1        "loop.wav"       0       4         1
i 1 0 3600
</CsScore>

</CsoundSynthesizer>
