;Written by Iain McCurdy, 2006

<CsoundSynthesizer>

<CsOptions>
-odevaudio -b400
</CsOptions>

<CsInstruments>

sr 		= 	44100	;SAMPLE RATE
kr 		= 	441	;CONTROL RATE
ksmps 		= 	100	;NUMBER OF AUDIO SAMPLES IN EACH CONTROL CYCLE
nchnls 		= 	2	;NUMBER OF CHANNELS (2=STEREO)


;FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;					LABEL   | WIDTH | HEIGHT | X | Y
				FLpanel	"wguide1", 500,    250,    0,  0
 
;SWITCHES                       				ON | OFF | TYPE | WIDTH | HEIGHT | X | Y | OPCODE | INS | STARTTIM | IDUR
gkOnOff,ihOnOff			FLbutton	"On/Off",	1,  -1,     2,    150,     30,    0,   0,    0,      1,     0,        -1

;VALUE DISPLAY BOXES			LABEL  | WIDTH | HEIGHT | X | Y
idfreq				FLvalue	" ",      100,     20,    0,  80
idcutoff			FLvalue	" ",      100,     20,    0, 130
idfeedback			FLvalue	" ",      100,     20,    0, 180
idamp				FLvalue	" ",      100,     20,    0, 230

;SLIDERS					            			MIN | MAX | EXP | TYPE |     DISP   | WIDTH | HEIGHT | X   | Y
gkfreq,ihfreq			FLslider 	"Frequency",			20,  10000, -1,    5,      idfreq,     500,      30,   0,    50
gkcutoff,ihcutoff		FLslider 	"LPF Cutoff Frequency",		20,  20000, -1,    5,      idcutoff,   500,      30,   0,   100
gkfeedback,ihfeedback		FLslider 	"Feedback",			0,    .999,  0,    5,      idfeedback, 500,      30,   0,   150
gkamp,ihamp			FLslider 	"Output Amplitude Scaling",	0,       1,  0,    5,      idamp,      500,      30,   0,   200

;SET INITIAL VALUES OF FLTK VALUATORS
;						VALUE | HANDLE
				FLsetVal_i	400, 	ihfreq
				FLsetVal_i	10000, 	ihcutoff
				FLsetVal_i	.9, 	ihfeedback
				FLsetVal_i	.7, 	ihamp
			
				FLpanel_end
;INSTRUCTIONS AND INFO PANEL
				FLpanel	" ", 500, 580, 512, 0
;TEXT BOXES												TYPE | FONT | SIZE | WIDTH | HEIGHT | X | Y
ih		 	FLbox  	"                           wguide1                           ", 	1,      5,     14,    490,    15,     5,   0
ih		 	FLbox  	"-------------------------------------------------------------", 	1,      5,     14,    490,    15,     5,  20
ih		 	FLbox  	"Wguide1 implements a delay and first order lowpass filter    ", 	1,      5,     14,    490,    15,     5,  40
ih		 	FLbox  	"with feedback in a single unit opcode. This arrangement is as", 	1,      5,     14,    490,    15,     5,  60
ih		 	FLbox  	"shown below:                                                 ", 	1,      5,     14,    490,    15,     5,  80
ih		 	FLbox  	"                +-----+  +--------------+                    ", 	1,      5,     14,    490,    15,     5, 100
ih		 	FLbox  	"        IN->-+->+DELAY+->+LOWPASS FILTER+->+--->OUT          ", 	1,      5,     14,    490,    15,     5, 120
ih		 	FLbox  	"             ^  +-----+  +--------------+  |                 ", 	1,      5,     14,    490,    15,     5, 140
ih		 	FLbox  	"             |                             |                 ", 	1,      5,     14,    490,    15,     5, 160
ih		 	FLbox  	"             +-----<-----[FEEDBACK]<-------+                 ", 	1,      5,     14,    490,    15,     5, 180
ih		 	FLbox  	"Delay time is not directly addressed as delay time are       ", 	1,      5,     14,    490,    15,     5, 200
ih		 	FLbox  	"expected to be small thus producing a comb filtering effect. ", 	1,      5,     14,    490,    15,     5, 220
ih		 	FLbox  	"Instead the frequency of the tone produced by this comb      ", 	1,      5,     14,    490,    15,     5, 240
ih		 	FLbox  	"filtering effect is given to the opcode. (Delay time could be", 	1,      5,     14,    490,    15,     5, 260
ih		 	FLbox  	"derived as 1/freq.) The minimum allowed value for 'Frequency'", 	1,      5,     14,    490,    15,     5, 280
ih		 	FLbox  	"is 5 hertz, this translates as a delay time of .2 second.    ", 	1,      5,     14,    490,    15,     5, 300
ih		 	FLbox  	"'Feedback' is expressed as a ratio of the entire signal. A   ", 	1,      5,     14,    490,    15,     5, 320
ih		 	FLbox  	"value of 0 means that none of the signal will be fed back    ", 	1,      5,     14,    490,    15,     5, 340
ih		 	FLbox  	"into the system, a value of 1 means that all of the signal   ", 	1,      5,     14,    490,    15,     5, 360
ih		 	FLbox  	"will be fed back into the system.                            ", 	1,      5,     14,    490,    15,     5, 380
ih		 	FLbox  	"The use of feedback can create dramatic rises in output      ", 	1,      5,     14,    490,    15,     5, 400
ih		 	FLbox  	"amplitude, therefore in this example I have included a slider", 	1,      5,     14,    490,    15,     5, 420
ih		 	FLbox  	"that controls output amplitude.                              ", 	1,      5,     14,    490,    15,     5, 440
ih		 	FLbox  	"Wguide's audible result is comparable to that of the         ", 	1,      5,     14,    490,    15,     5, 460
ih		 	FLbox  	"'streson' opcode.                                            ", 	1,      5,     14,    490,    15,     5, 480
ih		 	FLbox  	"Note that tuning inaccuracies are increasingly exhibited as  ", 	1,      5,     14,    490,    15,     5, 500
ih		 	FLbox  	"'Frequency' is increased. If precise tuning is required then ", 	1,      5,     14,    490,    15,     5, 520
ih		 	FLbox  	"it will probably not be suffucient to rely on the value given", 	1,      5,     14,    490,    15,     5, 540
ih		 	FLbox  	"for 'Frequency' and instead this should be checked by ear.   ", 	1,      5,     14,    490,    15,     5, 560

				FLpanel_end

				FLrun	;RUN THE FLTK WIDGET THREAD
;END OF FLTK INTERFACE CODE;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		instr	1	;(ALWAYS ON - SEE SCORE) PLAYS FILE AND SENSES FADER MOVEMENT AND RESTARTS INSTR 2 FOR I-RATE CONTROLLERS
if		gkOnOff!=-1	goto	CONTINUE 	;SENSE FLTK ON/OFF SWITCH, IF STATUS=ON JUMP TO 'CONTINUE' LABEL
		turnoff					;TURNOFF THIS INSTRUMENT IMMEDIATELY
CONTINUE:						;A LABEL CALLED 'CONTINUE' - JUMP TO HERE IF ON/OFF SWITCH IS 'ON'
;OUTPUTS	OPCODE	FILE           | SPEED | INSKIP | LOOPING (0=OFF 1=ON)
gasigL, gasigR	diskin2	"Seashore.wav",    1,       0,         1	;GENERATE 2 AUDIO SIGNALS FROM A STEREO SOUND FILE (NOTE THE USE OF GLOBAL VARIABLES)
		endin
		
		instr	2
;OUTPUT		OPCODE | INPUT | DELAY/COMB_FREQ | LPF_CUTOFF_FREQ | FEEDBACK_RATIO
aresL 		wguide1 gasigL,       gkfreq,         gkcutoff,       gkfeedback
aresR 		wguide1 gasigR,       gkfreq,         gkcutoff,       gkfeedback

		outs	aresL * gkamp, aresR * gkamp	;SEND wguide OUTPUT TO THE AUDIO OUTPUTS AND SCALE USING THE FLTK SLIDER VARIABLE gkamp
gasigL		=	0	;GLOBAL AUDIO VARIABLE IS RESET TO ZERO (TO PREVENT, FROZEN NON-ZERO VALUES WHEN INSTRUMENT 1 IS SWITCHED OFF)
gasigR		=	0	;GLOBAL AUDIO VARIABLE IS RESET TO ZERO (TO PREVENT, FROZEN NON-ZERO VALUES WHEN INSTRUMENT 1 IS SWITCHED OFF)
  		endin
  	
</CsInstruments>

<CsScore>
;INSTR | START | DURATION
i  2       0       3600	;INSTRUMENT 2 PLAYS FOR 1 HOUR (AND KEEPS REALTIME PERFORMANCE GOING)
</CsScore>

</CsoundSynthesizer>