<CsoundSynthesizer>
<CsOptions>
</CsOptions>

<CsInstruments>
;A Long Walk Off a Short Pier
;by Adam Zygmunt
;
;pier.orc Csound orchestra file
;
;copyright 1997

sr=44100
kr=441
ksmps=100
nchnls=2

instr 1  ;bell

idur=p3
iamp=ampdb(p4)
ipitch1=cpsoct(p5)
ipitch2=cpsoct(p6)
ivib=p7
ipan=p8/2+.5  ;-1<p8<1
ifn=p9

kpitch expseg ipitch1, idur, ipitch2  ;gliss
kenv1 expon iamp, idur, 1
kenv2 expon iamp, idur*.75, 1

a1 oscil kenv1, kpitch, ifn
a2 oscil kenv1, kpitch+ivib, ifn
a3 oscil kenv2, kpitch*2.5, ifn
a4 oscil kenv1, kpitch*4.3, ifn
a5 oscil kenv2, kpitch*10.7, ifn
amix=(a1*.3+a2*.3+a3*.2+a4*.1+a5*.1)*3
outs ipan*amix, (1-ipan*amix)

endin


instr 2  ;full

idur=p3
iamp=ampdb(p4)
ipitch=cpsoct(p5)
iatt=p6
idec=p7
ivibr=p8
ivibd=p9
ifn=p10

kenv linen iamp, iatt*idur, idur, idec*idur
a1 oscil kenv, ipitch*.95, ifn
a2 oscil kenv, ipitch*.96, ifn
a3 oscil kenv, ipitch*.97, ifn
a4 oscil kenv, ipitch*.98, ifn
a5 oscil kenv, ipitch*.99, ifn
a6 oscil kenv, ipitch, ifn
a7 oscil kenv, ipitch*.101, ifn
a8 oscil kenv, ipitch*.102, ifn
a9 oscil kenv, ipitch*.103, ifn
a10 oscil kenv, ipitch*.104, ifn
a11 oscil kenv, ipitch*.105, ifn
kvib oscil p9, p8, 1
kvib=kvib/2

outs (a1+a3+a5+a6+a8+a10)*(kvib+.5)/3, (a2+a4+a6+a7+a9+a11)*(.5-kvib)/3
endin


instr 3  ;beam-up

idur=p3
iamp=ampdb(p4)
ipitch1=cpsoct(p5)
ipitch2=cpsoct(p6)
imodf=p7
imodd=p8-1  ;p8>=1
ifn=p9

kpitch expseg ipitch1, idur, ipitch2
kenv linen iamp, .2, idur, idur*.3
k1 oscil .5, imodf, 5
k1=(k1+.5)*imodd+1  ;1<k1<imodd
a1 oscil kenv, kpitch*k1, ifn
a2 oscil kenv, kpitch*k1*1.08, ifn

outs a1*.7+a2*.3, a1*.3+a2*.7
endin


instr 4  ; filtered pluck
idur=p3
iamp=ampdb(p4)
ipitch=cpsoct(p5)
ifil=cpsoct(p6)

kenv expon iamp, idur, 1
abal oscil kenv, ipitch, 1
a1 pluck kenv, ipitch, ipitch, 0, 1
a2 butterbp a1, ifil, ifil/100
a3 balance a2, abal
outs a3, a3
endin


instr 5  ; generic sound
idur=p3
iamp=ampdb(p4)
ipitch=cpsoct(p5)
ifn=p6

kenv linen iamp, .1*idur, idur, .3*idur
kvibenv expseg .001, idur*.3, .03, idur*.7, .01
kvib oscil kvibenv, 6, 1
a1 oscil kenv, ipitch*(1+kvib), ifn
a2 oscil kenv, ipitch*(1+kvib)*1.004, ifn
a3 oscil kenv, ipitch*(1+kvib)*.996, ifn
outs (a1+a2)/1.4, (a1+a3)/1.4
endin



instr 6  ; squirm
idur=p3
iamp=ampdb(p4)
ipitch=p5
ipitchr=p6  ; spread of frequencies for randh
irate=p7  ; rate of random pitch change (cps)
ipan=p8  ; amount of random panning (0 to 1)
ifn=p9

kenv linen iamp, .1*idur, idur, .3*idur
kp randi ipitchr, irate, p2/500
k1 line 0, idur, ipan

a1 oscili kenv, cpsoct(ipitch+kp), ifn
a2 oscili kenv, cpsoct(ipitch+kp)/2, 1

asum=(a1+a2)/1.4
kpan randi k1, irate
kpan=(kpan+1)/2
outs kpan*asum, (1-kpan)*asum
endin


instr 7  ; random
idur=p3
iamp=ampdb(p4)
ipitch=p5
ipitchr=p6  ; spread of frequencies for randh
irate=p7  ; rate of random pitch change (cps)
ipan=p8  ; amount of random panning (0 to 1)
ifn=p9

kenv linen iamp, .1*idur, idur, .3*idur
kp randh ipitchr, irate, p2/500
k1 line 0, idur, ipan

a1 oscili kenv, cpsoct(ipitch+kp), ifn
a2 oscili kenv, cpsoct(ipitch+kp)/2, 1

asum=(a1+a2)/1.4
kpan randi k1, irate
kpan=(kpan+1)/2
outs kpan*asum, (1-kpan)*asum
endin


instr 8  ; static burst
idur=p3
iamp=ampdb(p4)
ipitch=cpsoct(p5)
ifn=p6

a1 randh ipitch, ipitch
a2 oscil iamp, ipitch*a1, ifn
a3 randh ipitch, ipitch, .5
a4 oscil iamp, ipitch*a3, ifn
a5 oscil iamp, (ipitch+a3)/2.4, ifn
a6 oscil iamp, (ipitch+a1)/2.4, ifn

outs a2*.5+a5*.5, a4*.5+a6*.5

endin


instr 9  ; koto
idur=p3
iamp=ampdb(p4)
ipitch1=cpsoct(p5)
ipitch2=cpsoct(p6)
kpitch expseg ipitch1, idur, ipitch2 
kenv expon 1, idur, .001
abal oscil kenv*iamp, kpitch, 1
ap pluck iamp, kpitch, ipitch1, 0, 1
ap2 pluck iamp, kpitch*1.01, ipitch1, 0, 1
a1 reson ap, 98, 10
a2 reson ap2, 211, 21
a3 reson ap, 343, 34
a4 reson ap2, 404, 40
a5 reson ap, 441, 44
a6 reson ap2, 480, 50
a7 reson ap, 534, 50
a8 reson ap2, 824, 80
asum1=a1+a3+a5+a7
asum1 balance asum1, abal
asum2=a2+a4+a6+a8
asum2 balance asum2, abal
outs asum1*kenv*.6, asum2*kenv*.6

endin


instr 10  ; drum
idur=p3
iamp=ampdb(p4)
ipitch=cpsoct(p5)

kenv1 expon iamp, idur*1, 1
kenv2 expon iamp, idur, 1
a1 randi kenv1, ipitch*2
a2 oscil kenv2, ipitch, 1
outs a1*.9+a2*.2, a1*.9+a2*.2
endin

</CsInstruments>

<CsScore>
;A Long Walk Off a Short Pier
;by Adam Zygmunt
;
;pier.sco, Csound score file created by pier.c
;
;copyright 1997 Adam Zygmunt

f1 0 8192 10 1
f2 0 4096 10 10 2 1 1 .5
f3 0 4096 10 1 0 4 2 6 3 2
f4 0 4096 10 10 8 6 4 2 2 2 2 8 6 4 2
f5 0 4096 7 -1 4096 1

i1 0.000 0.080 77.282 8.667 8.667 5.000 0.000 2
i1 0.080 0.120 78.632 7.556 7.557 5.000 -0.002 2
i1 0.200 0.140 82.575 8.056 8.055 5.000 0.003 2
i1 0.340 0.080 81.732 9.056 9.055 5.000 -0.009 2
i1 0.420 0.240 79.491 7.278 7.272 5.000 -0.000 2
i1 0.660 0.080 73.281 8.556 8.546 5.000 -0.018 2
i1 0.740 0.080 74.672 8.389 8.381 5.000 0.006 2
i1 0.820 0.140 78.992 7.556 7.562 5.000 0.004 2
i1 0.960 0.060 89.067 7.444 7.439 5.000 -0.009 2
i1 1.020 0.140 73.308 7.444 7.481 5.000 -0.019 2
i1 1.160 0.080 74.663 8.000 7.969 5.000 -0.030 2
i1 1.240 0.120 86.547 8.222 8.196 5.000 -0.022 2
i1 1.360 0.180 72.049 8.111 8.056 5.000 0.004 2
i1 1.540 0.040 74.783 7.778 7.748 5.000 0.033 2
i1 1.580 0.120 76.808 8.333 8.360 5.000 -0.043 2
i1 1.700 0.120 83.616 7.722 7.766 5.000 -0.028 2
i1 1.820 0.160 82.910 7.611 7.659 5.000 -0.008 2
i1 1.980 0.160 79.700 7.889 7.875 5.000 0.028 2
i1 2.140 0.220 84.257 7.944 7.917 5.000 -0.032 2
i1 2.360 0.140 75.710 7.889 7.899 5.000 0.028 2
i1 2.500 0.200 79.142 8.333 8.303 5.000 -0.004 2
i1 2.700 0.140 76.676 7.722 7.767 5.000 0.018 2
i1 2.840 0.140 70.728 8.333 8.229 5.000 -0.080 2
i1 2.980 0.140 79.997 8.278 8.158 5.000 0.015 2
i1 3.120 0.140 84.367 6.944 6.870 5.000 0.057 2
i1 3.260 0.080 79.900 7.444 7.451 5.000 -0.007 2
i1 3.340 0.120 81.166 8.111 8.027 5.000 -0.066 2
i1 3.460 0.220 81.791 7.722 7.727 5.000 -0.059 2
i1 3.680 0.120 86.574 8.000 7.877 5.000 0.018 2
i1 3.800 0.180 84.429 7.889 7.777 5.000 0.037 2
i1 3.980 0.220 79.765 7.111 7.165 5.000 0.110 2
i1 4.200 0.120 80.451 7.333 7.299 5.000 -0.052 2
i1 4.320 0.140 74.662 8.278 8.243 5.000 0.023 2
i1 4.460 0.220 76.813 7.944 7.885 5.000 -0.007 2
i1 4.680 0.200 77.440 8.333 8.318 5.000 -0.035 2
i1 4.880 0.160 78.340 8.167 8.271 5.000 -0.119 2
i1 5.040 0.180 73.106 8.111 8.067 5.000 0.097 2
i1 5.220 0.160 78.913 7.722 7.900 5.000 -0.015 2
i1 5.380 0.200 77.399 8.278 8.079 5.000 -0.036 2
i1 5.580 0.180 73.118 8.111 7.842 5.000 0.017 2
i1 5.760 0.200 79.691 8.944 8.884 5.000 -0.165 2
i1 5.960 0.140 87.390 7.833 7.606 5.000 -0.127 2
i1 6.100 0.180 80.414 7.278 7.636 5.000 -0.172 2
i1 6.280 0.140 76.488 7.500 7.295 5.000 -0.198 2
i1 6.420 0.220 83.512 8.333 8.642 5.000 0.142 2
i1 6.640 0.380 72.083 7.944 7.749 5.000 -0.013 2
i1 7.020 0.320 72.884 8.222 8.272 5.000 0.008 2
i1 7.340 0.300 76.040 8.000 7.961 5.000 0.187 2
i1 7.640 0.180 83.831 8.000 7.990 5.000 -0.073 2
i1 7.820 0.160 81.961 7.944 8.040 5.000 0.080 2
i1 7.980 0.140 76.528 7.611 7.568 5.000 -0.193 2
i1 8.120 0.220 79.895 8.167 8.194 5.000 -0.215 2
i1 8.340 0.180 79.759 7.667 7.751 5.000 -0.050 2
i1 8.520 0.280 76.443 8.167 8.187 5.000 0.190 2
i1 8.800 0.140 80.887 7.889 7.576 5.000 0.157 2
i1 8.940 0.280 77.238 7.944 7.646 5.000 -0.165 2
i1 9.220 0.300 84.105 8.278 8.137 5.000 -0.205 2
i1 9.520 0.340 76.212 7.611 7.379 5.000 0.144 2
i1 9.860 0.200 70.498 7.944 7.680 5.000 -0.150 2
i1 10.060 0.200 78.987 8.056 8.285 5.000 0.225 2
i1 10.260 0.380 72.598 8.556 8.390 5.000 0.228 2
i1 10.640 0.320 79.293 7.889 7.757 5.000 -0.113 2
i1 10.960 0.320 73.360 7.944 8.154 5.000 -0.216 2
i1 11.280 0.380 88.926 7.611 7.256 5.000 0.085 2
i1 11.660 0.160 86.904 8.167 8.396 5.000 0.070 2
i1 11.820 0.180 79.232 7.500 7.800 5.000 -0.021 2
i1 12.000 0.340 78.035 8.278 7.842 5.000 0.242 2
i1 12.340 0.180 83.223 7.667 7.067 5.000 -0.293 2
i1 12.520 0.380 77.603 7.722 8.105 5.000 -0.102 2
i1 12.900 0.420 71.762 7.500 7.175 5.000 0.244 2
i1 13.320 0.360 78.503 8.222 8.991 5.000 -0.099 2
i1 13.680 0.520 79.756 8.222 8.118 5.000 -0.332 2
i1 14.200 0.400 91.025 7.778 7.906 5.000 -0.249 2
i1 14.600 0.280 76.556 8.000 7.954 5.000 0.005 2
i1 14.880 0.420 78.260 7.611 7.262 5.000 -0.259 2
i1 15.300 0.340 76.245 8.389 8.790 5.000 0.460 2
i1 15.640 0.280 81.236 7.944 8.599 5.000 0.363 2
i1 15.920 0.300 78.818 7.944 8.484 5.000 -0.149 2
i1 16.220 0.320 89.516 8.667 9.056 5.000 -0.308 2
i1 16.540 0.280 79.355 8.000 7.679 5.000 0.527 2
i1 16.820 0.320 83.383 7.889 7.296 5.000 0.556 2
i1 17.140 0.520 75.606 8.889 9.010 5.000 0.554 2
i1 17.660 0.400 79.374 7.278 7.044 5.000 0.170 2
i1 18.060 0.580 88.982 7.667 8.221 5.000 0.386 2
i1 18.640 0.380 85.829 8.389 7.900 5.000 -0.022 2
i1 19.020 0.500 75.436 8.000 8.349 5.000 -0.198 2
i1 19.520 0.440 72.445 8.389 7.956 5.000 0.487 2
i1 19.960 0.300 76.595 7.944 8.344 5.000 -0.120 2
i1 20.260 0.440 84.391 8.167 8.517 5.000 0.614 2
i1 20.700 0.480 82.235 8.000 8.231 5.000 -0.354 2
i1 21.180 0.320 81.574 8.000 7.185 5.000 0.416 2
i1 21.500 0.460 81.580 8.000 7.998 5.000 0.682 2
i1 21.960 0.380 79.299 8.056 8.434 5.000 -0.300 2
i1 22.340 0.360 72.769 7.556 7.493 5.000 0.199 2
i1 22.700 0.540 83.909 7.889 7.495 5.000 -0.250 2
i1 23.240 0.500 77.543 8.000 8.205 5.000 -0.379 2
i1 23.740 0.640 81.727 7.833 7.101 5.000 0.383 2
i1 24.380 0.380 82.802 8.056 7.906 5.000 -0.173 2
i1 24.760 0.460 80.882 7.722 7.475 5.000 0.478 2
i1 25.220 0.600 78.896 8.111 8.601 5.000 0.004 2
i1 25.820 0.620 80.340 7.222 5.965 5.000 0.654 2
i1 26.440 0.640 83.743 7.333 7.886 5.000 -0.190 2
i1 27.080 0.600 73.640 8.778 9.088 5.000 0.198 2
i1 27.680 0.600 74.696 8.000 6.904 5.000 -0.311 2
i1 28.280 0.560 75.897 7.500 6.584 5.000 -0.224 2
i1 28.840 0.640 80.915 8.167 8.208 5.000 0.787 2
i1 29.480 0.480 80.387 8.389 9.535 5.000 -0.242 2
i1 29.960 0.600 85.759 7.222 7.701 5.000 -0.899 2
i2 0.000 5.000 84.000 8.333 0.200 0.300 0.719 0.700 3
i2 4.300 5.000 84.000 8.444 0.200 0.300 0.604 0.700 3
i2 7.700 5.000 84.000 8.556 0.200 0.300 0.525 0.700 3
i2 11.500 5.000 84.000 8.778 0.200 0.300 0.863 0.700 3
i2 16.200 5.000 84.000 8.444 0.200 0.300 0.830 0.700 3
i2 20.100 5.000 84.000 8.444 0.200 0.300 0.311 0.700 3
i2 24.000 5.000 84.000 8.556 0.200 0.300 0.462 0.700 3
i2 28.900 5.000 84.000 8.111 0.200 0.300 0.824 0.700 3
i3 7.000 4.000 78.000 6.357 6.522 40.000 2.000 4
i3 27.000 4.000 78.000 3.412 5.866 40.000 2.000 4
i3 34.000 4.000 78.000 5.123 8.560 40.000 2.000 4
i9 3.000 3.000 81.537 8.500 8.278
i9 8.000 3.000 78.541 8.278 8.056
i9 10.000 3.000 80.712 8.944 8.722
i9 11.000 3.000 78.997 6.944 6.722
i9 14.000 3.000 88.079 8.389 8.167
i9 16.000 3.000 78.453 7.611 7.389
i9 20.000 3.000 82.667 8.944 8.722
i9 21.000 3.000 79.629 9.167 8.944
i9 24.000 3.000 81.142 7.278 7.056
i9 25.000 3.000 83.485 8.500 8.278
i9 27.000 3.000 77.968 9.056 8.833
i9 29.000 3.000 80.136 9.722 9.500
i9 33.000 3.000 87.324 8.500 8.278
i2 30.000 6.000 77.920 10.200 0.200 0.300 0.270 0.200 1
i2 31.000 6.000 81.010 5.800 0.200 0.300 0.314 0.200 1
i2 38.000 6.000 75.153 11.300 0.200 0.300 0.304 0.200 1
i2 43.000 6.000 69.091 9.100 0.200 0.300 0.303 0.200 1
i2 50.000 6.000 68.355 8.700 0.200 0.300 0.277 0.200 1
i2 60.000 6.000 70.533 8.800 0.200 0.300 0.305 0.200 1
i2 63.000 6.000 71.557 9.700 0.200 0.300 0.323 0.200 1
i2 66.000 6.000 70.187 12.300 0.200 0.300 0.187 0.200 1
i2 68.000 6.000 63.453 7.900 0.200 0.300 0.316 0.200 1
i2 30.000 8.000 81.490 9.500 0.200 0.300 0.270 0.200 1
i2 32.000 8.000 80.954 10.167 0.200 0.300 0.304 0.200 1
i2 42.000 8.000 74.313 5.417 0.200 0.300 0.338 0.200 1
i2 49.000 8.000 76.666 9.500 0.200 0.300 0.292 0.200 1
i2 54.000 8.000 70.814 8.833 0.200 0.300 0.212 0.200 1
i2 60.000 8.000 68.837 8.417 0.200 0.300 0.389 0.200 1
i9 50.000 3.000 80.540 8.767 8.633
i9 50.193 3.000 81.884 9.367 9.233
i9 50.334 3.000 81.025 9.500 9.367
i9 50.490 3.000 82.964 9.567 9.433
i9 50.598 3.000 80.271 9.900 9.767
i9 50.681 3.000 83.906 9.833 9.700
i9 50.776 3.000 81.917 10.367 10.233
i9 50.905 3.000 81.190 10.500 10.367
i9 51.034 3.000 77.346 10.233 10.100
i9 51.225 3.000 74.225 10.233 10.100
i9 51.338 3.000 73.699 10.367 10.233
i9 55.338 3.000 72.146 10.367 10.233
i9 55.433 3.000 74.695 10.367 10.233
i9 55.516 3.000 74.812 9.633 9.500
i9 55.705 3.000 72.015 9.767 9.633
i9 60.548 3.000 71.825 9.633 9.500
i9 60.629 3.000 70.489 9.700 9.567
i9 60.786 3.000 69.104 9.833 9.700
i9 60.945 3.000 67.029 9.500 9.367
i9 61.084 3.000 63.941 9.567 9.433
i9 61.192 3.000 61.986 9.700 9.567
i9 61.362 3.000 58.745 9.833 9.700
i9 61.461 3.000 62.097 10.300 10.167
i9 61.635 3.000 60.521 10.033 9.900
i9 61.718 3.000 62.483 9.900 9.767
i9 61.806 3.000 60.625 9.767 9.633
i9 65.799 3.000 61.901 9.367 9.233
i9 65.888 3.000 65.138 9.100 8.967
i9 66.088 3.000 67.758 8.967 8.833
i9 66.242 3.000 67.571 8.300 8.167
i9 66.356 3.000 66.780 8.567 8.433
i9 66.536 3.000 65.893 8.233 8.100
i9 66.637 3.000 64.509 7.700 7.567
i9 66.751 3.000 62.799 8.033 7.900
i9 66.872 3.000 63.995 8.367 8.233
i9 67.020 3.000 61.671 8.500 8.367
i9 67.125 3.000 60.830 9.167 9.033
i9 67.290 3.000 59.293 9.300 9.167
i9 67.454 3.000 56.029 9.233 9.100
i9 67.645 3.000 56.358 9.167 9.033
i9 67.827 3.000 58.273 9.233 9.100
i9 67.956 3.000 58.502 8.833 8.700
i9 68.151 3.000 59.585 8.833 8.700
i9 68.258 3.000 62.077 8.500 8.367
i9 68.418 3.000 61.768 8.700 8.567
i6 50.000 14 60 6.7 .1 1.5 .4 3
i7 60.000 10 55 6.2 .2 .7 .9 2
i5 74.000 0.539 54.761 7.600 2
i5 74.490 0.385 48.079 7.500 2
i5 74.840 1.232 49.730 7.500 2
i5 75.960 0.616 50.711 7.600 2
i5 76.520 0.616 50.057 7.600 2
i5 77.080 1.001 49.876 7.600 2
i5 77.990 0.693 48.180 7.600 2
i5 78.620 0.462 45.432 7.600 2
i5 79.040 0.847 45.883 7.600 2
i5 79.810 1.155 47.284 7.700 2
i5 80.860 0.385 48.664 7.700 2
i5 81.210 0.770 48.427 7.500 2
i5 81.910 0.462 48.781 7.400 2
i5 82.330 0.231 48.270 7.400 2
i5 82.540 0.539 50.371 7.400 2
i5 83.030 0.154 50.014 7.300 2
i5 83.170 0.385 48.718 7.300 2
i5 83.520 0.077 46.910 7.200 2
i5 83.590 0.077 46.575 7.200 2
i5 83.660 0.385 48.247 7.100 2
i5 84.010 0.077 48.318 7.200 2
i5 84.080 0.077 47.934 7.300 2
i5 84.150 0.462 48.817 7.300 2
i5 84.570 0.308 47.224 7.100 2
i5 84.850 0.308 44.100 7.100 2
i2 74.250 16.000 76 6.1 .2 .5 .5 .3 4
i3 79.000 20 60 9 8.6 28 1.5 2
i5 88.130 0.231 59.121 7.100 1
i1 88.130 0.231 49.121 7.100 7.100 5 0 2
i5 88.340 0.539 60.504 7.335 1
i1 88.340 0.539 50.504 7.335 7.335 5 0 2
i5 88.830 0.154 63.338 7.571 1
i1 88.830 0.154 53.338 7.571 7.571 5 0 2
i5 88.970 0.154 65.369 7.571 1
i1 88.970 0.154 55.369 7.571 7.571 5 0 2
i5 89.110 0.385 65.875 7.806 1
i1 89.110 0.385 55.875 7.806 7.806 5 0 2
i5 89.460 0.231 64.917 7.982 1
i1 89.460 0.231 54.917 7.982 7.982 5 0 2
i5 89.670 0.539 66.964 8.218 1
i1 89.670 0.539 56.964 8.218 8.218 5 0 2
i5 90.160 0.385 66.781 8.335 1
i1 90.160 0.385 56.781 8.335 8.335 5 0 2
i5 90.510 0.231 67.211 8.629 1
i1 90.510 0.231 57.211 8.629 8.629 5 0 2
i5 90.720 0.385 68.804 8.512 1
i1 90.720 0.385 58.804 8.512 8.512 5 0 2
i5 91.070 0.462 71.633 8.571 1
i1 91.070 0.462 61.633 8.571 8.571 5 0 2
i5 91.490 0.385 70.454 8.806 1
i1 91.490 0.385 60.454 8.806 8.806 5 0 2
i5 91.840 0.385 73.315 8.806 1
i1 91.840 0.385 63.315 8.806 8.806 5 0 2
i5 92.190 0.231 73.090 8.747 1
i1 92.190 0.231 63.090 8.747 8.747 5 0 2
i5 92.400 0.847 76.169 8.747 1
i1 92.400 0.847 66.169 8.747 8.747 5 0 2
i5 93.170 0.462 77.831 8.982 1
i1 93.170 0.462 67.831 8.982 8.982 5 0 2
i5 93.590 0.308 78.080 9.159 1
i1 93.590 0.308 68.080 9.159 9.159 5 0 2
i5 93.870 0.539 77.872 9.276 1
i1 93.870 0.539 67.872 9.276 9.276 5 0 2
i5 94.360 0.385 78.180 9.276 1
i1 94.360 0.385 68.180 9.276 9.276 5 0 2
i5 94.710 0.308 79.092 9.394 1
i1 94.710 0.308 69.092 9.394 9.394 5 0 2
i5 94.990 0.462 79.566 9.453 1
i1 94.990 0.462 69.566 9.453 9.453 5 0 2
i5 95.410 0.154 77.397 9.512 1
i1 95.410 0.154 67.397 9.512 9.512 5 0 2
i5 95.550 0.539 80.561 9.512 1
i1 95.550 0.539 70.561 9.512 9.512 5 0 2
i5 96.040 0.616 80.484 9.688 1
i1 96.040 0.616 70.484 9.688 9.688 5 0 2
i5 96.600 0.693 81.362 10.041 1
i1 96.600 0.693 71.362 10.041 10.041 5 0 2
i5 97.230 0.154 82.840 10.276 1
i1 97.230 0.154 72.840 10.276 10.276 5 0 2
i5 97.370 0.462 85.176 10.218 1
i1 97.370 0.462 75.176 10.218 10.218 5 0 2
i5 97.790 0.770 85.213 10.276 1
i1 97.790 0.770 75.213 10.276 10.276 5 0 2
i5 98.490 0.539 87.288 10.629 1
i1 98.490 0.539 77.288 10.629 10.629 5 0 2
i5 98.980 0.231 86.895 10.806 1
i1 98.980 0.231 76.895 10.806 10.806 5 0 2
i3 92 8 73 5.06 10 200 5 4
i6 99.000 23.500 69 12.06 .04 4 .8 1
i6 99.000 23.500 62 12.058 .04 7 .8 1
i1 99.000 0.300 81.746 9.310 8.992 5.000 0.000 2
i1 99.114 0.300 71.124 9.160 9.047 5.000 0.001 2
i1 99.395 0.300 75.879 8.460 9.080 5.000 -0.001 2
i1 99.651 0.300 80.967 8.960 8.015 5.000 -0.011 2
i1 99.781 0.300 74.446 8.760 7.186 5.000 -0.015 2
i1 99.932 0.300 81.557 8.660 10.794 5.000 0.010 2
i1 100.132 0.300 78.361 8.260 8.192 5.000 -0.011 2
i1 100.316 0.300 68.241 8.060 7.473 5.000 -0.018 2
i1 100.451 0.300 75.545 8.460 8.958 5.000 -0.024 2
i1 100.658 0.300 79.584 8.160 8.352 5.000 0.012 2
i1 100.910 0.300 84.986 8.960 10.764 5.000 -0.028 2
i1 101.115 0.300 67.820 9.060 7.684 5.000 0.036 2
i1 101.297 0.300 71.567 10.010 9.594 5.000 0.026 2
i1 101.485 0.300 63.037 10.360 8.659 5.000 -0.048 2
i1 103.929 0.300 67.500 9.910 10.136 5.000 -0.081 2
i1 104.157 0.300 76.867 10.610 11.719 5.000 0.002 2
i1 104.360 0.300 73.832 10.510 9.367 5.000 -0.027 2
i1 104.653 0.300 62.742 10.510 11.343 5.000 -0.042 2
i1 104.856 0.300 65.635 10.510 12.066 5.000 0.038 2
i1 105.126 0.300 62.538 9.460 8.959 5.000 0.115 2
i1 105.327 0.300 80.623 8.910 9.036 5.000 0.009 2
i1 105.459 0.300 64.634 8.560 7.586 5.000 0.071 2
i1 107.314 0.300 73.295 8.960 7.884 5.000 -0.070 2
i1 107.606 0.300 77.495 9.010 9.716 5.000 0.033 2
i1 109.640 0.300 87.094 8.660 8.559 5.000 -0.059 2
i1 109.756 0.300 79.343 8.910 8.105 5.000 0.193 2
i1 112.108 0.300 78.279 8.760 10.391 5.000 -0.188 2
i1 112.286 0.300 72.795 8.360 8.979 5.000 0.147 2
i1 112.409 0.300 81.090 8.410 9.529 5.000 0.184 2
i1 112.609 0.300 66.143 8.260 8.790 5.000 -0.254 2
i1 112.779 0.300 76.545 8.060 8.765 5.000 0.101 2
i1 115.188 0.300 70.880 8.560 8.872 5.000 -0.317 2
i1 117.116 0.300 67.792 9.160 10.032 5.000 -0.018 2
i1 117.294 0.300 73.863 8.560 9.581 5.000 -0.034 2
i1 117.545 0.300 74.040 8.610 8.596 5.000 0.289 2
i1 117.769 0.300 72.084 7.610 7.798 5.000 0.298 2
i1 117.924 0.300 77.373 7.760 7.551 5.000 0.024 2
i1 120.099 0.300 70.975 6.610 7.524 5.000 -0.352 2
i1 120.250 0.300 65.676 6.510 6.290 5.000 0.417 2
i1 120.509 0.300 71.948 6.010 6.499 5.000 -0.302 2
i1 122.594 0.300 84.257 6.110 5.964 5.000 -0.281 2
i1 122.763 0.300 78.185 5.410 5.465 5.000 -0.428 2
i1 123.025 0.300 78.013 5.060 5.776 5.000 0.141 2
i1 123.211 0.300 72.900 4.510 4.368 5.000 -0.235 2
i1 123.360 0.300 73.770 4.510 4.561 5.000 -0.412 2
i1 123.493 0.300 65.344 4.810 4.021 5.000 0.341 2
i1 123.783 0.300 65.948 4.110 4.917 5.000 -0.212 2
i1 126.115 0.300 74.556 2.710 2.963 5.000 -0.435 2
i1 128.453 0.300 79.849 2.410 2.775 5.000 0.335 2
i1 128.570 0.300 68.803 2.060 2.433 5.000 0.623 2
i1 130.391 0.300 77.586 2.060 1.437 5.000 0.129 2
i1 132.157 0.300 79.777 2.360 2.530 5.000 0.359 2
i1 134.471 0.300 70.374 2.260 2.095 5.000 0.238 2
i1 136.341 0.300 70.764 2.110 2.048 5.000 0.186 2
i1 136.460 0.300 73.010 1.360 1.584 5.000 0.140 2
i1 136.598 0.300 65.603 1.860 2.500 5.000 0.155 2
i1 136.868 0.300 69.568 2.660 2.473 5.000 -0.234 2
i1 137.093 0.300 73.058 2.910 2.996 5.000 -0.666 2
i1 137.317 0.300 71.176 2.560 2.315 5.000 -0.332 2
i1 137.425 0.300 65.091 3.010 3.426 5.000 0.269 2
i1 139.677 0.300 75.723 3.010 2.616 5.000 -0.063 2
i1 139.955 0.300 79.725 3.860 3.759 5.000 0.298 2
i1 142.297 0.300 73.489 5.010 5.687 5.000 -0.514 2
i1 142.588 0.300 72.503 4.610 4.625 5.000 -0.912 2
i1 142.731 0.300 83.032 4.410 4.461 5.000 0.653 2
i1 142.921 0.300 67.341 3.460 3.410 5.000 0.906 2
i1 143.157 0.300 72.727 3.660 3.534 5.000 0.336 2
i1 143.404 0.300 72.755 3.610 3.678 5.000 0.259 2
i1 145.785 0.300 71.174 3.760 3.699 5.000 0.971 2
i1 145.926 0.300 67.880 3.860 3.944 5.000 0.211 2
i2 99.000 6.000 70.856 9.357 0.200 0.300 0.321 0.200 4
i2 104.000 6.000 68.692 8.929 0.200 0.300 0.342 0.200 4
i2 108.000 6.000 67.824 9.500 0.200 0.300 0.219 0.200 4
i2 111.000 6.000 59.692 9.643 0.200 0.300 0.344 0.200 4
i2 114.000 6.000 61.184 9.214 0.200 0.300 0.310 0.200 4
i2 115.000 6.000 60.398 9.643 0.200 0.300 0.352 0.200 4
i2 118.000 6.000 59.243 9.500 0.200 0.300 0.297 0.200 4
i2 120.000 6.000 60.837 9.643 0.200 0.300 0.311 0.200 4
i2 122.000 6.000 55.891 9.214 0.200 0.300 0.298 0.200 4
i2 133.000 6.000 54.380 8.929 0.200 0.300 0.337 0.200 4
i2 137.000 6.000 49.724 8.500 0.200 0.300 0.213 0.200 4
i2 142.000 6.000 50.494 8.786 0.200 0.300 0.265 0.200 4
i3 124.000 4.000 66.000 5.743 4.295 20.000 2.000 4
i3 128.000 4.000 66.000 7.413 5.519 20.000 2.000 4
i3 137.000 4.000 66.000 5.923 4.170 20.000 2.000 4
i3 140.000 4.000 66.000 5.645 4.959 20.000 2.000 4
i3 147.000 4.000 66.000 5.193 6.064 20.000 2.000 4
i3 153.000 4.000 66.000 5.070 6.306 20.000 2.000 4
i3 155.000 4.000 66.000 4.270 4.455 20.000 2.000 4
i6 146.000 20.000 71 5 .1 .7 .4 2
i1 146.000 0.300 81.789 10.500 11.191 5.000 0.000 2
i1 146.266 0.300 82.456 11.000 13.653 5.000 -0.006 2
i1 146.543 0.300 82.380 9.900 9.537 5.000 0.010 2
i1 146.716 0.300 85.352 9.550 10.476 5.000 0.018 2
i1 146.842 0.300 85.978 9.700 10.241 5.000 0.020 2
i1 147.105 0.300 89.225 9.300 9.701 5.000 -0.027 2
i1 147.296 0.300 89.043 7.700 8.399 5.000 -0.034 2
i1 147.527 0.300 87.901 7.200 7.036 5.000 0.017 2
i1 149.046 0.300 89.779 6.200 5.097 5.000 0.052 2
i1 149.204 0.300 85.873 5.800 7.329 5.000 0.042 2
i1 149.485 0.300 82.615 5.200 4.999 5.000 -0.052 2
i1 151.968 0.300 80.625 4.900 5.248 5.000 0.082 2
i1 152.113 0.300 84.463 4.700 5.816 5.000 0.026 2
i1 152.246 0.300 88.721 6.150 4.129 5.000 -0.067 2
i1 152.362 0.300 91.857 6.150 3.956 5.000 0.130 2
i1 152.654 0.300 91.402 6.450 6.794 5.000 -0.166 2
i1 152.853 0.300 88.697 6.350 5.945 5.000 0.213 2
i1 155.093 0.300 91.587 5.950 6.556 5.000 -0.098 2
i1 155.248 0.300 93.047 6.350 7.088 5.000 -0.104 2
i1 155.511 0.300 90.547 5.950 6.060 5.000 -0.278 2
i1 155.780 0.300 84.084 6.050 5.756 5.000 -0.236 2
i1 155.935 0.300 84.899 4.950 4.426 5.000 -0.035 2
i1 156.199 0.300 84.411 5.900 5.203 5.000 0.138 2
i1 156.321 0.300 81.399 6.850 7.337 5.000 -0.159 2
i1 156.438 0.300 81.326 6.950 5.566 5.000 -0.171 2
i1 156.609 0.300 81.099 6.500 6.988 5.000 -0.057 2
i1 156.810 0.300 82.060 5.750 5.877 5.000 -0.270 2
i1 158.440 0.300 85.119 6.900 6.303 5.000 0.324 2
i1 160.052 0.300 84.838 6.600 6.337 5.000 -0.455 2
i1 160.160 0.300 85.876 4.950 4.905 5.000 -0.147 2
i1 160.362 0.300 86.665 4.600 4.042 5.000 0.075 2
i1 160.521 0.300 86.706 5.000 4.669 5.000 0.228 2
i1 160.800 0.300 88.861 5.300 5.042 5.000 -0.392 2
i1 161.036 0.300 87.790 4.950 4.391 5.000 -0.113 2
i1 161.308 0.300 87.549 3.950 3.213 5.000 -0.003 2
i1 161.572 0.300 89.658 3.650 3.350 5.000 -0.351 2
i1 161.770 0.300 89.635 3.500 3.768 5.000 -0.323 2
i1 163.583 0.300 88.776 5.350 5.362 5.000 -0.157 2
i1 163.710 0.300 88.462 5.550 6.089 5.000 0.355 2
i1 163.983 0.300 87.302 5.500 4.558 5.000 0.509 2
i1 164.092 0.300 93.579 5.000 4.821 5.000 0.343 2
i1 164.294 0.300 91.576 4.550 5.001 5.000 -0.236 2
i1 166.302 0.300 90.823 3.950 3.802 5.000 0.602 2
i1 166.482 0.300 85.501 3.600 4.170 5.000 0.562 2
i1 166.648 0.300 89.577 3.500 3.475 5.000 0.427 2
i1 168.565 0.300 89.922 2.800 2.571 5.000 0.032 2
i1 168.672 0.300 89.731 2.900 2.814 5.000 0.596 2
i1 171.018 0.300 90.170 2.500 2.786 5.000 0.364 2
i1 173.445 0.300 89.722 2.800 2.109 5.000 -0.499 2
i1 173.691 0.300 90.528 2.950 2.654 5.000 0.674 2
i1 173.915 0.300 87.968 4.050 3.400 5.000 0.155 2
i1 174.158 0.300 86.345 4.100 4.089 5.000 0.824 2
i1 174.374 0.300 84.471 3.400 3.297 5.000 0.827 2
i1 174.571 0.300 81.773 2.650 2.212 5.000 0.657 2
i1 174.786 0.300 77.684 1.800 1.160 5.000 -0.744 2
i1 174.975 0.300 74.674 1.950 1.281 5.000 -0.456 2
i1 175.092 0.300 77.710 1.100 0.898 5.000 -0.258 2
i1 175.326 0.300 77.276 1.000 1.227 5.000 0.365 2
i1 175.611 0.300 74.981 0.900 0.777 5.000 0.305 2
i1 175.720 0.300 74.502 1.000 0.974 5.000 -0.404 2
i1 175.928 0.300 76.442 0.600 0.188 5.000 0.005 2
i2 146.000 6.000 66.541 9.500 0.200 0.300 0.249 0.200 1
i2 155.000 6.000 62.814 8.786 0.200 0.300 0.223 0.200 1
i2 163.000 6.000 62.911 10.071 0.200 0.300 0.323 0.200 1
i2 173.000 6.000 57.472 9.500 0.200 0.300 0.226 0.200 1
i4 164.000 0.533 74.114 6.300 7.166
i4 164.800 2.667 59.602 5.900 7.452
i4 168.800 0.533 69.890 6.600 10.940
i4 169.600 0.533 69.268 6.500 10.815
i4 170.400 2.133 65.570 6.300 9.711
i4 173.600 2.133 71.985 7.100 9.789
i4 176.800 3.733 67.454 6.500 10.118
i4 182.400 1.600 68.686 6.500 12.182
i4 184.800 0.533 67.630 7.100 11.729
i4 185.600 1.067 59.436 6.000 9.930
i4 187.200 2.667 72.225 6.400 9.397
i4 191.200 1.600 69.190 6.700 11.285
i4 193.600 2.133 63.905 6.600 13.529
i9 161.000 2.500 74.929 7.600 7.563
i9 164.000 2.500 76.292 7.400 7.390
i9 169.000 2.500 75.731 7.400 7.388
i9 169.250 2.500 74.052 7.800 7.783
i9 169.750 2.500 74.176 7.800 7.790
i9 170.250 2.500 70.046 7.600 7.584
i9 171.000 2.500 70.322 7.400 7.442
i9 172.000 2.500 72.191 7.400 7.364
i9 173.750 2.500 71.474 7.400 7.356
i9 174.750 2.500 69.287 7.000 7.015
i9 175.750 2.500 67.150 7.000 7.003
i9 176.500 2.500 71.237 6.600 6.613
i9 177.000 2.500 68.637 6.200 6.155
i9 177.750 2.500 68.596 6.000 5.988
i9 180.000 2.500 71.935 6.000 6.065
i9 180.170 2.500 72.407 6.000 5.973
i9 180.510 2.500 72.868 6.000 6.108
i9 181.020 2.500 70.275 6.000 6.029
i9 181.020 2.500 68.446 5.600 5.629
i9 181.530 2.500 68.288 6.000 5.986
i9 182.040 2.500 67.926 6.200 6.204
i9 182.550 2.500 66.641 6.000 5.960
i9 183.060 2.500 64.273 6.000 6.020
i9 183.570 2.500 64.425 6.200 6.195
i9 184.250 2.500 64.433 6.400 6.375
i9 184.760 2.500 63.310 6.400 6.382
i9 185.100 2.500 64.039 6.600 6.678
i9 185.950 2.500 64.792 6.400 6.395
i9 186.290 2.500 66.962 6.200 6.169
i9 186.460 2.500 68.769 6.200 6.215
i9 187.310 2.500 72.783 6.200 6.149
i9 188.330 2.500 71.330 6.200 6.175
i9 188.500 2.500 71.562 6.200 6.240
i9 189.350 2.500 72.666 6.200 6.169
i9 189.690 2.500 73.406 6.400 6.364
i9 190.200 2.500 72.588 6.600 6.573
i9 190.880 2.500 69.076 6.600 6.595
i9 191.050 2.500 69.535 6.800 6.789
i9 191.220 2.500 68.400 7.000 7.054
i9 191.390 2.500 67.791 7.000 6.985
i9 191.900 2.500 66.533 6.600 6.521
i9 192.240 2.500 66.758 6.600 6.518
i9 192.750 2.500 64.359 6.400 6.414
i4 194.000 1.333 68.395 6.000 6.061
i4 196.000 4.000 66.371 5.600 6.391
i4 202.000 8.000 63.654 6.500 7.024
i4 214.000 4.000 63.852 6.000 3.927
i4 220.000 13.333 68.119 6.200 6.535
i4 240.000 8.000 63.975 5.500 3.603
i9 194.000 2.500 66.785 7.400 7.075
i9 194.650 2.500 59.725 7.200 6.875
i9 195.300 2.500 66.936 7.400 7.140
i9 195.820 2.500 71.276 7.400 7.205
i9 196.210 2.500 77.060 7.800 7.410
i9 196.990 2.500 81.066 7.800 7.540
i9 197.510 2.500 71.409 6.800 6.670
i9 197.770 2.500 80.267 6.400 6.270
i9 198.030 2.500 77.309 6.200 6.070
i9 198.290 2.500 71.293 6.200 6.005
i9 198.680 2.500 71.176 6.200 6.005
i9 199.070 2.500 61.221 6.200 6.200
i9 199.070 2.500 64.472 6.000 5.805
i9 199.460 2.500 53.278 6.000 5.805
i9 199.850 2.500 78.009 5.800 5.670
i9 200.110 2.500 73.849 5.600 5.405
i9 200.500 2.500 78.770 5.600 5.275
i9 201.150 2.500 74.381 5.000 4.805
i9 201.540 2.500 79.754 5.200 5.005
i9 201.930 2.500 81.480 5.200 5.070
i9 202.190 2.500 70.616 5.000 4.610
i9 202.970 2.500 84.970 5.000 4.935
i9 203.100 2.500 83.847 5.200 4.940
i9 203.620 2.500 76.245 5.800 5.605
i9 204.010 2.500 72.765 5.200 5.005
i9 204.400 2.500 78.580 5.200 4.940
i9 204.920 2.500 64.770 5.400 5.010
i9 205.700 2.500 78.115 5.600 5.470
i9 205.960 2.500 80.299 5.800 5.605
i9 206.350 2.500 82.189 6.200 6.070
i9 206.610 2.500 72.091 6.200 5.940
i9 207.130 2.500 73.118 6.600 6.405
i9 207.520 2.500 85.580 5.800 5.735
i9 207.650 2.500 79.981 6.200 6.070
i9 207.910 2.500 76.848 6.600 6.210
i9 208.690 2.500 61.859 6.400 6.335
i9 208.820 2.500 69.854 6.600 6.210
i9 209.600 2.500 78.870 6.600 6.275
i9 210.250 2.500 78.194 6.600 6.275
i9 210.900 2.500 83.018 6.600 6.405
i9 211.290 2.500 75.260 6.600 6.535
i9 211.420 2.500 79.304 6.400 6.400
i9 211.420 2.500 81.483 6.400 6.075
i9 212.070 2.500 65.717 6.800 6.475
i9 212.720 2.500 71.167 6.800 6.800
i9 212.720 2.500 79.539 7.000 6.740
i9 213.240 2.500 80.091 7.000 7.000
i9 213.240 2.500 70.804 7.200 7.005
i9 213.630 2.500 79.954 7.200 6.875
i9 214.280 2.500 77.649 7.600 7.600
i9 214.280 2.500 66.186 7.400 7.205
i9 214.670 2.500 76.567 7.600 7.405
i9 215.060 2.500 69.031 7.800 7.410
i9 215.840 2.500 80.930 8.000 7.675
i9 216.490 2.500 63.033 7.400 7.335
i9 216.620 2.500 68.079 7.200 7.135
i9 216.750 2.500 74.431 7.200 6.810
i9 217.530 2.500 75.755 7.000 6.935
i9 217.660 2.500 66.043 6.800 6.605
i9 218.050 2.500 73.146 6.800 6.605
i9 218.440 2.500 73.058 7.000 6.740
i9 218.960 2.500 82.858 7.000 6.675
i9 219.610 2.500 77.535 7.000 6.805
i9 220.000 2.500 89.059 7.000 6.870
i9 220.260 2.500 61.037 7.400 7.270
i9 220.520 2.500 71.536 7.200 7.005
i9 220.910 2.500 65.029 7.600 7.470
i9 221.170 2.500 75.435 7.400 7.140
i9 221.690 2.500 71.079 7.400 7.140
i9 222.210 2.500 61.111 7.400 6.945
i9 223.120 2.500 77.695 7.400 7.140
i9 223.640 2.500 81.863 7.400 7.335
i9 223.770 2.500 61.122 7.200 7.005
i9 224.160 2.500 72.245 7.400 7.205
i9 224.550 2.500 66.703 7.400 7.270
i9 224.810 2.500 79.310 7.600 7.405
i9 225.200 2.500 70.357 7.200 6.875
i9 225.850 2.500 72.281 7.200 6.810
i9 226.630 2.500 76.744 7.600 7.275
i9 227.280 2.500 82.963 7.600 7.080
i9 228.320 2.500 74.522 7.400 7.140
i9 228.840 2.500 75.722 8.000 7.935
i9 228.970 2.500 69.979 8.000 7.610
i9 229.750 2.500 78.087 8.000 7.870
i9 230.010 2.500 70.021 8.200 8.005
i9 230.400 2.500 63.202 8.400 8.140
i9 230.920 2.500 73.380 8.400 8.270
i9 231.180 2.500 80.426 8.400 8.270
i9 231.440 2.500 71.640 8.800 8.605
i9 231.830 2.500 74.188 8.200 8.005
i9 232.220 2.500 59.578 8.600 8.405
i9 232.610 2.500 75.332 8.600 8.470
i9 232.870 2.500 84.557 8.200 8.070
i9 233.130 2.500 68.109 7.800 7.540
i9 233.650 2.500 77.044 7.000 6.935
i9 233.780 2.500 65.990 6.600 6.405
i9 234.170 2.500 80.104 5.800 5.670
i9 234.430 2.500 66.965 5.800 5.670
i9 234.690 2.500 80.579 6.000 5.610
i9 235.470 2.500 73.100 5.600 5.210
i9 236.250 2.500 71.049 5.600 5.470
i9 236.510 2.500 72.288 5.600 5.405
i9 236.900 2.500 75.477 5.400 5.075
i9 237.550 2.500 83.133 5.800 5.280
i9 238.590 2.500 81.749 5.800 5.670
i9 238.850 2.500 76.559 5.800 5.735
i9 238.980 2.500 71.293 5.600 5.535
i9 239.110 2.500 71.840 5.600 5.275
i9 239.760 2.500 78.053 5.600 5.405
i9 240.150 2.500 82.233 6.200 5.875
i9 240.800 2.500 58.835 6.200 6.200
i9 240.800 2.500 70.495 6.200 6.070
i9 241.060 2.500 80.488 6.200 5.940
i9 241.580 2.500 79.003 6.200 6.070
i9 241.840 2.500 84.508 6.200 6.135
i9 241.970 2.500 69.991 6.400 6.140
i9 242.490 2.500 72.510 6.400 5.035
i9 245.220 2.500 72.131 6.400 5.555
i9 246.910 2.500 77.833 6.800 6.020
i9 248.470 2.500 71.727 7.000 6.220
i9 250.030 2.500 64.468 7.400 6.815
i9 251.200 2.500 64.425 7.200 6.420
i9 252.760 2.500 73.761 7.200 6.420
i5 194.000 1.100 66.667 8.300 3
i5 194.560 1.100 66.156 8.500 3
i5 195.120 1.100 68.192 8.500 3
i5 195.960 1.100 68.294 8.500 3
i5 196.240 1.100 67.181 8.700 3
i5 197.640 1.100 67.596 8.500 3
i5 198.060 1.100 67.769 8.500 3
i5 198.900 1.100 68.981 8.500 3
i5 199.880 1.100 67.927 8.500 3
i5 200.440 1.100 66.511 9.100 3
i5 201.140 1.100 63.704 9.100 3
i5 201.840 1.100 62.231 8.300 3
i5 202.400 1.100 60.750 8.300 3
i5 203.100 1.100 60.598 8.500 3
i5 203.800 1.100 59.446 8.500 3
i5 204.640 1.100 59.715 8.300 3
i5 205.200 1.100 59.526 8.500 3
i5 205.900 1.100 55.650 7.900 3
i5 206.600 1.100 54.568 7.900 3
i5 207.440 1.100 52.153 7.900 3
i5 208.280 1.100 49.985 7.900 3
i5 208.700 1.100 50.702 7.900 3
i5 209.260 1.100 47.152 8.500 3
i5 209.680 1.100 45.622 8.900 3
i5 210.380 1.100 47.634 8.900 3
i5 210.660 1.100 45.213 8.900 3
i5 211.220 1.100 41.273 8.900 3
i5 212.480 1.100 41.556 8.500 3
i5 212.900 1.100 42.503 8.700 3
i5 214.020 1.100 41.833 8.700 3
i5 214.580 1.100 40.186 8.500 3
i5 215.420 1.100 36.161 8.900 3
i5 216.260 1.100 35.390 9.300 3
i5 217.520 1.100 35.491 9.500 3
i5 218.360 1.100 37.627 9.500 3
i5 218.640 1.100 39.211 9.500 3
i5 219.060 1.100 38.547 9.500 3
i5 219.620 1.100 38.130 9.500 3
i5 220.040 1.100 36.465 9.500 3
i5 220.460 1.100 33.418 9.300 3
i5 221.440 1.100 33.112 9.500 3
i5 222.140 1.100 32.469 9.500 3
i5 222.420 1.100 30.191 8.900 3
i5 223.260 1.100 29.379 8.900 3
i5 223.820 1.100 29.127 9.500 3
i5 224.240 1.100 29.839 9.500 3
i5 225.360 1.100 29.836 9.100 3
i5 225.920 1.100 26.973 9.500 3
i5 227.040 1.100 28.727 9.100 3
i5 228.580 1.100 28.884 9.100 3
i5 229.000 1.100 26.791 9.100 3
i5 230.260 1.100 26.129 9.100 3
i5 230.540 1.100 23.049 9.100 3
i5 230.680 1.100 23.805 9.300 3
i5 231.240 1.100 24.039 9.500 3
i5 232.080 1.100 23.346 9.900 3
i5 232.780 1.100 21.689 9.900 3
i5 233.200 1.100 20.685 9.900 3
i5 234.320 1.100 20.606 10.100 3
i5 235.020 1.100 22.068 9.900 3
i5 236.140 1.100 19.612 10.100 3
i5 236.840 1.100 16.452 10.100 3
i5 237.540 1.100 17.309 10.700 3
i5 237.680 1.100 16.891 10.700 3
i5 238.520 1.100 16.643 11.500 3
i5 239.220 1.100 13.912 11.500 3
i5 239.640 1.100 13.538 11.500 3
i5 239.920 1.100 12.806 11.500 3
i5 241.460 1.100 12.168 10.900 3
i5 241.880 1.100 9.774 11.100 3
i5 243.000 1.100 10.292 11.100 3
i5 243.560 1.100 9.896 10.900 3
i5 243.980 1.100 10.933 10.300 3
i5 244.540 1.100 11.458 10.300 3
i5 245.240 1.100 8.790 10.100 3
i5 245.660 1.100 10.783 10.100 3
i5 246.500 1.100 9.824 10.700 3
i5 246.920 1.100 7.920 10.700 3
i5 247.760 1.100 7.628 10.700 3
i5 248.180 1.100 2.593 10.700 3
i2 219.000 5.000 73.052 6.200 0.200 0.300 0.792 0.700 3
i2 223.600 5.000 72.784 6.500 0.200 0.300 0.562 0.700 3
i2 228.700 5.000 74.106 6.500 0.200 0.300 0.852 0.700 3
i2 233.600 5.000 71.695 6.400 0.200 0.300 1.085 0.700 3
i2 238.600 5.000 69.988 6.700 0.200 0.300 0.530 0.700 3
i2 244.800 5.000 69.380 6.900 0.200 0.300 0.460 0.700 3
i2 249.600 5.000 69.922 6.600 0.200 0.300 0.664 0.700 3
i2 254.500 5.000 69.842 6.900 0.200 0.300 0.832 0.700 3
i1 256.000 0.660 77.582 7.667 8.200 5.000 0.000 2
i1 256.660 0.700 78.569 8.056 8.644 5.000 -0.004 2
i1 257.360 0.540 79.678 8.667 9.100 5.000 -0.004 2
i1 257.900 0.520 83.449 7.222 7.958 5.000 -0.004 2
i1 258.420 0.880 77.669 8.333 7.124 5.000 0.003 2
i1 259.300 0.460 73.738 8.167 9.741 5.000 -0.000 2
i1 259.760 0.560 81.020 8.000 7.606 5.000 -0.040 2
i1 260.320 0.660 71.586 8.611 8.918 5.000 -0.052 2
i1 260.980 0.440 72.760 7.667 8.527 5.000 -0.089 2
i1 261.420 0.500 84.352 8.000 8.215 5.000 0.055 2
i1 261.920 0.780 75.748 7.889 7.521 5.000 -0.049 2
i1 262.700 0.460 70.944 7.944 7.947 5.000 0.073 2
i1 263.160 0.440 78.622 7.944 9.084 5.000 0.126 2
i1 263.600 0.600 73.647 7.556 7.338 5.000 -0.074 2
i1 264.200 0.500 77.228 8.167 8.111 5.000 0.161 2
i1 264.700 0.340 77.412 8.333 8.959 5.000 0.170 2
i1 265.040 0.460 69.551 8.500 8.218 5.000 0.081 2
i1 265.500 0.600 83.128 7.667 7.608 5.000 0.111 2
i1 266.100 0.500 73.864 8.000 9.076 5.000 -0.039 2
i1 266.600 0.420 74.443 7.667 7.994 5.000 0.182 2
i1 267.020 0.660 81.550 7.611 6.745 5.000 -0.077 2
i1 267.680 0.400 74.705 7.444 7.251 5.000 -0.121 2
i1 268.080 0.580 81.239 7.667 7.662 5.000 0.028 2
i1 268.660 0.440 73.193 8.056 7.539 5.000 0.133 2
i1 269.100 0.540 70.094 8.333 8.270 5.000 -0.162 2
i1 269.640 0.560 76.364 7.944 8.524 5.000 -0.156 2
i1 270.200 0.700 65.500 8.000 7.994 5.000 -0.169 2
i1 270.900 0.400 74.446 8.056 9.113 5.000 -0.146 2
i1 271.300 0.300 65.956 8.000 8.546 5.000 0.281 2
i1 271.600 0.520 70.910 8.278 8.082 5.000 0.144 2
i1 272.120 0.560 75.874 7.722 7.572 5.000 -0.059 2
i1 272.680 0.480 74.000 8.278 8.417 5.000 -0.229 2
i1 273.160 0.500 75.737 8.444 8.464 5.000 -0.072 2
i1 273.660 0.420 69.533 7.944 8.885 5.000 -0.254 2
i1 274.080 0.540 68.644 7.667 7.833 5.000 -0.238 2
i1 274.620 0.360 69.446 7.889 8.238 5.000 -0.203 2
i1 274.980 0.400 77.498 7.667 8.084 5.000 0.296 2
i1 275.380 0.580 80.811 8.333 8.416 5.000 -0.316 2
i1 275.960 0.380 68.744 7.278 7.412 5.000 0.282 2
i1 276.340 0.440 74.101 7.944 7.039 5.000 0.036 2
i1 276.780 0.400 79.199 7.389 8.201 5.000 0.386 2
i1 277.180 0.560 71.615 8.167 8.017 5.000 -0.169 2
i1 277.740 0.340 69.612 8.278 8.668 5.000 0.050 2
i1 278.080 0.420 69.453 8.222 8.174 5.000 -0.349 2
i1 278.500 0.400 74.984 8.000 8.101 5.000 -0.144 2
i1 278.900 0.320 75.404 8.000 8.002 5.000 0.248 2
i1 279.220 0.420 71.153 7.889 8.097 5.000 0.170 2
i1 279.640 0.280 68.820 8.056 7.730 5.000 0.198 2
i1 279.920 0.420 69.228 7.722 7.478 5.000 -0.063 2
i1 280.340 0.340 74.749 7.667 7.883 5.000 0.039 2
i1 280.680 0.440 79.457 7.611 7.530 5.000 -0.319 2
i1 281.120 0.300 66.880 7.722 8.076 5.000 0.061 2
i1 281.420 0.500 67.417 8.056 8.081 5.000 0.244 2
i1 281.920 0.320 65.918 8.389 8.633 5.000 -0.362 2
i1 282.240 0.280 74.687 7.722 7.702 5.000 0.294 2
i1 282.520 0.260 68.601 8.000 8.009 5.000 0.459 2
i1 282.780 0.320 79.544 7.667 7.809 5.000 -0.341 2
i1 283.100 0.540 74.848 8.000 7.816 5.000 -0.072 2
i1 283.640 0.320 72.664 7.944 7.882 5.000 -0.134 2
i1 283.960 0.280 63.379 7.833 7.324 5.000 0.361 2
i1 284.240 0.400 73.401 8.278 8.431 5.000 -0.094 2
i1 284.640 0.340 66.058 8.167 7.881 5.000 -0.241 2
i1 284.980 0.260 74.392 8.278 8.123 5.000 -0.559 2
i1 285.240 0.340 67.161 8.444 8.064 5.000 -0.147 2
i1 285.580 0.360 74.070 8.389 8.948 5.000 -0.450 2
i1 285.940 0.320 68.629 7.611 7.391 5.000 0.002 2
i1 286.260 0.300 79.478 7.556 7.289 5.000 0.323 2
i1 286.560 0.260 63.679 8.000 7.673 5.000 -0.141 2
i1 286.820 0.360 64.576 8.000 8.122 5.000 -0.201 2
i1 287.180 0.240 74.071 8.222 8.293 5.000 0.094 2
i1 287.420 0.320 70.823 8.222 7.663 5.000 0.594 2
i1 287.740 0.280 70.179 7.889 8.151 5.000 0.175 2
i1 288.020 0.180 71.510 8.222 8.724 5.000 0.622 2
i1 288.200 0.220 80.722 7.500 7.608 5.000 0.103 2
i1 288.420 0.180 62.859 7.333 7.455 5.000 0.171 2
i1 288.600 0.280 69.323 7.556 8.247 5.000 -0.637 2
i1 288.880 0.200 67.019 8.222 8.323 5.000 -0.047 2
i1 289.080 0.260 64.385 8.222 8.630 5.000 -0.568 2
i1 289.340 0.280 74.395 8.444 8.301 5.000 0.092 2
i1 289.620 0.380 70.539 7.500 7.694 5.000 0.660 2
i1 290.000 0.160 62.326 7.889 7.667 5.000 -0.121 2
i1 290.160 0.280 60.232 8.056 7.658 5.000 0.348 2
i1 290.440 0.240 71.454 8.111 8.023 5.000 -0.149 2
i1 290.680 0.180 60.317 7.778 7.806 5.000 -0.653 2
i1 290.860 0.220 67.960 7.944 7.811 5.000 -0.625 2
i1 291.080 0.420 74.983 8.667 8.726 5.000 0.144 2
i1 291.500 0.220 73.027 8.000 7.968 5.000 -0.201 2
i1 291.720 0.100 67.147 7.944 7.818 5.000 -0.545 2
i1 291.820 0.280 67.801 8.000 7.799 5.000 0.665 2
i1 292.100 0.280 70.029 8.167 8.253 5.000 0.165 2
i1 292.380 0.240 57.120 8.722 9.080 5.000 0.619 2
i1 292.620 0.140 60.276 7.889 7.521 5.000 -0.727 2
i1 292.760 0.260 69.977 7.722 7.756 5.000 -0.386 2
i1 293.020 0.340 76.588 7.611 7.446 5.000 -0.367 2
i1 293.360 0.260 73.183 8.167 8.484 5.000 0.060 2
i1 293.620 0.240 72.476 7.722 7.806 5.000 -0.223 2
i1 293.860 0.160 57.350 7.889 7.728 5.000 -0.506 2
i1 294.020 0.220 70.643 7.667 7.769 5.000 0.527 2
i1 294.240 0.280 57.910 8.167 8.372 5.000 0.594 2
i1 294.520 0.120 72.291 8.056 8.021 5.000 -0.421 2
i1 294.640 0.140 64.360 8.056 8.097 5.000 -0.769 2
i1 294.780 0.240 66.295 7.444 7.345 5.000 -0.015 2
i1 295.020 0.160 64.141 8.333 8.395 5.000 -0.764 2
i1 295.180 0.120 75.291 7.944 8.111 5.000 0.757 2
i1 295.300 0.160 66.322 8.722 8.831 5.000 0.511 2
i1 295.460 0.100 69.725 8.833 8.894 5.000 -0.523 2
i1 295.560 0.140 74.654 8.222 7.993 5.000 -0.064 2
i1 295.700 0.340 74.216 7.167 7.172 5.000 -0.402 2
i1 296.040 0.120 60.563 7.611 7.616 5.000 -0.700 2
i1 296.160 0.180 70.992 8.000 8.080 5.000 -0.282 2
i1 296.340 0.180 69.609 8.889 9.148 5.000 -0.587 2
i1 296.520 0.200 68.911 8.111 7.837 5.000 -0.271 2
i1 296.720 0.300 64.794 7.611 7.716 5.000 0.475 2
i1 297.020 0.180 66.852 7.444 7.607 5.000 0.678 2
i1 297.200 0.240 70.714 8.444 8.490 5.000 0.305 2
i1 297.440 0.220 68.257 8.444 8.442 5.000 -0.021 2
i1 297.660 0.140 67.478 8.222 8.096 5.000 0.255 2
i1 297.800 0.240 63.686 8.222 8.316 5.000 -0.454 2
i1 298.040 0.200 78.697 8.000 7.981 5.000 -0.296 2
i1 298.240 0.120 64.315 7.389 7.555 5.000 0.340 2
i1 298.360 0.160 61.851 8.167 8.260 5.000 -0.411 2
i1 298.520 0.120 63.769 7.611 7.758 5.000 0.134 2
i1 298.640 0.220 71.891 8.000 8.237 5.000 0.260 2
i1 298.860 0.260 74.349 7.556 7.562 5.000 0.468 2
i1 299.120 0.120 69.879 7.944 7.977 5.000 -0.153 2
i1 299.240 0.100 67.827 8.222 8.401 5.000 -0.635 2
i1 299.340 0.160 63.109 8.278 8.198 5.000 -0.097 2
i1 299.500 0.180 73.077 8.111 7.918 5.000 0.287 2
i1 299.680 0.160 67.336 8.056 7.905 5.000 0.266 2
i1 299.840 0.200 65.181 7.889 8.016 5.000 0.873 2
i1 300.040 0.140 64.096 8.111 7.880 5.000 -0.874 2
i1 300.180 0.120 69.436 7.944 7.949 5.000 0.340 2
i1 300.300 0.200 64.022 7.556 7.599 5.000 0.328 2
i1 300.500 0.220 64.218 7.167 7.051 5.000 0.365 2
i1 300.720 0.160 64.378 7.333 7.349 5.000 0.409 2
i1 300.880 0.260 65.209 8.278 8.301 5.000 -0.039 2
i1 301.140 0.080 68.587 8.000 8.011 5.000 0.336 2
i1 301.220 0.080 70.056 8.556 8.666 5.000 0.163 2
i1 301.300 0.180 72.199 7.944 7.929 5.000 0.442 2
i1 301.480 0.160 66.142 8.167 8.218 5.000 0.355 2
i1 301.640 0.080 72.286 8.222 8.284 5.000 0.911 2
i1 301.720 0.260 62.378 7.944 7.867 5.000 0.006 2
i1 301.980 0.240 66.242 8.056 8.072 5.000 -0.064 2
i1 302.220 0.160 63.972 8.222 8.317 5.000 0.733 2
i1 302.380 0.140 61.407 7.944 8.046 5.000 -0.626 2
i1 302.520 0.120 63.204 8.444 8.551 5.000 0.033 2
i1 302.640 0.100 66.228 8.556 8.511 5.000 -0.903 2
i1 302.740 0.100 63.081 8.556 8.550 5.000 -0.771 2
i1 302.840 0.060 66.257 7.722 7.622 5.000 -0.736 2
i1 302.900 0.180 60.488 8.278 8.226 5.000 0.563 2
i1 303.080 0.140 57.089 7.833 7.834 5.000 -0.664 2
i1 303.220 0.100 68.768 8.667 8.757 5.000 -0.493 2
i1 303.320 0.140 69.434 7.889 7.885 5.000 0.359 2
i1 303.460 0.180 65.956 8.278 8.285 5.000 -0.643 2
i1 303.640 0.120 60.803 8.000 7.964 5.000 -0.878 2
i1 303.760 0.100 57.405 7.389 7.376 5.000 0.764 2
i1 303.860 0.120 65.274 7.778 7.817 5.000 0.948 2
i1 303.980 0.160 72.079 8.000 7.969 5.000 0.703 2
i1 304.140 0.100 63.723 7.722 7.770 5.000 -0.027 2
i1 304.240 0.120 67.339 7.778 7.741 5.000 0.254 2
i1 304.360 0.080 67.679 8.722 8.755 5.000 0.671 2
i1 304.440 0.180 55.992 8.556 8.601 5.000 0.663 2
i1 304.620 0.140 64.717 8.278 8.253 5.000 -0.544 2
i1 304.760 0.080 69.821 8.444 8.412 5.000 0.257 2
i1 304.840 0.160 68.772 8.000 8.002 5.000 -0.780 2
i1 305.000 0.080 68.751 8.056 8.055 5.000 0.627 2
i1 305.080 0.020 62.711 8.611 8.599 5.000 0.657 2
i1 305.100 0.020 64.878 8.000 8.000 5.000 0.673 2
i1 305.120 0.100 64.659 7.833 7.848 5.000 -0.225 2
i1 305.220 0.040 70.657 7.889 7.904 5.000 0.732 2
i1 305.260 0.160 72.174 8.389 8.402 5.000 -0.474 2
i1 305.420 0.140 67.177 8.278 8.262 5.000 0.650 2
i1 305.560 0.100 52.945 7.500 7.495 5.000 0.396 2
i1 305.660 0.100 68.537 7.556 7.554 5.000 0.675 2
i1 305.760 0.120 61.344 7.444 7.445 5.000 0.795 2
i1 305.880 0.080 70.844 7.722 7.723 5.000 -0.587 2
i1 305.960 0.140 71.328 7.722 7.721 5.000 0.425 2
i2 256.000 5.000 80.000 8.222 0.200 0.300 0.705 0.700 3
i2 260.500 5.000 80.000 8.889 0.200 0.300 0.507 0.700 3
i2 263.900 5.000 80.000 8.667 0.200 0.300 0.903 0.700 3
i2 268.000 5.000 80.000 8.556 0.200 0.300 0.942 0.700 3
i2 271.200 5.000 80.000 8.444 0.200 0.300 0.823 0.700 3
i2 275.200 5.000 80.000 8.000 0.200 0.300 0.281 0.700 3
i2 279.600 5.000 80.000 8.000 0.200 0.300 0.581 0.700 3
i2 283.500 5.000 80.000 8.889 0.200 0.300 0.614 0.700 3
i2 288.400 5.000 80.000 8.444 0.200 0.300 0.933 0.700 3
i2 291.900 5.000 80.000 8.556 0.200 0.300 0.603 0.700 3
i2 296.100 5.000 80.000 8.667 0.200 0.300 0.522 0.700 3
i2 299.400 5.000 80.000 8.778 0.200 0.300 0.982 0.700 3
i2 304.000 5.000 80.000 8.778 0.200 0.300 0.444 0.700 3
i3 267.000 4.000 74.000 4.842 7.415 40.000 2.000 4
i3 272.000 4.000 74.000 5.393 10.163 40.000 2.000 4
i3 292.000 4.000 74.000 6.222 7.186 40.000 2.000 4
i3 308.000 4.000 74.000 5.015 3.915 40.000 2.000 4
i9 261.000 3.000 81.462 8.944 8.722
i9 265.000 3.000 77.036 6.833 6.611
i9 270.000 3.000 85.762 8.944 8.722
i9 273.000 3.000 80.491 6.722 6.500
i9 277.000 3.000 83.774 8.944 8.722
i9 279.000 3.000 81.103 7.944 7.722
i9 283.000 3.000 78.845 7.167 6.944
i9 289.000 3.000 81.216 9.611 9.389
i9 292.000 3.000 83.738 7.611 7.389
i9 296.000 3.000 82.716 9.278 9.056
i9 299.000 3.000 79.279 7.389 7.167
i9 301.000 3.000 84.335 8.389 8.167
i9 303.000 3.000 81.954 7.611 7.389
i9 305.000 3.000 80.133 9.611 9.389
i9 306.000 3.000 85.962 10.167 9.944
i3 300.000 10 75 6.00 4.8 13 1.5 4


</CsScore>
</CsoundSynthesizer>
