;; -*- cscsd-current-processing : "csound to dac" -*-
<About> ===================================================================

This is an example CSD file, "Study for computer" by John Endicott.

To hear it, click [[elisp:(cscsd-process)]] or use the "Process file" item
from the "CSD" menu ([[info:Csound-x:Interactive%20invocation%20from%20CSD][more details here]]). There is also an icon in the tool
bar, the rotating arrows.

================================================================== </About>

<CsoundSynthesizer>
<CsOptions>
</CsOptions>

<CsInstruments>
;STUDY FOR COMPUTER
;1997 JOHN ENDICOTT

sr        =         44100
kr        =         4410
ksmps     =         10
nchnls    =         2
               
garvbsig  init      0

          instr 1
icm       =         p8                            ; C:M RATIO
imod      =         p9                            ; MOD INDEX
ifm       =         p5*icm                        ; MOD FREQ
idfm      =         imod*ifm                      ; DEPTH
                                                  
; ADDITIVE FREQUENCY MODULATOR
     
     
kran      randi     1,.25
amod1     oscil     idfm*kran,p16*ifm,p6
amod2     oscil     idfm,p17*ifm,p6
     
aoutm     =         amod1+amod2
     
; FM CARRIER

kenv      linen     p13*p4,p14*p3,p3,p15*p3
asig      oscil     kenv,p5+aoutm,12
kenv linseg 0, 0.1*p3, 1.0, 0.7*p3, 0.9, 0.2*p3, 0     
     
aout=asig
     
     
; DELAY LINE

adel      delayr    .1*p3
kphs1     phasor    .01
adel1     deltap    kphs1
kphs2     phasor    .01
adel2     deltap    kphs2
kphs3     phasor    .01
adel3     deltap    kphs3
kphs4     phasor    .02
adel4     deltap    kphs4
kphs5     phasor    .02
adel5     deltap    kphs5
kphs6     phasor    .02
adel6     deltap    kphs6
kphs7     phasor    .03
adel7     deltap    kphs7
kphs8     phasor    .03
adel8     deltap    kphs8
kphs9     phasor    .03
adel9     deltap    kphs9
     
     
     
     
delayw    aout
aout1     =         adel1+adel2+adel3+adel4+adel5+adel6+adel7+adel8+adel9 
     
;FILTER BANK

afil1     butterlp  aout1,2000
;afil2     butterbr  afil1,50,10
     
     
     
;NORMALIZE AND STEREO OUTPUT

abal      balance   afil1,asig
     
kpan      line      p7,p3,abs(1-p7)

asigl,asigr,adum1,adum2  pan  abal,kpan,1,2,1,0
     
outs      asigl,asigr
     
;GLOBAL REVERB PATCH

garvbsig  =         aout*p10
          endin
          


instr     2    

kenv      linen     p4,p8*p3,p3,p9*p3
klin      line      p5,p3,p10
     
asig      oscil     kenv,klin,p6
     
;FILTER BANKS
     
acom1     comb      asig,p3,1/50
acmb1     comb      asig,p3,1/60
acob1     comb      asig,p3,1/70
aomb1     comb      asig,p3,1/80
amoc1     comb      asig,p3,1/90
abmc1     comb      asig,p3,1/100
aboc1     comb      asig,p3,1/110
abmo1     comb      asig,p3,1/120
abob1     comb      asig,p3,1/130
aboo1     comb      asig,p3,1/140
aooo1     comb      asig,p3,1/150
accc1     comb      asig,p3,1/160
abbb1     comb      asig,p3,1/170
ammm1     comb      asig,p3,1/180
aoob1     comb      asig,p3,1/190
aoutc1    =         acom1+acmb1+acob1+aomb1+amoc1+abmc1+aboc1+abmo1+abob1+aboo1+aooo1+accc1+abbb1+ammm1+aoob1
     
     
acom2     comb      asig,p3,1/200
acmb2     comb      asig,p3,1/210
acob2     comb      asig,p3,1/220
aomb2     comb      asig,p3,1/230
amoc2     comb      asig,p3,1/240
abmc2     comb      asig,p3,1/250
aboc2     comb      asig,p3,1/260
abmo2     comb      asig,p3,1/270
abob2     comb      asig,p3,1/280
aboo2     comb      asig,p3,1/290
aooo2     comb      asig,p3,1/300
accc2     comb      asig,p3,1/310
abbb2     comb      asig,p3,1/320
ammm2     comb      asig,p3,1/330
aoob2     comb      asig,p3,1/340
aoutc2    =         acom2+acmb2+acob2+aomb2+amoc2+abmc2+aboc2+abmo2+abob2+aboo2+aooo2+accc2+abbb2+ammm2+aoob2
     
     
     
acom3     comb      asig,p3,1/350
acmb3     comb      asig,p3,1/360
acob3     comb      asig,p3,1/370
aomb3     comb      asig,p3,1/380
amoc3     comb      asig,p3,1/390
abmc3     comb      asig,p3,1/400
aboc3     comb      asig,p3,1/410
abmo3     comb      asig,p3,1/420
abob3     comb      asig,p3,1/430
aboo3     comb      asig,p3,1/440
aooo3     comb      asig,p3,1/450
accc3     comb      asig,p3,1/460
abbb3     comb      asig,p3,1/470
ammm3     comb      asig,p3,1/480
aoob3     comb      asig,p3,1/490
aoutc3    =         acom3+acmb3+acob3+aomb3+amoc3+abmc3+aboc3+abmo3+abob3+aboo3+aooo3+accc3+abbb3+ammm3+aoob3

          
     
acom4     comb      asig,p3,1/500
acmb4     comb      asig,p3,1/510
acob4     comb      asig,p3,1/520
aomb4     comb      asig,p3,1/530
amoc4     comb      asig,p3,1/540
abmc4     comb      asig,p3,1/550
aboc4     comb      asig,p3,1/560
abmo4     comb      asig,p3,1/570
abob4     comb      asig,p3,1/580
aboo4     comb      asig,p3,1/590
aooo4     comb      asig,p3,1/600
accc4     comb      asig,p3,1/610
abbb4     comb      asig,p3,1/620
ammm4     comb      asig,p3,1/630
aoob4     comb      asig,p3,1/640
aoutc4    =         acom4+acmb4+acob4+aomb4+amoc4+abmc4+aboc4+abmo4+abob4+aboo4+aooo4+accc4+abbb4+ammm4+aoob4
     
          
     
acom5     comb      asig,p3,1/650
acmb5     comb      asig,p3,1/660
acob5     comb      asig,p3,1/670
aomb5     comb      asig,p3,1/680
amoc5     comb      asig,p3,1/690
abmc5     comb      asig,p3,1/700
aboc5     comb      asig,p3,1/710
abmo5     comb      asig,p3,1/720
abob5     comb      asig,p3,1/730
aboo5     comb      asig,p3,1/740
aooo5     comb      asig,p3,1/750
accc5     comb      asig,p3,1/760
abbb5     comb      asig,p3,1/770
ammm5     comb      asig,p3,1/780
aoob5     comb      asig,p3,1/790
aoutc5    =         acom5+acmb5+acob5+aomb5+amoc5+abmc5+aboc5+abmo5+abob5+aboo5+aooo5+accc5+abbb5+ammm5+aoob5
     
     
acom6     comb      asig,p3,1/800
acmb6     comb      asig,p3,1/810
acob6     comb      asig,p3,1/820
aomb6     comb      asig,p3,1/830
amoc6     comb      asig,p3,1/840
abmc6     comb      asig,p3,1/850
aboc6     comb      asig,p3,1/860
abmo6     comb      asig,p3,1/870
abob6     comb      asig,p3,1/880
aboo6     comb      asig,p3,1/890
aooo6     comb      asig,p3,1/900
accc6     comb      asig,p3,1/910
abbb6     comb      asig,p3,1/920
ammm6     comb      asig,p3,1/930
aoob6     comb      asig,p3,1/940
aoutc6    =         acom6+acmb6+acob6+aomb6+amoc6+abmc6+aboc6+abmo6+abob6+aboo6+aooo6+accc6+abbb6+ammm6+aoob6
     
     
acom7     comb      asig,p3,1/950
acmb7     comb      asig,p3,1/960
acob7     comb      asig,p3,1/970
aomb7     comb      asig,p3,1/980
amoc7     comb      asig,p3,1/990
abmc7     comb      asig,p3,1/1000
aboc7     comb      asig,p3,1/1110
abmo7     comb      asig,p3,1/1120
abob7     comb      asig,p3,1/1130
aboo7     comb      asig,p3,1/1140
aooo7     comb      asig,p3,1/1150
accc7     comb      asig,p3,1/1160
abbb7     comb      asig,p3,1/1170
ammm7     comb      asig,p3,1/1180
aoob7     comb      asig,p3,1/1190
aoutc7    =         acom7+acmb7+acob7+aomb7+amoc7+abmc7+aboc7+abmo7+abob7+aboo7+aooo7+accc7+abbb7+ammm1+aoob7
     
     
acom8     comb      asig,p3,1/1200
acmb8     comb      asig,p3,1/1210
acob8     comb      asig,p3,1/1220
aomb8     comb      asig,p3,1/1230
amoc8     comb      asig,p3,1/1240
abmc8     comb      asig,p3,1/1250
aboc8     comb      asig,p3,1/1260
abmo8     comb      asig,p3,1/1270
abob8     comb      asig,p3,1/1280
aboo8     comb      asig,p3,1/1290
aooo8     comb      asig,p3,1/1300
accc8     comb      asig,p3,1/1310
abbb8     comb      asig,p3,1/1320
ammm8     comb      asig,p3,1/1330
aoob8     comb      asig,p3,1/1340
aoutc8    =         acom8+acmb8+acob8+aomb8+amoc8+abmc8+aboc8+abmo8+abob8+aboo8+aooo8+accc8+abbb8+ammm8+aoob8
     
     
acom9     comb      asig,p3,1/1350
acmb9     comb      asig,p3,1/1360
acob9     comb      asig,p3,1/1370
aomb9     comb      asig,p3,1/1380
amoc9     comb      asig,p3,1/1390
abmc9     comb      asig,p3,1/1400
aboc9     comb      asig,p3,1/1410
abmo9     comb      asig,p3,1/1420
abob9     comb      asig,p3,1/1430
aboo9     comb      asig,p3,1/1440
aooo9     comb      asig,p3,1/1450
accc9     comb      asig,p3,1/1460
abbb9     comb      asig,p3,1/1470
ammm9     comb      asig,p3,1/1480
aoob9     comb      asig,p3,1/1490
aoutc9    =         acom9+acmb9+acob9+aomb9+amoc9+abmc9+aboc9+abmo9+abob9+aboo9+aooo9+accc9+abbb9+ammm9+aoob9
     
     
acom10    comb      asig,p3,1/1500
acmb10    comb      asig,p3,1/1510
acob10    comb      asig,p3,1/1520
aomb10    comb      asig,p3,1/1530
amoc10    comb      asig,p3,1/1540
abmc10    comb      asig,p3,1/1550
aboc10    comb      asig,p3,1/1560
abmo10    comb      asig,p3,1/1570
abob10    comb      asig,p3,1/1580
aboo10    comb      asig,p3,1/1590
aooo10    comb      asig,p3,1/1600
accc10    comb      asig,p3,1/1610
abbb10    comb      asig,p3,1/1620
ammm10    comb      asig,p3,1/1630
aoob10    comb      asig,p3,1/1640
aoutc10   =         acom10+acmb10+acob10+aomb10+amoc10+abmc10+aboc10+abmo10+abob10+aboo10+aooo10+accc10+abbb10+ammm10+aoob10
     
aout      =         aoutc1+aoutc2+aoutc3+aoutc4+aoutc5+aoutc6+aoutc7+aoutc8+aoutc9+aoutc10
afilx     butterlp  aout,p11
     
;STEREO OUTPUT

abal      balance   afilx,asig

kpan      line      p7,p3,abs(1-p7)

asigl,asigr,adum1,adum2  pan  abal,kpan,1,2,1,0

outs      asigl,asigr

garvbsig  =         abal*1
          endin
     

instr     3
     
;CARRIERS

kllin     linseg    0,.5*p3,10,.5*p3,0
     
     
atble     oscil     kllin,10,p6
     
     
     
ksig1     linen     p4,p9*p3,p3,p10*p3
asgl1     oscil     ksig1,(p5/1*p11)+atble,p6

ksig2     linen     p4,p9*p3,p3,p10*p3
asgl2     oscil     ksig2,(p5/1.11*p11)+atble,p6


ksig3     linen     p4,p9*p3,p3,p10*p3
asgl3     oscil     .01*ksig3,(p5/1.12*p11)+atble,p6

ksig4     linen     p4,p9*p3,p3,p10*p3
asgl4     oscil     ksig4,(p5/1.13*p11)+atble,p6
     
     
ksig5     linen     p4,p9*p3,p3,p10*p3
asgl5     oscil     .01*ksig5,(p5/1.14*p11)+atble,p6

ksig6     linen     p4,p9*p3,p3,p10*p3
asgl6     oscil     ksig6,(p5/1.15*p11)+atble,p6


ksig7     linen     p4,p9*p3,p3,p10*p3
asgl7     oscil     .01*ksig7,(p5/1.16*p11)+atble,p6

ksig8     linen     p4,p9*p3,p3,p10*p3
asgl8     oscil     ksig8,(p5/1.17*p11)+atble,p6


ksig9     linen     p4,p9*p3,p3,p10*p3
asgl9     oscil     .01*ksig9,(p5/1.18*p11)+atble,p6

ksig10    linen     p4,p9*p3,p3,p10*p3
asgl10    oscil     ksig10,(p5/1.19*p11)+atble,p6
     
aout      =         asgl1+asgl2+asgl3+asgl4+asgl5+asgl6+asgl7+asgl8+asgl9+asgl10
     
afil      tone      aout,p12
     
abal      balance   afil,asgl1
     
     
kpan      line      p7,p3,abs(1-p7)

asigl,asigr,adum1,adum2   pan   abal,kpan,1,2,1,0
     
          outs      asigl,asigr

;GLOBAL REVERB PATCH

garvbsig  =         aout*p8
          endin


instr 99

;GLOBAL REVERB INSTRUMENT

arvb      reverb    garvbsig,p4
          outs      arvb,arvb
gareverb  =         0
          endin
</CsInstruments>

<CsScore>
;#define MidiPhraseDuration ##
;f0 $MidiPhraseDuration.

;STUDY FOR COMPUTER
;1997 JOHN ENDICOTT

;instr    1
;p2       =         START TIME
;p3       =         DURATION
;p4       =         AMPLITUDE
;p5       =         FREQUENCY
;p6       =         FUNCTION TABLE
;p7       =         STEREO OUTPUT
;p8       =         C:M RATIO(MOSTLY 1, USE GREATER THAN 1 WHEN PITCH IS [500-1900)
;p9       =         MODULATION INDEX (1 AND LESS, FOR SKINNY BANDWIDTH) 
;p10      =         PERCENT OF GLOBAL REVERB OUTPUT (.01-.5 MULTIPLIED BY INSTR OUTPUT)
;p11      =         LOW-PASS CUT-OFF, AS A PERCENTAGE(OR MULTIPLICATION) OF THE FREQUENCY(p5)
;p12      =         HIGH-PASS CUT-OFF, AS A PERCENTAGE OF p5
;p13      =         ATTENUATION
;p14      =         RISE
;p15      =         DECAY

;instr    2
;p2       =         START TIME
;p3       =         DURATION
;p4       =         AMPLITUDE
;p5       =         START FREQUENCY
;p6       =         FUNCTION TABLE
;p7       =         STEREO OUT
;p8       =         ENDING FREQUENCY
;p9       =         RISE
;p10      =         DECAY

;instr    3
;p2       =         START TIME
;p3       =         DURATION
;p4       =         AMPLITUDE
;p5       =         FREQUENCY
;p6       =         FUNCTION TABLE
;p7       =         STEREO OUT
;p8       =         GLOBAL REVERB GAIN
;p9       =         RISE
;p10      =         DECAY
;p11      =         DISTANCE BETWEEN PITCHES IN EASH oscil(p5/1*p11)*atble
;p12      =         LOW  PASS FIL CUT-OFF

f1   0	8193  9	  .1	1   0 
f2   0	8193  9	  .25	1   0 
f3   0	8193  9	  .3	1   0    
f4   0	8193  9	  .4	1   0    
f5   0	8193  9	  .5	1   0 
f6   0	512   9	  .6	1   1 
f7   0	512   9	  .7	1   1 
f8   0	512   9	  .8	1   1 
f9   0	512   9	  .9	1   1 
f10  0	512   10  1    
f11  0	512   10  1	.5  .3	  .25  .2   .167  .14	.125  .111  
f12  0	512   10  1	0   .3	  0    .2   0	  .14	0     .111 
f13  0	512   10  1	1   1	  1    .7   .3	  .1 
f14  0	512   9	  150	50  -150  50   150  50	  -150	50    150    50	 -150  50  150	50  -150  50  150  50  -150  50	 150  50  1  50 
f15  0	8193  13  1	1   0	  1    -1   2	  -2	1     .5     .2	 .3 ; Chebyshev polynomial 1st kind
f16  0	512   7	  150	10  1	  500  1    1  

; i99     0    6    1.2


; BEGINNING????

i3 0      1   10000  1500  10  1   .01  .001  .9  1  200
i2 1      .9  15000  1050  11  0   .1  .9  500   2000
i2 2.2    .5  15000  900   11  1   .1  .9  400   2000
i3 2.7    1   10000  1500  10  1   .01  .001  .9  1  200
i1 3.7    5   10000  100   11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i3 4      .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1500  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1600  10  1   .01  .001  .9  1  200
i3 4.6    .1  10000  1700  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1100  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1300  10  0   .01  .001  .9  1  200
i3 5.2    .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1500  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1600  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1700  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1100  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1300  10  0   .01  .001  .9  1  200
i2 5.9    .1  5000   800   11  0   .1  .9  800   2000
i2 +      .   .      770   .   .   .   .   870   2000
i2 .      .   .      850   .   .   .   .   850   2000
i2 .      .   .      800   .   .   .   .   800   2000
i2 .      .   .      600   .   .   .   .   600   2000
i2 .      .   .      700   .   .   .   .   700   2000
i3 6.7    .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200
i3 +      .1  10000  980   10  0   .01  .001  .9  1  200
i3 +      .1  10000  1110  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1200  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1320  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1400  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1530  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1670  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1800  10  1   .01  .001  .9  1  200
i2 8.1    1   15000  100   11  0   .1  .9  800   2000
i3 9.1    2   15000  100   11  .5  .01  .001  .9  1  200
i1 11.1   7   10000  100   11  .5  1  1     1  .5  .5  1  .5   .5  1  1.5
i3 11.4   .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1500  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1600  10  1   .01  .001  .9  1  200
i3 12.1   .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1500  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1600  10  1   .01  .001  .9  1  200
i3 12.7   .1  10000  1700  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1100  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1300  10  0   .01  .001  .9  1  200
i3 13.3   .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1500  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1600  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1700  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1100  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1300  10  0   .01  .001  .9  1  200
i2 14     .1  5000   800   11  0   .1  .9  800   2000
i2 +      .   .      600   .   .   .   .   600   2000
i2 .      .   .      850   .   .   .   .   850   2000
i2 .      .   .      700   .   .   .   .   700   2000
i2 .      .   .      600   .   .   .   .   600   2000
i2 .      .   .      950   .   .   .   .   950   2000
i3 14.8   .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200
i3 +      .1  10000  980   10  0   .01  .001  .9  1  200
i3 +      .1  10000  1110  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1200  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1320  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1400  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1530  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1670  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1800  10  1   .01  .001  .9  1  200
i3 15.8   .1  8000   1100  10  1   .01  .001  .9  1  200
i3 +      .1  8000   100   10  0   .01  .001  .9  1  200
i3 +      .1  8000   150   10  1   .01  .001  .9  1  200
i3 +      .1  8000   240   10  0   .01  .001  .9  1  200
i3 +      .1  8000   300   10  1   .01  .001  .9  1  200
i3 +      .1  8000   380   10  0   .01  .001  .9  1  200
i3 +      .1  8000   510   10  1   .01  .001  .9  1  200
i3 +      .1  8000   600   10  0   .01  .001  .9  1  200
i3 +      .1  8000   720   10  1   .01  .001  .9  1  200
i3 +      .1  8000   800   10  0   .01  .001  .9  1  200
i3 +      .1  8000   930   10  1   .01  .001  .9  1  200
i3 +      .1  8000   1070  10  0   .01  .001  .9  1  200
i3 +      .1  8000   1100  10  1   .01  .001  .9  1  200
i3 +      .1  8000   1200  10  1   .01  .001  .9  1  200
i3 16.3   .1  10000  700   10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200
i3 +      .1  10000  980   10  0   .01  .001  .9  1  200
i3 +      .1  10000  1110  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1200  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1320  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1400  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1530  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1670  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1800  10  1   .01  .001  .9  1  200
i2 17.7   1   15000  1250  11  0   .1  .9  700   2000
i2 +      .1  10000  1900  .   1   .   .   1100  2000
i2 .      .   .      1100  .   0   .   .   1900  .
i2 .      .   .      1900  .   1   .   .   1100  .
i2 .      .   .      1100  .   0   .   .   1900  .


i1 18.8   12  10000  120   11  .5  1  1     1  .5  .5  1  .5   .5  1  1.5
i1 20     7   10000  150   .   .   .  .001  .  .   .   .  .    .   .  .
i1 22     6   .      170   .   .   .  .001  .  .   .   .  .    .   .  .
i1 25.8   10  .      80    11  .5  1  .001  .  .   .   .  .    .   .  .
i1 28     6   5000   130   11  1   .  .001  .  .   .   .  .    .   .  1
i1 30     4   5000   160   11  0   .  .001  .  .   .   .  .    .   .  1

i2 18.5   1   15000  1300  11  .5  .1  .9  800   2000
i2 19.5   .1  5000   900   11  .5  .1  .9  900   .
i2 +      .   .      1100  .   .   .   .   1100  .
i2 +      .   .      800   .   .   .   .   800   .

i2 21.1   1   15000  1000  .   .   .   .   700   .
i2 22.1   .1  5000   900   .   .   .   .   900   .
i2 +      .   .      700   .   .   .   .   700   .
i2 +      .   .      1100  .   .   .   .   1100  .

i2 24     1   15000  1400  .   .   .   .   1200  .
i2 25     .1  5000   1000  .   .   .   .   1000  .
i2 +      .   .      900   .   .   .   .   900   .
i2 +      .   .      1100  .   .   .   .   1100  .
i2 25.8   .   .      1500  .   .   .   .   1500  .
i2 +      .   .      1300  .   .   .   .   1300  .
i2 +      .   .      1600  .   .   .   .   1600  .

i2 26.5   1   15000  1300  .   .   .   .   900   .
i2 27.5   .1  5000   1200  .   .   .   .   1200  .
i2 +      .   .      1400  .   .   .   .   1400  .
i2 +      .   .      1100  .   .   .   .   1100  .
i2 28.1   .   .      1300  .   .   .   .   1300  .
i2 +      .   .      1400  .   .   .   .   1400  .
i2 +      .   .      1100  .   .   .   .   1100  .

i2 28.7   1   15000  1500  .   .   .   .   1100  .
i2 29.7   .1  5000   900   .   .   .   .   900   .
i2 +      .   .      1100  .   .   .   .   1400  .
i2 +      .   .      800   .   .   .   .   800   .

i2 30.5   2   15000  900   .   .   .   .   600   .
i2 32.5   .1  5000   1000  .   .   .   .   1000  .
i2 +      .   .      1400  .   .   .   .   1400  .
i2 +      .   .      1100  .   .   .   .   1100  .
i2 33.1   .   .      700   .   .   .   .   700   .
i2 +      .   .      800   .   .   .   .   800   .
i2 +      .   .      600   .   .   .   .   600   .
i2 33.7   .   .      1200  .   .   .   .   1200  .
i2 +      .   .      1400  .   .   .   .   1400  .
i2 +      .   .      1100  .   .   .   .   1100  .

i3 34     2   10000  100   10  .5  .01  .001  .9  1  200
i1 34     20  15000  80    11  .5  1  1     1  .5  .5  1  .1   .1  1  1.5
i3 55     3   15000  110   10  .5  .01  .001  .9  1  200
i3 55     3   15000  55    10  .5  .    .     .   .  .
i3 58     .   .      55    .   .   .    .     .   .  .
i3 58     .   .      110   .   .   .    .     .   .  .

i2 34.5   1   15000  1300  11  .5  .1  .9  800   2000
i2 35.5   .1  .      900   11  .5  .1  .9  900   .
i2 +      .   .      1100  .   .   .   .   1100  .
i2 +      .   .      800   .   .   .   .   800   .

i2 37.1   1   15000  1000  .   .   .   .   700   .
i2 38.1   .1  .      900   .   .   .   .   900   .
i2 +      .   .      700   .   .   .   .   700   .
i2 +      .   .      1100  .   .   .   .   1100  .

i2 40     1   15000  1400  .   .   .   .   1200  .
i2 41     .1  .      1000  .   .   .   .   1000  .
i2 +      .   .      900   .   .   .   .   900   .
i2 +      .   .      1100  .   .   .   .   1100  .
i2 42.8   .   .      1500  .   .   .   .   1500  .
i2 +      .   .      1300  .   .   .   .   1300  .
i2 +      .   .      1600  .   .   .   .   1600  .

i2 43.5   1   15000  1300  .   .   .   .   900   .
i2 44.5   .1  .      1200  .   .   .   .   1200  .
i2 +      .   .      1400  .   .   .   .   1400  .
i2 +      .   .      1100  .   .   .   .   1100  .
i2 45.1   .   .      1300  .   .   .   .   1300  .
i2 +      .   .      1400  .   .   .   .   1400  .
i2 +      .   .      1100  .   .   .   .   1100  .

i2 45.7   1   15000  1500  .   .   .   .   1100  .
i2 46.7   .1  .      900   .   .   .   .   900   .
i2 +      .   .      1100  .   .   .   .   1400  .
i2 +      .   .      800   .   .   .   .   800   .

i2 47.5   1   15000  900   .   .   .   .   600   .
i2 48.5   .1  .      1000  .   .   .   .   1000  .
i2 +      .   .      1400  .   .   .   .   1400  .
i2 +      .   .      1100  .   .   .   .   1100  .
i2 49.1   .   .      700   .   .   .   .   700   .
i2 +      .   .      800   .   .   .   .   800   .
i2 +      .   .      600   .   .   .   .   600   .
i2 49.7   .   .      1200  .   .   .   .   1200  .
i2 +      .   .      1400  .   .   .   .   1400  .
i2 +      .   .      1100  .   .   .   .   1100  .

i3 50     .1  10000  700   10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200

i3 50.5   .1  10000  700   10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200
i3 +      .1  10000  980   10  0   .01  .001  .9  1  200
i3 +      .1  10000  1110  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1200  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1320  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1400  10  0   .01  .001  .9  1  200
i3 51.5   .1  10000  1530  10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200
i3 +      .1  10000  980   10  0   .01  .001  .9  1  200
i3 +      .1  10000  1110  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1200  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1320  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1400  10  0   .01  .001  .9  1  200
i3 52.5   .1  10000  1530  10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200
i3 +      .1  10000  980   10  0   .01  .001  .9  1  200
i3 +      .1  10000  1110  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1200  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1320  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1400  10  0   .01  .001  .9  1  200
i3 53.5   .1  10000  1530  10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200
i3 +      .1  10000  980   10  0   .01  .001  .9  1  200
i3 +      .1  10000  1110  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1200  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1320  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1400  10  0   .01  .001  .9  1  200
i3 54.5   .1  10000  1530  10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200


i3 +      .1  10000  980   10  0   .01  .001  .9  1  200
i3 +      .1  10000  1110  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1200  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1320  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1400  10  0   .01  .001  .9  1  200
i3 51     .1  10000  1530  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1670  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1800  10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200
i3 52     .1  10000  980   10  0   .01  .001  .9  1  200
i3 +      .1  10000  1110  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1200  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1320  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1400  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1530  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1670  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1800  10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  1   .01  .001  .9  1  200
i3 53     .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200
i3 +      .1  10000  980   10  0   .01  .001  .9  1  200
i3 +      .1  10000  1110  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1200  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1320  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1400  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1530  10  1   .01  .001  .9  1  200
i3 54     .1  10000  1670  10  0   .01  .001  .9  1  200
i3 +      .1  10000  1700  10  1   .01  .001  .9  1  200
i3 +      .1  10000  1800  10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  1   .01  .001  .9  1  200
i3 +      .1  10000  700   10  0   .01  .001  .9  1  200
i3 +      .1  10000  750   10  1   .01  .001  .9  1  200
i3 +      .1  10000  840   10  0   .01  .001  .9  1  200
i3 +      .1  10000  900   10  1   .01  .001  .9  1  200
i3 +      .1  10000  980   10  0   .01  .001  .9  1  200
i3 +      .1  10000  1110  10  1   .01  .001  .9  1  200
i3 55     .1  10000  1200  10  0   .01  .001  .9  1  200


;a section near the end
;  p2     p3  p4     p5    p6   p7 p8 p9    p10 p11 p12p13p14  p15 p16p17
i1 60     30  10000  110   11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 67     5   10000  110   12  .5  1  1     1  .5  .5  1  .    .   1  1.5
i1 77     .   10000  110   12  .5  1  1     1  .5  .5  1  .    .   1  1.5
i1 83     .   5000   210   11  .5  1  .001  1  .5  .5  1  .    .   1  1.5
i1 83     .   5000   131   11  .5  1  .001  1  .5  .5  1  .    .   1  1.5
i1 84     10  10000  123   12  .5  1  1     1  .5  .5  1  .9   .1  1  1.5
i1 94     .   10000  98    12  .5  1  1     1  .5  .5  1  .1   .9  1  1.5

i2 83     14  10000  440   11  0   .1  .1  220   2000

i2 100    1   10000  900   11  1   .1  .1  600   200
i2 101    1   10000  1100  11  0   .1  .1  700   200
i3 102    2   15000  110   10  .5  .01  .001  .9  1  200
i3 104    3   15000  110   10  .5  .01  .001  .9  1  200
i1 104    20  5000   110   12  .5  1  1     1  .5  .5  1  .    .   1  1.5

i3 109    1   10000  55    10  .5  .01  .001  .9  1  200
i1 109    5   10000  55    11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i3 115    1   10000  55    10  .5  .01  .001  .9  1  200
i1 115    5   10000  55    11  .   .  .     .  .   .   .  .    .   .  .

i3 121    1   10000  55    10  .5  .01  .001  .9  1  200
i3 123    1   10000  55    10  .5  .01  .001  .9  1  200


i2 121.1  .1  10000  900   .   .   .   .   900   .
i2 +      .   .      700   .   .   .   .   700   .
i2 +      .   .      1100  .   .   .   .   1100  .

i2 123.1  .1  10000  1100  .   .   .   .   1100  .
i2 +      .   .      700   .   .   .   .   700   .
i2 +      .   .      900   .   .   .   .   900   .
;;;;to here







     
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;LAST 30 SEC BEFORE THE END

i2 124    .1  10000  1300  .   .   .   .   1100  .
i2 +      .   .      900   .   .   .   .   700   .
i2 +      .   .      1100  .   .   .   .   900   .

i3 124    4   20000  55    13  .5  .01  .001  .9  1  200
i3 124    4   20000  110   13  .5  .01  .001  .9  1  200

i2 128    .1  10000  1500  .   .   .   .   1100  .
i2 +      .   .      1100  .   .   .   .   700   .
i2 +      .   .      1300  .   .   .   .   900   .

i3 128    4   20000  55    13  .5  .01  .001  .9  1  200
i3 128    4   20000  110   13  .5  .01  .001  .9  1  200
i3 132    3   20000  55    13  .5  .01  .001  .9  1  200

i1 133    .1  10000  1500  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .1  10000  880   11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .1  10000  1300  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 133.5  .1  10000  1500  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .1  10000  880   11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .1  10000  1300  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .1  10000  1600  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .1  10000  1800  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .1  10000  2100  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .1  10000  1200  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5

i2 134.2  1   10000  1000  11  1   .1  .9  440   2000

i3 134.2  .9  20000  55    13  .5  .01  .001  .9  1  200
i3 135.1  1   5000   880   10  0   .01  .001  .9  1  200
i3 136.1  20  20000  55    13  .5  .01  .001  .9  1  200

i3 137.5  .1  10000  1500  10  1   .01  .001  .9  1  200
i3 137.8  .1  10000  880   10  1   .01  .001  .9  1  200
i3 138.2  .1  10000  1300  10  1   .01  .001  .9  1  200
i3 138.5  .1  10000  1500  10  1   .01  .001  .9  1  200
i3 138.8  .1  10000  880   10  1   .01  .001  .9  1  200
i3 138.5  .1  10000  1300  10  1   .01  .001  .9  1  200

i2 141    .1  20000  1500  13  1   .7  .3  600   2000
i2 +      .   .      200   13  1   .7  .3  1100  2000
i2 .      .   .      1300  .   .   .   .   800   .
i2 .      .   .      500   .   .   .   .   1000  .
i2 .      .   .      1800  .   .   .   .   900   .
i2 .      .   .      600   .   .   .   .   1500  .
i2 .      .   .      1800  .   .   .   .   500   .
i2 .      .   .      400   .   .   .   .   1200  .
i2 .      .   .      1300  .   .   .   .   800   .
i2 .      .   .      500   .   .   .   .   1900  .
i2 .      .   .      1700  .   .   .   .   1200  .
i2 .      .   .      1000  .   .   .   .   1800  .
i2 .      .   .      1600  .   .   .   .   120   .



i3 142.3  .1  10000  1500  10  1   .01  .001  .9  1  200
i3 +      .   .      200   .   0   .    .     .   .  .
i3 .      .   .      1300  .   1   .    .     .   .  .
i3 .      .   .      500   .   0   .    .     .   .  .
i3 .      .   .      1800  .   1   .    .     .   .  .
i3 .      .   .      600   .   0   .    .     .   .  .
i3 .      .   .      1800  .   1   .    .     .   .  .
i3 .      .   .      400   .   0   .    .     .   .  .
i3 .      .   .      1300  .   1   .    .     .   .  .
i3 .      .   .      500   .   0   .    .     .   .  .
i3 .      .   .      1700  .   1   .    .     .   .  .
i3 .      .   .      1000  .   0   .    .     .   .  .
i3 .      .   .      1600  .   1   .    .     .   .  .

i1 143.6  1   5000   1500  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .5  5000   200   11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   1300  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   500   11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   1800  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   600   11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .1  5000   1800  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   400   11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   1300  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   500   11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   1700  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   1000  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   1600  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5

i3 149.6  .1  .      1700  .   1   .    .     .   .  .
i3 +      .   .      1000  .   0   .    .     .   .  .
i3 .      .   .      1600  .   1   .    .     .   .  .

i1 151    .1  5000   1800  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   400   11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   1300  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5

i2 153    .1  .      400   .   .   .   .   1200  .
i2 +      .   .      1300  .   .   .   .   800   .
i2 .      .   .      500   .   .   .   .   1900  .

i1 154    .1  5000   1600  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   400   11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5
i1 +      .   5000   1700  11  .5  1  .001  1  .5  .5  1  .5   .5  1  1.5

i3 155.4  3   10000  880   10  0   .01  .001  .9  1  200

i3 157    3   10000  110   10  0   .01  .001  .9  1  200

i3 161    3   10000  110   10  0   .01  .001  .9  1  200

i3 163    3   10000  55    10  0   .01  .001  .9  1  200
i3 163    3   10000  110   10  0   .01  .001  .9  1  200

; USE LATER IN THIS SECTION (TOWARDS END)

i2 155.4  2   15000  500   11  1   .9  .1  1500  2000
i2 157    3   15000  440   11  1   .9  .1  1300  2000
i2 161    2   15000  300   11  1   .9  .1  1800  2000
i2 163    3   15000  200   11  1   .9  .1  1400  2000


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; LAST 30 SECONDS

i1 165    30  5000   100   12  .5  1  1     1  .5  .5  1  .01  .2  1  1.5


i3 165    2   10000  100   13  .5  .01  .001  .9  1  1000


i2 165    14  15000  150   11  .5  .1  .9  110   2000

     
i2 180    13  15000  160   11  1   .1  .9  120   2000

; THE END





</CsScore>
</CsoundSynthesizer>
